/* command.c generated by valac 0.56.7, the Vala compiler
 * generated from command.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2023 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _CommandPrivate CommandPrivate;
enum  {
	COMMAND_0_PROPERTY,
	COMMAND_NUM_PROPERTIES
};
static GParamSpec* command_properties[COMMAND_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;

#define TYPE_MEMBER (member_get_type ())
#define MEMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEMBER, Member))
#define MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEMBER, MemberClass))
#define IS_MEMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEMBER))
#define IS_MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEMBER))
#define MEMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEMBER, MemberClass))

typedef struct _Member Member;
typedef struct _MemberClass MemberClass;
typedef struct _MemberPrivate MemberPrivate;

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define TYPE_HAGUICHI_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))
#define IS_HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HAGUICHI_WINDOW))
#define IS_HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HAGUICHI_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
};

struct _Member {
	GObject parent_instance;
	MemberPrivate * priv;
	Status* status;
	gchar* network_id;
	gchar* ipv4;
	gchar* ipv6;
	gchar* nick;
	gchar* client_id;
	gchar* tunnel;
	gchar* name_sort_string;
	gchar* status_sort_string;
	gboolean is_evicted;
};

struct _MemberClass {
	GObjectClass parent_class;
};

static gpointer command_parent_class = NULL;
VALA_EXTERN gchar* command_spawn_wrap;
gchar* command_spawn_wrap = NULL;
VALA_EXTERN gchar* command_sudo;
gchar* command_sudo = NULL;
VALA_EXTERN gchar* command_sudo_start;
gchar* command_sudo_start = NULL;
VALA_EXTERN gchar* command_terminal;
gchar* command_terminal = NULL;
VALA_EXTERN gchar* command_file_manager;
gchar* command_file_manager = NULL;
VALA_EXTERN gchar* command_remote_desktop;
gchar* command_remote_desktop = NULL;
VALA_EXTERN Key* settings_super_user;
VALA_EXTERN gchar* hamachi_ip_version;
VALA_EXTERN Key* settings_custom_commands;
VALA_EXTERN HaguichiWindow* haguichi_window;

VALA_EXTERN GType command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
VALA_EXTERN void command_init (void);
VALA_EXTERN void command_determine_sudo (void);
VALA_EXTERN void command_determine_terminal (void);
VALA_EXTERN void command_determine_file_manager (void);
VALA_EXTERN void command_determine_remote_desktop (void);
VALA_EXTERN void command_execute (const gchar* command);
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
VALA_EXTERN gchar* command_return_output (const gchar* command);
VALA_EXTERN gboolean command_exists (const gchar* command);
VALA_EXTERN gboolean command_custom_exists (const gchar* command_ipv4,
                                const gchar* command_ipv6);
VALA_EXTERN gchar* command_replace_variables (gchar* command,
                                  const gchar* address,
                                  const gchar* nick,
                                  const gchar* id);
VALA_EXTERN GType key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
VALA_EXTERN GVariant* key_get_val (Key* self);
static gchar* _variant_get1 (GVariant* value);
static gchar* command_get_available (gchar** commands,
                              gint commands_length1);
VALA_EXTERN GType member_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Member, g_object_unref)
VALA_EXTERN gchar* command_return_custom (Member* member,
                              const gchar* command_ipv4,
                              const gchar* command_ipv6,
                              const gchar* priority);
VALA_EXTERN GType status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
VALA_EXTERN gchar** command_return_default (gint* result_length1);
static gchar** _variant_get2 (GVariant* value,
                       gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
VALA_EXTERN gchar** command_return_by_number (gint number,
                                  gint* result_length1);
static gchar** _variant_get3 (GVariant* value,
                       gint* result_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
VALA_EXTERN void command_open_uri (const gchar* uri);
VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN Command* command_new (void);
VALA_EXTERN Command* command_construct (GType object_type);
static void command_finalize (GObject * obj);
static GType command_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

void
command_init (void)
{
#line 24 "../src/command.vala"
	command_determine_sudo ();
#line 25 "../src/command.vala"
	command_determine_terminal ();
#line 26 "../src/command.vala"
	command_determine_file_manager ();
#line 27 "../src/command.vala"
	command_determine_remote_desktop ();
#line 218 "command.c"
}

void
command_execute (const gchar* command)
{
	GError* _inner_error0_ = NULL;
#line 30 "../src/command.vala"
	g_return_if_fail (command != NULL);
#line 32 "../src/command.vala"
	if (g_strcmp0 (command, "") == 0) {
#line 34 "../src/command.vala"
		return;
#line 231 "command.c"
	}
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 39 "../src/command.vala"
		_tmp0_ = command_spawn_wrap;
#line 39 "../src/command.vala"
		_tmp1_ = g_strconcat (_tmp0_, command, NULL);
#line 39 "../src/command.vala"
		_tmp2_ = _tmp1_;
#line 39 "../src/command.vala"
		g_spawn_command_line_async (_tmp2_, &_inner_error0_);
#line 39 "../src/command.vala"
		_g_free0 (_tmp2_);
#line 39 "../src/command.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/command.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 251 "command.c"
				goto __catch0_g_spawn_error;
			}
#line 39 "../src/command.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../src/command.vala"
			g_clear_error (&_inner_error0_);
#line 39 "../src/command.vala"
			return;
#line 260 "command.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 37 "../src/command.vala"
		e = _inner_error0_;
#line 37 "../src/command.vala"
		_inner_error0_ = NULL;
#line 43 "../src/command.vala"
		_tmp3_ = e;
#line 43 "../src/command.vala"
		_tmp4_ = _tmp3_->message;
#line 43 "../src/command.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "Command.execute", _tmp4_);
#line 37 "../src/command.vala"
		_g_error_free0 (e);
#line 281 "command.c"
	}
	__finally0:
#line 37 "../src/command.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/command.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/command.vala"
		g_clear_error (&_inner_error0_);
#line 37 "../src/command.vala"
		return;
#line 292 "command.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 312 "command.c"
}

gchar*
command_return_output (const gchar* command)
{
	gchar* output = NULL;
	gchar* _error_ = NULL;
	gint exit_status = 0;
	const gchar* _tmp14_;
	const gchar* _tmp16_;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 47 "../src/command.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 329 "command.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		const gchar* _tmp6_;
#line 55 "../src/command.vala"
		_tmp0_ = command_spawn_wrap;
#line 55 "../src/command.vala"
		_tmp1_ = g_strconcat (_tmp0_, command, NULL);
#line 55 "../src/command.vala"
		_tmp2_ = _tmp1_;
#line 55 "../src/command.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 55 "../src/command.vala"
		_g_free0 (output);
#line 55 "../src/command.vala"
		output = _tmp3_;
#line 55 "../src/command.vala"
		_g_free0 (_error_);
#line 55 "../src/command.vala"
		_error_ = _tmp4_;
#line 55 "../src/command.vala"
		exit_status = _tmp5_;
#line 55 "../src/command.vala"
		_g_free0 (_tmp2_);
#line 55 "../src/command.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/command.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 362 "command.c"
				goto __catch0_g_spawn_error;
			}
#line 55 "../src/command.vala"
			_g_free0 (_error_);
#line 55 "../src/command.vala"
			_g_free0 (output);
#line 55 "../src/command.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../src/command.vala"
			g_clear_error (&_inner_error0_);
#line 55 "../src/command.vala"
			return NULL;
#line 375 "command.c"
		}
#line 57 "../src/command.vala"
		_tmp6_ = _error_;
#line 57 "../src/command.vala"
		if (g_strcmp0 (_tmp6_, "") != 0) {
#line 381 "command.c"
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 59 "../src/command.vala"
			_tmp7_ = _error_;
#line 59 "../src/command.vala"
			_tmp8_ = g_strconcat ("stderr: ", _tmp7_, NULL);
#line 59 "../src/command.vala"
			_tmp9_ = _tmp8_;
#line 59 "../src/command.vala"
			debug_log (DEBUG_DOMAIN_ERROR, "Command.return_output", _tmp9_);
#line 59 "../src/command.vala"
			_g_free0 (_tmp9_);
#line 395 "command.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
#line 53 "../src/command.vala"
		e = _inner_error0_;
#line 53 "../src/command.vala"
		_inner_error0_ = NULL;
#line 64 "../src/command.vala"
		_tmp10_ = e;
#line 64 "../src/command.vala"
		_tmp11_ = _tmp10_->message;
#line 64 "../src/command.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 64 "../src/command.vala"
		_g_free0 (_error_);
#line 64 "../src/command.vala"
		_error_ = _tmp12_;
#line 65 "../src/command.vala"
		_tmp13_ = _error_;
#line 65 "../src/command.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "Command.return_output", _tmp13_);
#line 53 "../src/command.vala"
		_g_error_free0 (e);
#line 426 "command.c"
	}
	__finally0:
#line 53 "../src/command.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/command.vala"
		_g_free0 (_error_);
#line 53 "../src/command.vala"
		_g_free0 (output);
#line 53 "../src/command.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/command.vala"
		g_clear_error (&_inner_error0_);
#line 53 "../src/command.vala"
		return NULL;
#line 441 "command.c"
	}
#line 69 "../src/command.vala"
	_tmp14_ = output;
#line 69 "../src/command.vala"
	if (_tmp14_ == NULL) {
#line 447 "command.c"
		gchar* _tmp15_;
#line 71 "../src/command.vala"
		_tmp15_ = g_strdup ("");
#line 71 "../src/command.vala"
		_g_free0 (output);
#line 71 "../src/command.vala"
		output = _tmp15_;
#line 455 "command.c"
	}
#line 75 "../src/command.vala"
	_tmp16_ = output;
#line 75 "../src/command.vala"
	if (string_contains (_tmp16_, ".. failed, busy")) {
#line 461 "command.c"
		gchar* _tmp17_;
#line 77 "../src/command.vala"
		debug_log (DEBUG_DOMAIN_HAMACHI, "Command.return_output", "Hamachi is busy, waiting to try again...");
#line 78 "../src/command.vala"
		g_usleep ((gulong) 100000);
#line 80 "../src/command.vala"
		_tmp17_ = command_return_output (command);
#line 80 "../src/command.vala"
		_g_free0 (output);
#line 80 "../src/command.vala"
		output = _tmp17_;
#line 473 "command.c"
	}
#line 84 "../src/command.vala"
	_tmp19_ = output;
#line 84 "../src/command.vala"
	if (g_strcmp0 (_tmp19_, "") == 0) {
#line 479 "command.c"
		const gchar* _tmp20_;
#line 84 "../src/command.vala"
		_tmp20_ = _error_;
#line 84 "../src/command.vala"
		_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
#line 485 "command.c"
	} else {
#line 84 "../src/command.vala"
		_tmp18_ = FALSE;
#line 489 "command.c"
	}
#line 84 "../src/command.vala"
	if (_tmp18_) {
#line 86 "../src/command.vala"
		result = _error_;
#line 86 "../src/command.vala"
		_g_free0 (output);
#line 86 "../src/command.vala"
		return result;
#line 499 "command.c"
	} else {
#line 90 "../src/command.vala"
		result = output;
#line 90 "../src/command.vala"
		_g_free0 (_error_);
#line 90 "../src/command.vala"
		return result;
#line 507 "command.c"
	}
}

gboolean
command_exists (const gchar* command)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 96 "../src/command.vala"
	if (command == NULL) {
#line 98 "../src/command.vala"
		result = FALSE;
#line 98 "../src/command.vala"
		return result;
#line 529 "command.c"
	}
#line 101 "../src/command.vala"
	_tmp0_ = g_strconcat ("bash -c \"command -v ", command, NULL);
#line 101 "../src/command.vala"
	_tmp1_ = _tmp0_;
#line 101 "../src/command.vala"
	_tmp2_ = g_strconcat (_tmp1_, " &>/dev/null || echo 'command not found'\"", NULL);
#line 101 "../src/command.vala"
	_tmp3_ = _tmp2_;
#line 101 "../src/command.vala"
	_tmp4_ = command_return_output (_tmp3_);
#line 101 "../src/command.vala"
	_tmp5_ = _tmp4_;
#line 101 "../src/command.vala"
	_g_free0 (_tmp3_);
#line 101 "../src/command.vala"
	_g_free0 (_tmp1_);
#line 101 "../src/command.vala"
	output = _tmp5_;
#line 103 "../src/command.vala"
	_tmp6_ = output;
#line 103 "../src/command.vala"
	if (string_contains (_tmp6_, "command not found")) {
#line 105 "../src/command.vala"
		result = FALSE;
#line 105 "../src/command.vala"
		_g_free0 (output);
#line 105 "../src/command.vala"
		return result;
#line 559 "command.c"
	} else {
#line 109 "../src/command.vala"
		result = TRUE;
#line 109 "../src/command.vala"
		_g_free0 (output);
#line 109 "../src/command.vala"
		return result;
#line 567 "command.c"
	}
}

gboolean
command_custom_exists (const gchar* command_ipv4,
                       const gchar* command_ipv6)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 113 "../src/command.vala"
	g_return_val_if_fail (command_ipv4 != NULL, FALSE);
#line 113 "../src/command.vala"
	g_return_val_if_fail (command_ipv6 != NULL, FALSE);
#line 115 "../src/command.vala"
	_tmp1_ = g_strdup (command_ipv4);
#line 115 "../src/command.vala"
	_tmp2_ = command_replace_variables (_tmp1_, "", "", "");
#line 115 "../src/command.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/command.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, " ", 0);
#line 115 "../src/command.vala"
	_tmp6_ = _tmp5_;
#line 115 "../src/command.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 115 "../src/command.vala"
	_tmp7_ = _tmp6_[0];
#line 115 "../src/command.vala"
	_tmp8_ = command_exists (_tmp7_);
#line 115 "../src/command.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 115 "../src/command.vala"
	_g_free0 (_tmp3_);
#line 115 "../src/command.vala"
	if (_tmp8_) {
#line 115 "../src/command.vala"
		_tmp0_ = TRUE;
#line 614 "command.c"
	} else {
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
#line 116 "../src/command.vala"
		_tmp9_ = g_strdup (command_ipv6);
#line 116 "../src/command.vala"
		_tmp10_ = command_replace_variables (_tmp9_, "", "", "");
#line 116 "../src/command.vala"
		_tmp11_ = _tmp10_;
#line 116 "../src/command.vala"
		_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, " ", 0);
#line 116 "../src/command.vala"
		_tmp14_ = _tmp13_;
#line 116 "../src/command.vala"
		_tmp14__length1 = _vala_array_length (_tmp12_);
#line 116 "../src/command.vala"
		_tmp15_ = _tmp14_[0];
#line 116 "../src/command.vala"
		_tmp0_ = command_exists (_tmp15_);
#line 116 "../src/command.vala"
		_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 116 "../src/command.vala"
		_g_free0 (_tmp11_);
#line 644 "command.c"
	}
#line 115 "../src/command.vala"
	if (_tmp0_) {
#line 118 "../src/command.vala"
		result = TRUE;
#line 118 "../src/command.vala"
		return result;
#line 652 "command.c"
	} else {
#line 122 "../src/command.vala"
		result = FALSE;
#line 122 "../src/command.vala"
		return result;
#line 658 "command.c"
	}
}

static gchar*
_variant_get1 (GVariant* value)
{
#line 128 "../src/command.vala"
	return g_variant_dup_string (value, NULL);
#line 667 "command.c"
}

void
command_determine_sudo (void)
{
	Key* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp11_;
	const gchar* _tmp13_;
#line 128 "../src/command.vala"
	_tmp0_ = settings_super_user;
#line 128 "../src/command.vala"
	_tmp1_ = key_get_val (_tmp0_);
#line 128 "../src/command.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/command.vala"
	_tmp3_ = _variant_get1 (_tmp2_);
#line 128 "../src/command.vala"
	_g_free0 (command_sudo);
#line 128 "../src/command.vala"
	command_sudo = _tmp3_;
#line 129 "../src/command.vala"
	_tmp4_ = g_strdup ("-- ");
#line 129 "../src/command.vala"
	_g_free0 (command_sudo_start);
#line 129 "../src/command.vala"
	command_sudo_start = _tmp4_;
#line 131 "../src/command.vala"
	_tmp5_ = command_sudo;
#line 131 "../src/command.vala"
	if (g_strcmp0 (_tmp5_, "auto") == 0) {
#line 703 "command.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar* _tmp10_;
#line 133 "../src/command.vala"
		_tmp6_ = g_strdup ("pkexec");
#line 133 "../src/command.vala"
		_tmp7_ = g_strdup ("sudo");
#line 133 "../src/command.vala"
		_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 133 "../src/command.vala"
		_tmp8_[0] = _tmp6_;
#line 133 "../src/command.vala"
		_tmp8_[1] = _tmp7_;
#line 133 "../src/command.vala"
		_tmp9_ = _tmp8_;
#line 133 "../src/command.vala"
		_tmp9__length1 = 2;
#line 133 "../src/command.vala"
		_tmp10_ = command_get_available (_tmp9_, (gint) 2);
#line 133 "../src/command.vala"
		_g_free0 (command_sudo);
#line 133 "../src/command.vala"
		command_sudo = _tmp10_;
#line 133 "../src/command.vala"
		_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 732 "command.c"
	}
#line 139 "../src/command.vala"
	_tmp11_ = command_sudo;
#line 139 "../src/command.vala"
	if (g_strcmp0 (_tmp11_, "pkexec") == 0) {
#line 738 "command.c"
		gchar* _tmp12_;
#line 141 "../src/command.vala"
		_tmp12_ = g_strdup ("");
#line 141 "../src/command.vala"
		_g_free0 (command_sudo_start);
#line 141 "../src/command.vala"
		command_sudo_start = _tmp12_;
#line 746 "command.c"
	}
#line 144 "../src/command.vala"
	_tmp13_ = command_sudo;
#line 144 "../src/command.vala"
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_sudo", _tmp13_);
#line 752 "command.c"
}

static gchar*
command_get_available (gchar** commands,
                       gint commands_length1)
{
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	{
		gchar** cmd_collection = NULL;
		gint cmd_collection_length1 = 0;
		gint _cmd_collection_size_ = 0;
		gint cmd_it = 0;
#line 150 "../src/command.vala"
		cmd_collection = commands;
#line 150 "../src/command.vala"
		cmd_collection_length1 = commands_length1;
#line 150 "../src/command.vala"
		for (cmd_it = 0; cmd_it < cmd_collection_length1; cmd_it = cmd_it + 1) {
#line 773 "command.c"
			gchar* _tmp0_;
			gchar* cmd = NULL;
#line 150 "../src/command.vala"
			_tmp0_ = g_strdup (cmd_collection[cmd_it]);
#line 150 "../src/command.vala"
			cmd = _tmp0_;
#line 780 "command.c"
			{
				const gchar* _tmp1_;
#line 152 "../src/command.vala"
				_tmp1_ = cmd;
#line 152 "../src/command.vala"
				if (command_exists (_tmp1_)) {
#line 154 "../src/command.vala"
					result = cmd;
#line 154 "../src/command.vala"
					return result;
#line 791 "command.c"
				}
#line 150 "../src/command.vala"
				_g_free0 (cmd);
#line 795 "command.c"
			}
		}
	}
#line 159 "../src/command.vala"
	_tmp2_ = commands[0];
#line 159 "../src/command.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 159 "../src/command.vala"
	result = _tmp3_;
#line 159 "../src/command.vala"
	return result;
#line 807 "command.c"
}

void
command_determine_terminal (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	const gchar* _tmp15_;
#line 164 "../src/command.vala"
	_tmp0_ = g_strdup ("gnome-terminal");
#line 164 "../src/command.vala"
	_tmp1_ = g_strdup ("mate-terminal");
#line 164 "../src/command.vala"
	_tmp2_ = g_strdup ("io.elementary.terminal");
#line 164 "../src/command.vala"
	_tmp3_ = g_strdup ("kgx");
#line 164 "../src/command.vala"
	_tmp4_ = g_strdup ("tilix");
#line 164 "../src/command.vala"
	_tmp5_ = g_strdup ("xfce4-terminal");
#line 164 "../src/command.vala"
	_tmp6_ = g_strdup ("konsole");
#line 164 "../src/command.vala"
	_tmp7_ = g_strdup ("deepin-terminal");
#line 164 "../src/command.vala"
	_tmp8_ = g_strdup ("qterminal");
#line 164 "../src/command.vala"
	_tmp9_ = g_strdup ("lxterminal");
#line 164 "../src/command.vala"
	_tmp10_ = g_strdup ("uxterm");
#line 164 "../src/command.vala"
	_tmp11_ = g_strdup ("xterm");
#line 164 "../src/command.vala"
	_tmp12_ = g_new0 (gchar*, 12 + 1);
#line 164 "../src/command.vala"
	_tmp12_[0] = _tmp0_;
#line 164 "../src/command.vala"
	_tmp12_[1] = _tmp1_;
#line 164 "../src/command.vala"
	_tmp12_[2] = _tmp2_;
#line 164 "../src/command.vala"
	_tmp12_[3] = _tmp3_;
#line 164 "../src/command.vala"
	_tmp12_[4] = _tmp4_;
#line 164 "../src/command.vala"
	_tmp12_[5] = _tmp5_;
#line 164 "../src/command.vala"
	_tmp12_[6] = _tmp6_;
#line 164 "../src/command.vala"
	_tmp12_[7] = _tmp7_;
#line 164 "../src/command.vala"
	_tmp12_[8] = _tmp8_;
#line 164 "../src/command.vala"
	_tmp12_[9] = _tmp9_;
#line 164 "../src/command.vala"
	_tmp12_[10] = _tmp10_;
#line 164 "../src/command.vala"
	_tmp12_[11] = _tmp11_;
#line 164 "../src/command.vala"
	_tmp13_ = _tmp12_;
#line 164 "../src/command.vala"
	_tmp13__length1 = 12;
#line 164 "../src/command.vala"
	_tmp14_ = command_get_available (_tmp13_, (gint) 12);
#line 164 "../src/command.vala"
	_g_free0 (command_terminal);
#line 164 "../src/command.vala"
	command_terminal = _tmp14_;
#line 164 "../src/command.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 179 "../src/command.vala"
	_tmp15_ = command_terminal;
#line 179 "../src/command.vala"
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_terminal", _tmp15_);
#line 896 "command.c"
}

void
command_determine_file_manager (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	const gchar* _tmp12_;
#line 184 "../src/command.vala"
	_tmp0_ = g_strdup ("nautilus");
#line 184 "../src/command.vala"
	_tmp1_ = g_strdup ("caja");
#line 184 "../src/command.vala"
	_tmp2_ = g_strdup ("nemo");
#line 184 "../src/command.vala"
	_tmp3_ = g_strdup ("io.elementary.files");
#line 184 "../src/command.vala"
	_tmp4_ = g_strdup ("thunar");
#line 184 "../src/command.vala"
	_tmp5_ = g_strdup ("dolphin");
#line 184 "../src/command.vala"
	_tmp6_ = g_strdup ("dde-file-manager");
#line 184 "../src/command.vala"
	_tmp7_ = g_strdup ("pcmanfm-qt");
#line 184 "../src/command.vala"
	_tmp8_ = g_strdup ("pcmanfm");
#line 184 "../src/command.vala"
	_tmp9_ = g_new0 (gchar*, 9 + 1);
#line 184 "../src/command.vala"
	_tmp9_[0] = _tmp0_;
#line 184 "../src/command.vala"
	_tmp9_[1] = _tmp1_;
#line 184 "../src/command.vala"
	_tmp9_[2] = _tmp2_;
#line 184 "../src/command.vala"
	_tmp9_[3] = _tmp3_;
#line 184 "../src/command.vala"
	_tmp9_[4] = _tmp4_;
#line 184 "../src/command.vala"
	_tmp9_[5] = _tmp5_;
#line 184 "../src/command.vala"
	_tmp9_[6] = _tmp6_;
#line 184 "../src/command.vala"
	_tmp9_[7] = _tmp7_;
#line 184 "../src/command.vala"
	_tmp9_[8] = _tmp8_;
#line 184 "../src/command.vala"
	_tmp10_ = _tmp9_;
#line 184 "../src/command.vala"
	_tmp10__length1 = 9;
#line 184 "../src/command.vala"
	_tmp11_ = command_get_available (_tmp10_, (gint) 9);
#line 184 "../src/command.vala"
	_g_free0 (command_file_manager);
#line 184 "../src/command.vala"
	command_file_manager = _tmp11_;
#line 184 "../src/command.vala"
	_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 196 "../src/command.vala"
	_tmp12_ = command_file_manager;
#line 196 "../src/command.vala"
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_file_manager", _tmp12_);
#line 970 "command.c"
}

void
command_determine_remote_desktop (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 201 "../src/command.vala"
	_tmp0_ = g_strdup ("vinagre");
#line 201 "../src/command.vala"
	_tmp1_ = g_strdup ("gvncviewer");
#line 201 "../src/command.vala"
	_tmp2_ = g_strdup ("krdc");
#line 201 "../src/command.vala"
	_tmp3_ = g_strdup ("vncviewer");
#line 201 "../src/command.vala"
	_tmp4_ = g_strdup ("xtightvncviewer");
#line 201 "../src/command.vala"
	_tmp5_ = g_strdup ("xvnc4viewer");
#line 201 "../src/command.vala"
	_tmp6_ = g_strdup ("rdesktop");
#line 201 "../src/command.vala"
	_tmp7_ = g_new0 (gchar*, 7 + 1);
#line 201 "../src/command.vala"
	_tmp7_[0] = _tmp0_;
#line 201 "../src/command.vala"
	_tmp7_[1] = _tmp1_;
#line 201 "../src/command.vala"
	_tmp7_[2] = _tmp2_;
#line 201 "../src/command.vala"
	_tmp7_[3] = _tmp3_;
#line 201 "../src/command.vala"
	_tmp7_[4] = _tmp4_;
#line 201 "../src/command.vala"
	_tmp7_[5] = _tmp5_;
#line 201 "../src/command.vala"
	_tmp7_[6] = _tmp6_;
#line 201 "../src/command.vala"
	_tmp8_ = _tmp7_;
#line 201 "../src/command.vala"
	_tmp8__length1 = 7;
#line 201 "../src/command.vala"
	_tmp9_ = command_get_available (_tmp8_, (gint) 7);
#line 201 "../src/command.vala"
	_g_free0 (command_remote_desktop);
#line 201 "../src/command.vala"
	command_remote_desktop = _tmp9_;
#line 201 "../src/command.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 211 "../src/command.vala"
	_tmp10_ = command_remote_desktop;
#line 211 "../src/command.vala"
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_remote_desktop", _tmp10_);
#line 1034 "command.c"
}

gchar*
command_return_custom (Member* member,
                       const gchar* command_ipv4,
                       const gchar* command_ipv6,
                       const gchar* priority)
{
	gchar* command = NULL;
	gchar* _tmp0_;
	gchar* address = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* result;
#line 214 "../src/command.vala"
	g_return_val_if_fail (command_ipv4 != NULL, NULL);
#line 214 "../src/command.vala"
	g_return_val_if_fail (command_ipv6 != NULL, NULL);
#line 214 "../src/command.vala"
	g_return_val_if_fail (priority != NULL, NULL);
#line 216 "../src/command.vala"
	_tmp0_ = g_strdup ("");
#line 216 "../src/command.vala"
	command = _tmp0_;
#line 217 "../src/command.vala"
	_tmp1_ = g_strdup ("");
#line 217 "../src/command.vala"
	address = _tmp1_;
#line 219 "../src/command.vala"
	_tmp2_ = hamachi_ip_version;
#line 219 "../src/command.vala"
	if (g_strcmp0 (_tmp2_, "Both") == 0) {
#line 221 "../src/command.vala"
		if (g_strcmp0 (priority, "IPv4") == 0) {
#line 1075 "command.c"
			const gchar* _tmp3_;
#line 223 "../src/command.vala"
			_tmp3_ = member->ipv4;
#line 223 "../src/command.vala"
			if (_tmp3_ != NULL) {
#line 1081 "command.c"
				gchar* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 225 "../src/command.vala"
				_tmp4_ = g_strdup (command_ipv4);
#line 225 "../src/command.vala"
				_g_free0 (command);
#line 225 "../src/command.vala"
				command = _tmp4_;
#line 226 "../src/command.vala"
				_tmp5_ = member->ipv4;
#line 226 "../src/command.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 226 "../src/command.vala"
				_g_free0 (address);
#line 226 "../src/command.vala"
				address = _tmp6_;
#line 1099 "command.c"
			} else {
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 230 "../src/command.vala"
				_tmp7_ = g_strdup (command_ipv6);
#line 230 "../src/command.vala"
				_g_free0 (command);
#line 230 "../src/command.vala"
				command = _tmp7_;
#line 231 "../src/command.vala"
				_tmp8_ = member->ipv6;
#line 231 "../src/command.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 231 "../src/command.vala"
				_g_free0 (address);
#line 231 "../src/command.vala"
				address = _tmp9_;
#line 1118 "command.c"
			}
		}
#line 234 "../src/command.vala"
		if (g_strcmp0 (priority, "IPv6") == 0) {
#line 1123 "command.c"
			const gchar* _tmp10_;
#line 236 "../src/command.vala"
			_tmp10_ = member->ipv6;
#line 236 "../src/command.vala"
			if (_tmp10_ != NULL) {
#line 1129 "command.c"
				gchar* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 238 "../src/command.vala"
				_tmp11_ = g_strdup (command_ipv6);
#line 238 "../src/command.vala"
				_g_free0 (command);
#line 238 "../src/command.vala"
				command = _tmp11_;
#line 239 "../src/command.vala"
				_tmp12_ = member->ipv6;
#line 239 "../src/command.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 239 "../src/command.vala"
				_g_free0 (address);
#line 239 "../src/command.vala"
				address = _tmp13_;
#line 1147 "command.c"
			} else {
				gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 243 "../src/command.vala"
				_tmp14_ = g_strdup (command_ipv4);
#line 243 "../src/command.vala"
				_g_free0 (command);
#line 243 "../src/command.vala"
				command = _tmp14_;
#line 244 "../src/command.vala"
				_tmp15_ = member->ipv4;
#line 244 "../src/command.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 244 "../src/command.vala"
				_g_free0 (address);
#line 244 "../src/command.vala"
				address = _tmp16_;
#line 1166 "command.c"
			}
		}
	} else {
		const gchar* _tmp17_;
#line 248 "../src/command.vala"
		_tmp17_ = hamachi_ip_version;
#line 248 "../src/command.vala"
		if (g_strcmp0 (_tmp17_, "IPv4") == 0) {
#line 1175 "command.c"
			gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 250 "../src/command.vala"
			_tmp18_ = g_strdup (command_ipv4);
#line 250 "../src/command.vala"
			_g_free0 (command);
#line 250 "../src/command.vala"
			command = _tmp18_;
#line 251 "../src/command.vala"
			_tmp19_ = member->ipv4;
#line 251 "../src/command.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 251 "../src/command.vala"
			_g_free0 (address);
#line 251 "../src/command.vala"
			address = _tmp20_;
#line 1193 "command.c"
		} else {
			const gchar* _tmp21_;
#line 253 "../src/command.vala"
			_tmp21_ = hamachi_ip_version;
#line 253 "../src/command.vala"
			if (g_strcmp0 (_tmp21_, "IPv6") == 0) {
#line 1200 "command.c"
				gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 255 "../src/command.vala"
				_tmp22_ = g_strdup (command_ipv6);
#line 255 "../src/command.vala"
				_g_free0 (command);
#line 255 "../src/command.vala"
				command = _tmp22_;
#line 256 "../src/command.vala"
				_tmp23_ = member->ipv6;
#line 256 "../src/command.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 256 "../src/command.vala"
				_g_free0 (address);
#line 256 "../src/command.vala"
				address = _tmp24_;
#line 1218 "command.c"
			}
		}
	}
#line 259 "../src/command.vala"
	_tmp25_ = command;
#line 259 "../src/command.vala"
	_tmp26_ = g_strdup (_tmp25_);
#line 259 "../src/command.vala"
	_tmp27_ = address;
#line 259 "../src/command.vala"
	_tmp28_ = member->nick;
#line 259 "../src/command.vala"
	_tmp29_ = member->client_id;
#line 259 "../src/command.vala"
	_tmp30_ = command_replace_variables (_tmp26_, _tmp27_, _tmp28_, _tmp29_);
#line 259 "../src/command.vala"
	result = _tmp30_;
#line 259 "../src/command.vala"
	_g_free0 (address);
#line 259 "../src/command.vala"
	_g_free0 (command);
#line 259 "../src/command.vala"
	return result;
#line 1242 "command.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1264 "command.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1268 "command.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1274 "command.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1278 "command.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1282 "command.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1290 "command.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1318 "command.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1327 "command.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1341 "command.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1350 "command.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1364 "command.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1373 "command.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1382 "command.c"
}

gchar*
command_replace_variables (gchar* command,
                           const gchar* address,
                           const gchar* nick,
                           const gchar* id)
{
	gchar* _tmp38_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 262 "../src/command.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 262 "../src/command.vala"
	g_return_val_if_fail (address != NULL, NULL);
#line 262 "../src/command.vala"
	g_return_val_if_fail (nick != NULL, NULL);
#line 262 "../src/command.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1402 "command.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		gchar* execute = NULL;
		gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_;
		gchar* quote = NULL;
		gchar* _tmp8_;
		GRegex* _tmp9_ = NULL;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 266 "../src/command.vala"
		_tmp0_ = string_replace (command, "%A", address);
#line 266 "../src/command.vala"
		_g_free0 (command);
#line 266 "../src/command.vala"
		command = _tmp0_;
#line 267 "../src/command.vala"
		_tmp1_ = string_replace (command, "%N", nick);
#line 267 "../src/command.vala"
		_g_free0 (command);
#line 267 "../src/command.vala"
		command = _tmp1_;
#line 268 "../src/command.vala"
		_tmp2_ = string_replace (command, "%ID", id);
#line 268 "../src/command.vala"
		_g_free0 (command);
#line 268 "../src/command.vala"
		command = _tmp2_;
#line 270 "../src/command.vala"
		_tmp4_ = command_terminal;
#line 270 "../src/command.vala"
		if (g_strcmp0 (_tmp4_, "gnome-terminal") == 0) {
#line 270 "../src/command.vala"
			_tmp3_ = "--";
#line 1466 "command.c"
		} else {
#line 270 "../src/command.vala"
			_tmp3_ = "-e";
#line 1470 "command.c"
		}
#line 270 "../src/command.vala"
		_tmp5_ = g_strdup (_tmp3_);
#line 270 "../src/command.vala"
		execute = _tmp5_;
#line 271 "../src/command.vala"
		_tmp7_ = command_terminal;
#line 271 "../src/command.vala"
		if (g_strcmp0 (_tmp7_, "gnome-terminal") == 0) {
#line 271 "../src/command.vala"
			_tmp6_ = "";
#line 1482 "command.c"
		} else {
#line 271 "../src/command.vala"
			_tmp6_ = "\"";
#line 1486 "command.c"
		}
#line 271 "../src/command.vala"
		_tmp8_ = g_strdup (_tmp6_);
#line 271 "../src/command.vala"
		quote = _tmp8_;
#line 273 "../src/command.vala"
		_tmp10_ = g_regex_new ("%TERMINAL (.*)", 0, 0, &_inner_error0_);
#line 273 "../src/command.vala"
		_tmp9_ = _tmp10_;
#line 273 "../src/command.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/command.vala"
			_g_free0 (quote);
#line 273 "../src/command.vala"
			_g_free0 (execute);
#line 273 "../src/command.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1504 "command.c"
				goto __catch0_g_regex_error;
			}
#line 273 "../src/command.vala"
			_g_free0 (command);
#line 273 "../src/command.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/command.vala"
			g_clear_error (&_inner_error0_);
#line 273 "../src/command.vala"
			return NULL;
#line 1515 "command.c"
		}
#line 273 "../src/command.vala"
		_tmp12_ = command_terminal;
#line 273 "../src/command.vala"
		_tmp13_ = g_strconcat (_tmp12_, " ", NULL);
#line 273 "../src/command.vala"
		_tmp14_ = _tmp13_;
#line 273 "../src/command.vala"
		_tmp15_ = execute;
#line 273 "../src/command.vala"
		_tmp16_ = g_strconcat (_tmp14_, _tmp15_, NULL);
#line 273 "../src/command.vala"
		_tmp17_ = _tmp16_;
#line 273 "../src/command.vala"
		_tmp18_ = g_strconcat (_tmp17_, " ", NULL);
#line 273 "../src/command.vala"
		_tmp19_ = _tmp18_;
#line 273 "../src/command.vala"
		_tmp20_ = quote;
#line 273 "../src/command.vala"
		_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
#line 273 "../src/command.vala"
		_tmp22_ = _tmp21_;
#line 273 "../src/command.vala"
		_tmp23_ = g_strconcat (_tmp22_, "\\1", NULL);
#line 273 "../src/command.vala"
		_tmp24_ = _tmp23_;
#line 273 "../src/command.vala"
		_tmp25_ = quote;
#line 273 "../src/command.vala"
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 273 "../src/command.vala"
		_tmp27_ = _tmp26_;
#line 273 "../src/command.vala"
		_tmp28_ = g_regex_replace (_tmp9_, command, (gssize) -1, 0, _tmp27_, 0, &_inner_error0_);
#line 273 "../src/command.vala"
		_tmp29_ = _tmp28_;
#line 273 "../src/command.vala"
		_g_free0 (_tmp27_);
#line 273 "../src/command.vala"
		_g_free0 (_tmp24_);
#line 273 "../src/command.vala"
		_g_free0 (_tmp22_);
#line 273 "../src/command.vala"
		_g_free0 (_tmp19_);
#line 273 "../src/command.vala"
		_g_free0 (_tmp17_);
#line 273 "../src/command.vala"
		_g_free0 (_tmp14_);
#line 273 "../src/command.vala"
		_tmp11_ = _tmp29_;
#line 273 "../src/command.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/command.vala"
			_g_regex_unref0 (_tmp9_);
#line 273 "../src/command.vala"
			_g_free0 (quote);
#line 273 "../src/command.vala"
			_g_free0 (execute);
#line 273 "../src/command.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1577 "command.c"
				goto __catch0_g_regex_error;
			}
#line 273 "../src/command.vala"
			_g_free0 (command);
#line 273 "../src/command.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/command.vala"
			g_clear_error (&_inner_error0_);
#line 273 "../src/command.vala"
			return NULL;
#line 1588 "command.c"
		}
#line 273 "../src/command.vala"
		_tmp30_ = _tmp11_;
#line 273 "../src/command.vala"
		_tmp11_ = NULL;
#line 273 "../src/command.vala"
		_g_free0 (command);
#line 273 "../src/command.vala"
		command = _tmp30_;
#line 274 "../src/command.vala"
		_tmp31_ = command_file_manager;
#line 274 "../src/command.vala"
		_tmp32_ = string_replace (command, "%FILEMANAGER", _tmp31_);
#line 274 "../src/command.vala"
		_g_free0 (command);
#line 274 "../src/command.vala"
		command = _tmp32_;
#line 275 "../src/command.vala"
		_tmp33_ = command_remote_desktop;
#line 275 "../src/command.vala"
		_tmp34_ = string_replace (command, "%REMOTEDESKTOP", _tmp33_);
#line 275 "../src/command.vala"
		_g_free0 (command);
#line 275 "../src/command.vala"
		command = _tmp34_;
#line 276 "../src/command.vala"
		_tmp35_ = string_replace (command, "{COLON}", ";");
#line 276 "../src/command.vala"
		_g_free0 (command);
#line 276 "../src/command.vala"
		command = _tmp35_;
#line 264 "../src/command.vala"
		_g_free0 (_tmp11_);
#line 264 "../src/command.vala"
		_g_regex_unref0 (_tmp9_);
#line 264 "../src/command.vala"
		_g_free0 (quote);
#line 264 "../src/command.vala"
		_g_free0 (execute);
#line 1628 "command.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 264 "../src/command.vala"
		e = _inner_error0_;
#line 264 "../src/command.vala"
		_inner_error0_ = NULL;
#line 280 "../src/command.vala"
		_tmp36_ = e;
#line 280 "../src/command.vala"
		_tmp37_ = _tmp36_->message;
#line 280 "../src/command.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "Command.replace_variables", _tmp37_);
#line 264 "../src/command.vala"
		_g_error_free0 (e);
#line 1648 "command.c"
	}
	__finally0:
#line 264 "../src/command.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "../src/command.vala"
		_g_free0 (command);
#line 264 "../src/command.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../src/command.vala"
		g_clear_error (&_inner_error0_);
#line 264 "../src/command.vala"
		return NULL;
#line 1661 "command.c"
	}
#line 283 "../src/command.vala"
	_tmp38_ = g_strdup (command);
#line 283 "../src/command.vala"
	result = _tmp38_;
#line 283 "../src/command.vala"
	_g_free0 (command);
#line 283 "../src/command.vala"
	return result;
#line 1671 "command.c"
}

static gchar**
_variant_get2 (GVariant* value,
               gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (gchar*, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 289 "../src/command.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 289 "../src/command.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 289 "../src/command.vala"
		if (_tmp0__size == _tmp0__length) {
#line 289 "../src/command.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 289 "../src/command.vala"
			_tmp0_ = g_renew (gchar*, _tmp0_, _tmp0__size + 1);
#line 1698 "command.c"
		}
#line 289 "../src/command.vala"
		_tmp0_[_tmp0__length++] = g_variant_dup_string (_tmp2_, NULL);
#line 289 "../src/command.vala"
		g_variant_unref (_tmp2_);
#line 1704 "command.c"
	}
#line 289 "../src/command.vala"
	*result_length1 = _tmp0__length1;
#line 289 "../src/command.vala"
	_tmp0_[_tmp0__length] = NULL;
#line 289 "../src/command.vala"
	return _tmp0_;
#line 1712 "command.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 299 "../src/command.vala"
	if (length >= 0) {
#line 1721 "command.c"
		gchar** result;
		gssize i;
#line 299 "../src/command.vala"
		result = g_new0 (gchar*, length + 1);
#line 299 "../src/command.vala"
		for (i = 0; i < length; i++) {
#line 1728 "command.c"
			gchar* _tmp0_;
#line 299 "../src/command.vala"
			_tmp0_ = g_strdup (self[i]);
#line 299 "../src/command.vala"
			result[i] = _tmp0_;
#line 1734 "command.c"
		}
#line 299 "../src/command.vala"
		return result;
#line 1738 "command.c"
	}
#line 299 "../src/command.vala"
	return NULL;
#line 1742 "command.c"
}

gchar**
command_return_default (gint* result_length1)
{
	gchar** command = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint command_length1;
	gint _command_size_;
	gchar** commands = NULL;
	Key* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint commands_length1;
	gint _commands_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar** result;
#line 288 "../src/command.vala"
	_tmp0_ = g_strdup ("");
#line 288 "../src/command.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 288 "../src/command.vala"
	_tmp1_[0] = _tmp0_;
#line 288 "../src/command.vala"
	command = _tmp1_;
#line 288 "../src/command.vala"
	command_length1 = 1;
#line 288 "../src/command.vala"
	_command_size_ = command_length1;
#line 289 "../src/command.vala"
	_tmp2_ = settings_custom_commands;
#line 289 "../src/command.vala"
	_tmp3_ = key_get_val (_tmp2_);
#line 289 "../src/command.vala"
	_tmp4_ = _tmp3_;
#line 289 "../src/command.vala"
	_tmp5_ = _variant_get2 (_tmp4_, &_tmp5__length1);
#line 289 "../src/command.vala"
	commands = _tmp5_;
#line 289 "../src/command.vala"
	commands_length1 = _tmp5__length1;
#line 289 "../src/command.vala"
	_commands_size_ = commands_length1;
#line 291 "../src/command.vala"
	_tmp6_ = commands;
#line 291 "../src/command.vala"
	_tmp6__length1 = commands_length1;
#line 1796 "command.c"
	{
		gchar** _string_collection = NULL;
		gint _string_collection_length1 = 0;
		gint __string_collection_size_ = 0;
		gint _string_it = 0;
#line 291 "../src/command.vala"
		_string_collection = _tmp6_;
#line 291 "../src/command.vala"
		_string_collection_length1 = _tmp6__length1;
#line 291 "../src/command.vala"
		for (_string_it = 0; _string_it < _string_collection_length1; _string_it = _string_it + 1) {
#line 1808 "command.c"
			gchar* _tmp7_;
			gchar* _string = NULL;
#line 291 "../src/command.vala"
			_tmp7_ = g_strdup (_string_collection[_string_it]);
#line 291 "../src/command.vala"
			_string = _tmp7_;
#line 1815 "command.c"
			{
				gchar** _array = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _array_length1;
				gint __array_size_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_;
				gint _tmp13__length1;
#line 293 "../src/command.vala"
				_tmp8_ = _string;
#line 293 "../src/command.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ";", 6);
#line 293 "../src/command.vala"
				_array = _tmp10_;
#line 293 "../src/command.vala"
				_array_length1 = _vala_array_length (_tmp9_);
#line 293 "../src/command.vala"
				__array_size_ = _array_length1;
#line 295 "../src/command.vala"
				_tmp13_ = _array;
#line 295 "../src/command.vala"
				_tmp13__length1 = _array_length1;
#line 295 "../src/command.vala"
				if (_tmp13__length1 == 6) {
#line 1843 "command.c"
					gchar** _tmp14_;
					gint _tmp14__length1;
					const gchar* _tmp15_;
#line 296 "../src/command.vala"
					_tmp14_ = _array;
#line 296 "../src/command.vala"
					_tmp14__length1 = _array_length1;
#line 296 "../src/command.vala"
					_tmp15_ = _tmp14_[1];
#line 296 "../src/command.vala"
					_tmp12_ = g_strcmp0 (_tmp15_, "true") == 0;
#line 1855 "command.c"
				} else {
#line 295 "../src/command.vala"
					_tmp12_ = FALSE;
#line 1859 "command.c"
				}
#line 295 "../src/command.vala"
				if (_tmp12_) {
#line 1863 "command.c"
					gchar** _tmp16_;
					gint _tmp16__length1;
					const gchar* _tmp17_;
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
#line 297 "../src/command.vala"
					_tmp16_ = _array;
#line 297 "../src/command.vala"
					_tmp16__length1 = _array_length1;
#line 297 "../src/command.vala"
					_tmp17_ = _tmp16_[3];
#line 297 "../src/command.vala"
					_tmp18_ = _array;
#line 297 "../src/command.vala"
					_tmp18__length1 = _array_length1;
#line 297 "../src/command.vala"
					_tmp19_ = _tmp18_[4];
#line 297 "../src/command.vala"
					_tmp11_ = command_custom_exists (_tmp17_, _tmp19_);
#line 1884 "command.c"
				} else {
#line 295 "../src/command.vala"
					_tmp11_ = FALSE;
#line 1888 "command.c"
				}
#line 295 "../src/command.vala"
				if (_tmp11_) {
#line 1892 "command.c"
					gchar** _tmp20_;
					gint _tmp20__length1;
					gchar** _tmp21_;
					gint _tmp21__length1;
#line 299 "../src/command.vala"
					_tmp20_ = _array;
#line 299 "../src/command.vala"
					_tmp20__length1 = _array_length1;
#line 299 "../src/command.vala"
					_tmp21_ = (_tmp20_ != NULL) ? _vala_array_dup1 (_tmp20_, _tmp20__length1) : _tmp20_;
#line 299 "../src/command.vala"
					_tmp21__length1 = _tmp20__length1;
#line 299 "../src/command.vala"
					command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
#line 299 "../src/command.vala"
					command = _tmp21_;
#line 299 "../src/command.vala"
					command_length1 = _tmp21__length1;
#line 299 "../src/command.vala"
					_command_size_ = command_length1;
#line 1913 "command.c"
				}
#line 291 "../src/command.vala"
				_array = (_vala_array_free (_array, _array_length1, (GDestroyNotify) g_free), NULL);
#line 291 "../src/command.vala"
				_g_free0 (_string);
#line 1919 "command.c"
			}
		}
	}
#line 303 "../src/command.vala"
	_tmp22_ = command;
#line 303 "../src/command.vala"
	_tmp22__length1 = command_length1;
#line 303 "../src/command.vala"
	if (result_length1) {
#line 303 "../src/command.vala"
		*result_length1 = _tmp22__length1;
#line 1931 "command.c"
	}
#line 303 "../src/command.vala"
	result = _tmp22_;
#line 303 "../src/command.vala"
	commands = (_vala_array_free (commands, commands_length1, (GDestroyNotify) g_free), NULL);
#line 303 "../src/command.vala"
	return result;
#line 1939 "command.c"
}

static gchar**
_variant_get3 (GVariant* value,
               gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (gchar*, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 309 "../src/command.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 309 "../src/command.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 309 "../src/command.vala"
		if (_tmp0__size == _tmp0__length) {
#line 309 "../src/command.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 309 "../src/command.vala"
			_tmp0_ = g_renew (gchar*, _tmp0_, _tmp0__size + 1);
#line 1966 "command.c"
		}
#line 309 "../src/command.vala"
		_tmp0_[_tmp0__length++] = g_variant_dup_string (_tmp2_, NULL);
#line 309 "../src/command.vala"
		g_variant_unref (_tmp2_);
#line 1972 "command.c"
	}
#line 309 "../src/command.vala"
	*result_length1 = _tmp0__length1;
#line 309 "../src/command.vala"
	_tmp0_[_tmp0__length] = NULL;
#line 309 "../src/command.vala"
	return _tmp0_;
#line 1980 "command.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 325 "../src/command.vala"
	if (length >= 0) {
#line 1989 "command.c"
		gchar** result;
		gssize i;
#line 325 "../src/command.vala"
		result = g_new0 (gchar*, length + 1);
#line 325 "../src/command.vala"
		for (i = 0; i < length; i++) {
#line 1996 "command.c"
			gchar* _tmp0_;
#line 325 "../src/command.vala"
			_tmp0_ = g_strdup (self[i]);
#line 325 "../src/command.vala"
			result[i] = _tmp0_;
#line 2002 "command.c"
		}
#line 325 "../src/command.vala"
		return result;
#line 2006 "command.c"
	}
#line 325 "../src/command.vala"
	return NULL;
#line 2010 "command.c"
}

gchar**
command_return_by_number (gint number,
                          gint* result_length1)
{
	gchar** command = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint command_length1;
	gint _command_size_;
	gchar** commands = NULL;
	Key* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint commands_length1;
	gint _commands_size_;
	gint count = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar** result;
#line 308 "../src/command.vala"
	_tmp0_ = g_strdup ("");
#line 308 "../src/command.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 308 "../src/command.vala"
	_tmp1_[0] = _tmp0_;
#line 308 "../src/command.vala"
	command = _tmp1_;
#line 308 "../src/command.vala"
	command_length1 = 1;
#line 308 "../src/command.vala"
	_command_size_ = command_length1;
#line 309 "../src/command.vala"
	_tmp2_ = settings_custom_commands;
#line 309 "../src/command.vala"
	_tmp3_ = key_get_val (_tmp2_);
#line 309 "../src/command.vala"
	_tmp4_ = _tmp3_;
#line 309 "../src/command.vala"
	_tmp5_ = _variant_get3 (_tmp4_, &_tmp5__length1);
#line 309 "../src/command.vala"
	commands = _tmp5_;
#line 309 "../src/command.vala"
	commands_length1 = _tmp5__length1;
#line 309 "../src/command.vala"
	_commands_size_ = commands_length1;
#line 311 "../src/command.vala"
	count = 0;
#line 313 "../src/command.vala"
	_tmp6_ = commands;
#line 313 "../src/command.vala"
	_tmp6__length1 = commands_length1;
#line 2068 "command.c"
	{
		gchar** _string_collection = NULL;
		gint _string_collection_length1 = 0;
		gint __string_collection_size_ = 0;
		gint _string_it = 0;
#line 313 "../src/command.vala"
		_string_collection = _tmp6_;
#line 313 "../src/command.vala"
		_string_collection_length1 = _tmp6__length1;
#line 313 "../src/command.vala"
		for (_string_it = 0; _string_it < _string_collection_length1; _string_it = _string_it + 1) {
#line 2080 "command.c"
			gchar* _tmp7_;
			gchar* _string = NULL;
#line 313 "../src/command.vala"
			_tmp7_ = g_strdup (_string_collection[_string_it]);
#line 313 "../src/command.vala"
			_string = _tmp7_;
#line 2087 "command.c"
			{
				gchar** _array = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _array_length1;
				gint __array_size_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_;
				gint _tmp13__length1;
#line 315 "../src/command.vala"
				_tmp8_ = _string;
#line 315 "../src/command.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ";", 6);
#line 315 "../src/command.vala"
				_array = _tmp10_;
#line 315 "../src/command.vala"
				_array_length1 = _vala_array_length (_tmp9_);
#line 315 "../src/command.vala"
				__array_size_ = _array_length1;
#line 317 "../src/command.vala"
				_tmp13_ = _array;
#line 317 "../src/command.vala"
				_tmp13__length1 = _array_length1;
#line 317 "../src/command.vala"
				if (_tmp13__length1 == 6) {
#line 2115 "command.c"
					gchar** _tmp14_;
					gint _tmp14__length1;
					const gchar* _tmp15_;
#line 318 "../src/command.vala"
					_tmp14_ = _array;
#line 318 "../src/command.vala"
					_tmp14__length1 = _array_length1;
#line 318 "../src/command.vala"
					_tmp15_ = _tmp14_[0];
#line 318 "../src/command.vala"
					_tmp12_ = g_strcmp0 (_tmp15_, "true") == 0;
#line 2127 "command.c"
				} else {
#line 317 "../src/command.vala"
					_tmp12_ = FALSE;
#line 2131 "command.c"
				}
#line 317 "../src/command.vala"
				if (_tmp12_) {
#line 2135 "command.c"
					gchar** _tmp16_;
					gint _tmp16__length1;
					const gchar* _tmp17_;
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
#line 319 "../src/command.vala"
					_tmp16_ = _array;
#line 319 "../src/command.vala"
					_tmp16__length1 = _array_length1;
#line 319 "../src/command.vala"
					_tmp17_ = _tmp16_[3];
#line 319 "../src/command.vala"
					_tmp18_ = _array;
#line 319 "../src/command.vala"
					_tmp18__length1 = _array_length1;
#line 319 "../src/command.vala"
					_tmp19_ = _tmp18_[4];
#line 319 "../src/command.vala"
					_tmp11_ = command_custom_exists (_tmp17_, _tmp19_);
#line 2156 "command.c"
				} else {
#line 317 "../src/command.vala"
					_tmp11_ = FALSE;
#line 2160 "command.c"
				}
#line 317 "../src/command.vala"
				if (_tmp11_) {
#line 2164 "command.c"
					gint _tmp20_;
#line 321 "../src/command.vala"
					_tmp20_ = count;
#line 321 "../src/command.vala"
					count = _tmp20_ + 1;
#line 323 "../src/command.vala"
					if (count == number) {
#line 2172 "command.c"
						gchar** _tmp21_;
						gint _tmp21__length1;
						gchar** _tmp22_;
						gint _tmp22__length1;
#line 325 "../src/command.vala"
						_tmp21_ = _array;
#line 325 "../src/command.vala"
						_tmp21__length1 = _array_length1;
#line 325 "../src/command.vala"
						_tmp22_ = (_tmp21_ != NULL) ? _vala_array_dup2 (_tmp21_, _tmp21__length1) : _tmp21_;
#line 325 "../src/command.vala"
						_tmp22__length1 = _tmp21__length1;
#line 325 "../src/command.vala"
						command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
#line 325 "../src/command.vala"
						command = _tmp22_;
#line 325 "../src/command.vala"
						command_length1 = _tmp22__length1;
#line 325 "../src/command.vala"
						_command_size_ = command_length1;
#line 2193 "command.c"
					}
				}
#line 313 "../src/command.vala"
				_array = (_vala_array_free (_array, _array_length1, (GDestroyNotify) g_free), NULL);
#line 313 "../src/command.vala"
				_g_free0 (_string);
#line 2200 "command.c"
			}
		}
	}
#line 330 "../src/command.vala"
	_tmp23_ = command;
#line 330 "../src/command.vala"
	_tmp23__length1 = command_length1;
#line 330 "../src/command.vala"
	if (result_length1) {
#line 330 "../src/command.vala"
		*result_length1 = _tmp23__length1;
#line 2212 "command.c"
	}
#line 330 "../src/command.vala"
	result = _tmp23_;
#line 330 "../src/command.vala"
	commands = (_vala_array_free (commands, commands_length1, (GDestroyNotify) g_free), NULL);
#line 330 "../src/command.vala"
	return result;
#line 2220 "command.c"
}

void
command_open_uri (const gchar* uri)
{
	GError* _inner_error0_ = NULL;
#line 333 "../src/command.vala"
	g_return_if_fail (uri != NULL);
#line 2229 "command.c"
	{
		HaguichiWindow* _tmp0_;
#line 338 "../src/command.vala"
		_tmp0_ = haguichi_window;
#line 338 "../src/command.vala"
		gtk_show_uri_on_window ((GtkWindow*) _tmp0_, uri, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
#line 338 "../src/command.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2238 "command.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 335 "../src/command.vala"
		e = _inner_error0_;
#line 335 "../src/command.vala"
		_inner_error0_ = NULL;
#line 345 "../src/command.vala"
		_tmp1_ = e;
#line 345 "../src/command.vala"
		_tmp2_ = _tmp1_->message;
#line 345 "../src/command.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "Command.open_uri", _tmp2_);
#line 347 "../src/command.vala"
		if (command_exists ("xdg-open")) {
#line 2260 "command.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 349 "../src/command.vala"
			debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.open_uri", "Falling back to xdg-open");
#line 350 "../src/command.vala"
			_tmp3_ = g_strconcat ("xdg-open ", uri, NULL);
#line 350 "../src/command.vala"
			_tmp4_ = _tmp3_;
#line 350 "../src/command.vala"
			command_execute (_tmp4_);
#line 350 "../src/command.vala"
			_g_free0 (_tmp4_);
#line 2273 "command.c"
		}
#line 335 "../src/command.vala"
		_g_error_free0 (e);
#line 2277 "command.c"
	}
	__finally0:
#line 335 "../src/command.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "../src/command.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 335 "../src/command.vala"
		g_clear_error (&_inner_error0_);
#line 335 "../src/command.vala"
		return;
#line 2288 "command.c"
	}
}

Command*
command_construct (GType object_type)
{
	Command * self = NULL;
#line 11 "../src/command.vala"
	self = (Command*) g_object_new (object_type, NULL);
#line 11 "../src/command.vala"
	return self;
#line 2300 "command.c"
}

Command*
command_new (void)
{
#line 11 "../src/command.vala"
	return command_construct (TYPE_COMMAND);
#line 2308 "command.c"
}

static void
command_class_init (CommandClass * klass,
                    gpointer klass_data)
{
#line 11 "../src/command.vala"
	command_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/command.vala"
	G_OBJECT_CLASS (klass)->finalize = command_finalize;
#line 2319 "command.c"
}

static void
command_instance_init (Command * self,
                       gpointer klass)
{
}

static void
command_finalize (GObject * obj)
{
	Command * self;
#line 11 "../src/command.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMAND, Command);
#line 11 "../src/command.vala"
	G_OBJECT_CLASS (command_parent_class)->finalize (obj);
#line 2336 "command.c"
}

static GType
command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Command), 0, (GInstanceInitFunc) command_instance_init, NULL };
	GType command_type_id;
	command_type_id = g_type_register_static (G_TYPE_OBJECT, "Command", &g_define_type_info, 0);
	return command_type_id;
}

GType
command_get_type (void)
{
	static volatile gsize command_type_id__once = 0;
	if (g_once_init_enter (&command_type_id__once)) {
		GType command_type_id;
		command_type_id = command_get_type_once ();
		g_once_init_leave (&command_type_id__once, command_type_id);
	}
	return command_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

