/* connection.c generated by valac 0.56.7, the Vala compiler
 * generated from connection.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;
typedef struct _ConnectionPrivate ConnectionPrivate;

#define TYPE_NETWORK (network_get_type ())
#define NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NETWORK, Network))
#define NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NETWORK, NetworkClass))
#define IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NETWORK))
#define IS_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NETWORK))
#define NETWORK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NETWORK, NetworkClass))

typedef struct _Network Network;
typedef struct _NetworkClass NetworkClass;
enum  {
	CONNECTION_0_PROPERTY,
	CONNECTION_NUM_PROPERTIES
};
static GParamSpec* connection_properties[CONNECTION_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _Connection {
	GObject parent_instance;
	ConnectionPrivate * priv;
	GList* networks;
};

struct _ConnectionClass {
	GObjectClass parent_class;
};

struct _ConnectionPrivate {
	GHashTable* long_nicks_hash;
	GRecMutex __lock_long_nicks_hash;
};

struct _Block1Data {
	int _ref_count_;
	Connection* self;
	gchar** long_nicks;
	gint long_nicks_length1;
	gint _long_nicks_size_;
};

static gint Connection_private_offset;
static gpointer connection_parent_class = NULL;
VALA_EXTERN Key* settings_long_nicks;

VALA_EXTERN GType connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Connection, g_object_unref)
VALA_EXTERN GType network_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Network, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN Connection* connection_new (void);
VALA_EXTERN Connection* connection_construct (GType object_type);
static void _g_free0_ (gpointer var);
VALA_EXTERN GType key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
VALA_EXTERN GVariant* key_get_val (Key* self);
static gchar** _variant_get4 (GVariant* value,
                       gint* result_length1);
VALA_EXTERN void connection_add_long_nick (Connection* self,
                               const gchar* client_id,
                               const gchar* long_nick);
VALA_EXTERN void connection_add_network (Connection* self,
                             Network* network);
VALA_EXTERN void connection_remove_network (Connection* self,
                                Network* network);
VALA_EXTERN gboolean connection_has_network (Connection* self,
                                 Network* network);
VALA_EXTERN void connection_clear_networks (Connection* self);
VALA_EXTERN gboolean connection_has_long_nick (Connection* self,
                                   const gchar* client_id);
VALA_EXTERN gchar* connection_get_long_nick (Connection* self,
                                 const gchar* client_id);
VALA_EXTERN void connection_save_long_nicks (Connection* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_,
                 const gchar* client_id,
                 const gchar* long_nick);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda4__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static GVariant* _variant_new3 (gchar** value,
                         gint value_length1);
VALA_EXTERN void key_set_val (Key* self,
                  GVariant* value);
static void connection_finalize (GObject * obj);
static GType connection_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
connection_get_instance_private (Connection* self)
{
	return G_STRUCT_MEMBER_P (self, Connection_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 13 "../src/connection.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 164 "connection.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 13 "../src/connection.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 172 "connection.c"
}

static void
_g_free0_ (gpointer var)
{
#line 19 "../src/connection.vala"
	var = (g_free (var), NULL);
#line 180 "connection.c"
}

static gchar**
_variant_get4 (GVariant* value,
               gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (gchar*, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 22 "../src/connection.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 22 "../src/connection.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 22 "../src/connection.vala"
		if (_tmp0__size == _tmp0__length) {
#line 22 "../src/connection.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 22 "../src/connection.vala"
			_tmp0_ = g_renew (gchar*, _tmp0_, _tmp0__size + 1);
#line 207 "connection.c"
		}
#line 22 "../src/connection.vala"
		_tmp0_[_tmp0__length++] = g_variant_dup_string (_tmp2_, NULL);
#line 22 "../src/connection.vala"
		g_variant_unref (_tmp2_);
#line 213 "connection.c"
	}
#line 22 "../src/connection.vala"
	*result_length1 = _tmp0__length1;
#line 22 "../src/connection.vala"
	_tmp0_[_tmp0__length] = NULL;
#line 22 "../src/connection.vala"
	return _tmp0_;
#line 221 "connection.c"
}

Connection*
connection_construct (GType object_type)
{
	Connection * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar** long_nicks = NULL;
	Key* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gint long_nicks_length1;
	gint _long_nicks_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
#line 16 "../src/connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 18 "../src/connection.vala"
	(self->networks == NULL) ? NULL : (self->networks = (_g_list_free__g_object_unref0_ (self->networks), NULL));
#line 18 "../src/connection.vala"
	self->networks = NULL;
#line 19 "../src/connection.vala"
	_tmp0_ = g_str_hash;
#line 19 "../src/connection.vala"
	_tmp1_ = g_str_equal;
#line 19 "../src/connection.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 19 "../src/connection.vala"
	_g_hash_table_unref0 (self->priv->long_nicks_hash);
#line 19 "../src/connection.vala"
	self->priv->long_nicks_hash = _tmp2_;
#line 22 "../src/connection.vala"
	_tmp3_ = settings_long_nicks;
#line 22 "../src/connection.vala"
	_tmp4_ = key_get_val (_tmp3_);
#line 22 "../src/connection.vala"
	_tmp5_ = _tmp4_;
#line 22 "../src/connection.vala"
	_tmp6_ = _variant_get4 (_tmp5_, &_tmp6__length1);
#line 22 "../src/connection.vala"
	long_nicks = _tmp6_;
#line 22 "../src/connection.vala"
	long_nicks_length1 = _tmp6__length1;
#line 22 "../src/connection.vala"
	_long_nicks_size_ = long_nicks_length1;
#line 25 "../src/connection.vala"
	_tmp7_ = long_nicks;
#line 25 "../src/connection.vala"
	_tmp7__length1 = long_nicks_length1;
#line 275 "connection.c"
	{
		gchar** long_nick_collection = NULL;
		gint long_nick_collection_length1 = 0;
		gint _long_nick_collection_size_ = 0;
		gint long_nick_it = 0;
#line 25 "../src/connection.vala"
		long_nick_collection = _tmp7_;
#line 25 "../src/connection.vala"
		long_nick_collection_length1 = _tmp7__length1;
#line 25 "../src/connection.vala"
		for (long_nick_it = 0; long_nick_it < long_nick_collection_length1; long_nick_it = long_nick_it + 1) {
#line 287 "connection.c"
			gchar* _tmp8_;
			gchar* long_nick = NULL;
#line 25 "../src/connection.vala"
			_tmp8_ = g_strdup (long_nick_collection[long_nick_it]);
#line 25 "../src/connection.vala"
			long_nick = _tmp8_;
#line 294 "connection.c"
			{
				gchar** parts = NULL;
				const gchar* _tmp9_;
				gchar** _tmp10_;
				gchar** _tmp11_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp12_;
				gint _tmp12__length1;
#line 27 "../src/connection.vala"
				_tmp9_ = long_nick;
#line 27 "../src/connection.vala"
				_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, ";", 2);
#line 27 "../src/connection.vala"
				parts = _tmp11_;
#line 27 "../src/connection.vala"
				parts_length1 = _vala_array_length (_tmp10_);
#line 27 "../src/connection.vala"
				_parts_size_ = parts_length1;
#line 29 "../src/connection.vala"
				_tmp12_ = parts;
#line 29 "../src/connection.vala"
				_tmp12__length1 = parts_length1;
#line 29 "../src/connection.vala"
				if (_tmp12__length1 == 2) {
#line 320 "connection.c"
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
#line 31 "../src/connection.vala"
					_tmp13_ = parts;
#line 31 "../src/connection.vala"
					_tmp13__length1 = parts_length1;
#line 31 "../src/connection.vala"
					_tmp14_ = _tmp13_[0];
#line 31 "../src/connection.vala"
					_tmp15_ = parts;
#line 31 "../src/connection.vala"
					_tmp15__length1 = parts_length1;
#line 31 "../src/connection.vala"
					_tmp16_ = _tmp15_[1];
#line 31 "../src/connection.vala"
					connection_add_long_nick (self, _tmp14_, _tmp16_);
#line 341 "connection.c"
				}
#line 25 "../src/connection.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 25 "../src/connection.vala"
				_g_free0 (long_nick);
#line 347 "connection.c"
			}
		}
	}
#line 16 "../src/connection.vala"
	long_nicks = (_vala_array_free (long_nicks, long_nicks_length1, (GDestroyNotify) g_free), NULL);
#line 16 "../src/connection.vala"
	return self;
#line 355 "connection.c"
}

Connection*
connection_new (void)
{
#line 16 "../src/connection.vala"
	return connection_construct (TYPE_CONNECTION);
#line 363 "connection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 371 "connection.c"
}

void
connection_add_network (Connection* self,
                        Network* network)
{
	Network* _tmp0_;
#line 36 "../src/connection.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/connection.vala"
	g_return_if_fail (network != NULL);
#line 38 "../src/connection.vala"
	_tmp0_ = _g_object_ref0 (network);
#line 38 "../src/connection.vala"
	self->networks = g_list_append (self->networks, _tmp0_);
#line 387 "connection.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5135 "glib-2.0.vapi"
	l = self;
#line 5136 "glib-2.0.vapi"
	while (TRUE) {
#line 401 "connection.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5136 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5136 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5136 "glib-2.0.vapi"
			break;
#line 411 "connection.c"
		}
#line 5137 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5137 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5137 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 419 "connection.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5138 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5138 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5138 "glib-2.0.vapi"
			l = _tmp4_;
#line 428 "connection.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5140 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5140 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5140 "glib-2.0.vapi"
			func (_tmp6_);
#line 5141 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5141 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5142 "glib-2.0.vapi"
			break;
#line 445 "connection.c"
		}
	}
#line 5145 "glib-2.0.vapi"
	result = self;
#line 5145 "glib-2.0.vapi"
	return result;
#line 452 "connection.c"
}

void
connection_remove_network (Connection* self,
                           Network* network)
{
#line 41 "../src/connection.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/connection.vala"
	g_return_if_fail (network != NULL);
#line 43 "../src/connection.vala"
	self->networks = vala_g_list_remove_full (self->networks, network, _g_object_unref0_);
#line 465 "connection.c"
}

gboolean
connection_has_network (Connection* self,
                        Network* network)
{
	GList* _tmp0_;
	gboolean result;
#line 46 "../src/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/connection.vala"
	g_return_val_if_fail (network != NULL, FALSE);
#line 48 "../src/connection.vala"
	_tmp0_ = self->networks;
#line 48 "../src/connection.vala"
	result = g_list_index (_tmp0_, network) > -1;
#line 48 "../src/connection.vala"
	return result;
#line 484 "connection.c"
}

void
connection_clear_networks (Connection* self)
{
#line 51 "../src/connection.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/connection.vala"
	(self->networks == NULL) ? NULL : (self->networks = (_g_list_free__g_object_unref0_ (self->networks), NULL));
#line 53 "../src/connection.vala"
	self->networks = NULL;
#line 496 "connection.c"
}

gboolean
connection_has_long_nick (Connection* self,
                          const gchar* client_id)
{
	GHashTable* _tmp0_;
	gboolean result;
#line 56 "../src/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/connection.vala"
	g_return_val_if_fail (client_id != NULL, FALSE);
#line 58 "../src/connection.vala"
	_tmp0_ = self->priv->long_nicks_hash;
#line 58 "../src/connection.vala"
	result = g_hash_table_contains (_tmp0_, client_id);
#line 58 "../src/connection.vala"
	return result;
#line 515 "connection.c"
}

gchar*
connection_get_long_nick (Connection* self,
                          const gchar* client_id)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 61 "../src/connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/connection.vala"
	g_return_val_if_fail (client_id != NULL, NULL);
#line 63 "../src/connection.vala"
	_tmp0_ = self->priv->long_nicks_hash;
#line 63 "../src/connection.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, client_id);
#line 63 "../src/connection.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
#line 63 "../src/connection.vala"
	result = _tmp2_;
#line 63 "../src/connection.vala"
	return result;
#line 540 "connection.c"
}

void
connection_add_long_nick (Connection* self,
                          const gchar* client_id,
                          const gchar* long_nick)
{
	GError* _inner_error0_ = NULL;
#line 66 "../src/connection.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/connection.vala"
	g_return_if_fail (client_id != NULL);
#line 66 "../src/connection.vala"
	g_return_if_fail (long_nick != NULL);
#line 555 "connection.c"
	{
		GHashTable* _tmp0_;
#line 69 "../src/connection.vala"
		_tmp0_ = self->priv->long_nicks_hash;
#line 69 "../src/connection.vala"
		g_rec_mutex_lock (&self->priv->__lock_long_nicks_hash);
#line 562 "connection.c"
		{
			GHashTable* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 71 "../src/connection.vala"
			_tmp1_ = self->priv->long_nicks_hash;
#line 71 "../src/connection.vala"
			_tmp2_ = g_strdup (client_id);
#line 71 "../src/connection.vala"
			_tmp3_ = g_strdup (long_nick);
#line 71 "../src/connection.vala"
			g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
#line 575 "connection.c"
		}
		__finally0:
		{
			GHashTable* _tmp4_;
#line 69 "../src/connection.vala"
			_tmp4_ = self->priv->long_nicks_hash;
#line 69 "../src/connection.vala"
			g_rec_mutex_unlock (&self->priv->__lock_long_nicks_hash);
#line 584 "connection.c"
		}
#line 69 "../src/connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/connection.vala"
			g_clear_error (&_inner_error0_);
#line 69 "../src/connection.vala"
			return;
#line 594 "connection.c"
		}
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 75 "../src/connection.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 75 "../src/connection.vala"
	return _data1_;
#line 606 "connection.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 75 "../src/connection.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 616 "connection.c"
		Connection* self;
#line 75 "../src/connection.vala"
		self = _data1_->self;
#line 75 "../src/connection.vala"
		_data1_->long_nicks = (_vala_array_free (_data1_->long_nicks, _data1_->long_nicks_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/connection.vala"
		_g_object_unref0 (self);
#line 75 "../src/connection.vala"
		g_slice_free (Block1Data, _data1_);
#line 626 "connection.c"
	}
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 81 "../src/connection.vala"
	if ((*length) == (*size)) {
#line 81 "../src/connection.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 81 "../src/connection.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 642 "connection.c"
	}
#line 81 "../src/connection.vala"
	(*array)[(*length)++] = value;
#line 81 "../src/connection.vala"
	(*array)[*length] = NULL;
#line 648 "connection.c"
}

static void
__lambda4_ (Block1Data* _data1_,
            const gchar* client_id,
            const gchar* long_nick)
{
	Connection* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 79 "../src/connection.vala"
	self = _data1_->self;
#line 79 "../src/connection.vala"
	g_return_if_fail (client_id != NULL);
#line 79 "../src/connection.vala"
	g_return_if_fail (long_nick != NULL);
#line 81 "../src/connection.vala"
	_tmp0_ = g_strconcat (client_id, ";", NULL);
#line 81 "../src/connection.vala"
	_tmp1_ = _tmp0_;
#line 81 "../src/connection.vala"
	_tmp2_ = g_strconcat (_tmp1_, long_nick, NULL);
#line 81 "../src/connection.vala"
	_vala_array_add3 (&_data1_->long_nicks, &_data1_->long_nicks_length1, &_data1_->_long_nicks_size_, _tmp2_);
#line 81 "../src/connection.vala"
	_g_free0 (_tmp1_);
#line 676 "connection.c"
}

static void
___lambda4__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
#line 79 "../src/connection.vala"
	__lambda4_ (self, (const gchar*) key, (const gchar*) value);
#line 686 "connection.c"
}

static GVariant*
_variant_new3 (gchar** value,
               gint value_length1)
{
	gchar** _tmp3_;
	GVariantBuilder _tmp4_;
	gint _tmp5_;
#line 84 "../src/connection.vala"
	_tmp3_ = value;
#line 84 "../src/connection.vala"
	g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE ("as"));
#line 84 "../src/connection.vala"
	for (_tmp5_ = 0; _tmp5_ < value_length1; _tmp5_++) {
#line 84 "../src/connection.vala"
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string (*_tmp3_));
#line 84 "../src/connection.vala"
		_tmp3_++;
#line 706 "connection.c"
	}
#line 84 "../src/connection.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp4_));
#line 710 "connection.c"
}

void
connection_save_long_nicks (Connection* self)
{
	Block1Data* _data1_;
	gchar** _tmp0_;
	GHashTable* _tmp1_;
	Key* _tmp2_;
	GVariant* _tmp6_;
#line 75 "../src/connection.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/connection.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 75 "../src/connection.vala"
	_data1_->_ref_count_ = 1;
#line 75 "../src/connection.vala"
	_data1_->self = g_object_ref (self);
#line 77 "../src/connection.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 77 "../src/connection.vala"
	_data1_->long_nicks = _tmp0_;
#line 77 "../src/connection.vala"
	_data1_->long_nicks_length1 = 0;
#line 77 "../src/connection.vala"
	_data1_->_long_nicks_size_ = _data1_->long_nicks_length1;
#line 79 "../src/connection.vala"
	_tmp1_ = self->priv->long_nicks_hash;
#line 79 "../src/connection.vala"
	g_hash_table_foreach (_tmp1_, ___lambda4__gh_func, _data1_);
#line 84 "../src/connection.vala"
	_tmp2_ = settings_long_nicks;
#line 84 "../src/connection.vala"
	_tmp6_ = _variant_new3 (_data1_->long_nicks, _data1_->long_nicks_length1);
#line 84 "../src/connection.vala"
	key_set_val (_tmp2_, _tmp6_);
#line 84 "../src/connection.vala"
	_g_variant_unref0 (_tmp6_);
#line 75 "../src/connection.vala"
	block1_data_unref (_data1_);
#line 75 "../src/connection.vala"
	_data1_ = NULL;
#line 753 "connection.c"
}

static void
connection_class_init (ConnectionClass * klass,
                       gpointer klass_data)
{
#line 11 "../src/connection.vala"
	connection_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/connection.vala"
	g_type_class_adjust_private_offset (klass, &Connection_private_offset);
#line 11 "../src/connection.vala"
	G_OBJECT_CLASS (klass)->finalize = connection_finalize;
#line 766 "connection.c"
}

static void
connection_instance_init (Connection * self,
                          gpointer klass)
{
#line 11 "../src/connection.vala"
	self->priv = connection_get_instance_private (self);
#line 14 "../src/connection.vala"
	g_rec_mutex_init (&self->priv->__lock_long_nicks_hash);
#line 777 "connection.c"
}

static void
connection_finalize (GObject * obj)
{
	Connection * self;
#line 11 "../src/connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONNECTION, Connection);
#line 13 "../src/connection.vala"
	(self->networks == NULL) ? NULL : (self->networks = (_g_list_free__g_object_unref0_ (self->networks), NULL));
#line 14 "../src/connection.vala"
	g_rec_mutex_clear (&self->priv->__lock_long_nicks_hash);
#line 14 "../src/connection.vala"
	_g_hash_table_unref0 (self->priv->long_nicks_hash);
#line 11 "../src/connection.vala"
	G_OBJECT_CLASS (connection_parent_class)->finalize (obj);
#line 794 "connection.c"
}

static GType
connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Connection), 0, (GInstanceInitFunc) connection_instance_init, NULL };
	GType connection_type_id;
	connection_type_id = g_type_register_static (G_TYPE_OBJECT, "Connection", &g_define_type_info, 0);
	Connection_private_offset = g_type_add_instance_private (connection_type_id, sizeof (ConnectionPrivate));
	return connection_type_id;
}

GType
connection_get_type (void)
{
	static volatile gsize connection_type_id__once = 0;
	if (g_once_init_enter (&connection_type_id__once)) {
		GType connection_type_id;
		connection_type_id = connection_get_type_once ();
		g_once_init_leave (&connection_type_id__once, connection_type_id);
	}
	return connection_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

