/* debug.c generated by valac 0.56.7, the Vala compiler
 * generated from debug.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DEBUG (debug_get_type ())
#define DEBUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEBUG, Debug))
#define DEBUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEBUG, DebugClass))
#define IS_DEBUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEBUG))
#define IS_DEBUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEBUG))
#define DEBUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEBUG, DebugClass))

typedef struct _Debug Debug;
typedef struct _DebugClass DebugClass;
typedef struct _DebugPrivate DebugPrivate;
enum  {
	DEBUG_0_PROPERTY,
	DEBUG_NUM_PROPERTIES
};
static GParamSpec* debug_properties[DEBUG_NUM_PROPERTIES];
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _Debug {
	GObject parent_instance;
	DebugPrivate * priv;
};

struct _DebugClass {
	GObjectClass parent_class;
};

static gpointer debug_parent_class = NULL;
VALA_EXTERN gboolean haguichi_debugging;

VALA_EXTERN GType debug_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Debug, g_object_unref)
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static gchar* debug_domain_color (Debugdomain _domain);
static gchar* debug_domain_name (Debugdomain _domain);
VALA_EXTERN Debug* debug_new (void);
VALA_EXTERN Debug* debug_construct (GType object_type);
static GType debug_get_type_once (void);

static GType
debug_domain_get_type_once (void)
{
	static const GEnumValue values[] = {{DEBUG_DOMAIN_ERROR, "DEBUG_DOMAIN_ERROR", "error"}, {DEBUG_DOMAIN_INFO, "DEBUG_DOMAIN_INFO", "info"}, {DEBUG_DOMAIN_HAMACHI, "DEBUG_DOMAIN_HAMACHI", "hamachi"}, {DEBUG_DOMAIN_ENVIRONMENT, "DEBUG_DOMAIN_ENVIRONMENT", "environment"}, {DEBUG_DOMAIN_GUI, "DEBUG_DOMAIN_GUI", "gui"}, {0, NULL, NULL}};
	GType debug_domain_type_id;
	debug_domain_type_id = g_enum_register_static ("Debugdomain", values);
	return debug_domain_type_id;
}

GType
debug_domain_get_type (void)
{
	static volatile gsize debug_domain_type_id__once = 0;
	if (g_once_init_enter (&debug_domain_type_id__once)) {
		GType debug_domain_type_id;
		debug_domain_type_id = debug_domain_get_type_once ();
		g_once_init_leave (&debug_domain_type_id__once, debug_domain_type_id);
	}
	return debug_domain_type_id__once;
}

void
debug_log (Debugdomain _domain,
           const gchar* reporter,
           const gchar* output)
{
#line 13 "../src/debug.vala"
	g_return_if_fail (reporter != NULL);
#line 15 "../src/debug.vala"
	if (haguichi_debugging) {
#line 112 "debug.c"
		GDateTime* now = NULL;
		GDateTime* _tmp0_;
		FILE* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 17 "../src/debug.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 17 "../src/debug.vala"
		now = _tmp0_;
#line 19 "../src/debug.vala"
		_tmp1_ = stdout;
#line 19 "../src/debug.vala"
		_tmp2_ = debug_domain_color (_domain);
#line 19 "../src/debug.vala"
		_tmp3_ = _tmp2_;
#line 19 "../src/debug.vala"
		_tmp4_ = now;
#line 19 "../src/debug.vala"
		_tmp5_ = now;
#line 19 "../src/debug.vala"
		_tmp6_ = now;
#line 19 "../src/debug.vala"
		_tmp7_ = now;
#line 19 "../src/debug.vala"
		_tmp8_ = debug_domain_name (_domain);
#line 19 "../src/debug.vala"
		_tmp9_ = _tmp8_;
#line 19 "../src/debug.vala"
		_tmp10_ = g_utf8_strup (_tmp9_, (gssize) -1);
#line 19 "../src/debug.vala"
		_tmp11_ = _tmp10_;
#line 19 "../src/debug.vala"
		fprintf (_tmp1_, "\x1b[%sm[%02d:%02d:%02d.%06d %s] [%s]\x1b[0m %s\n", _tmp3_, g_date_time_get_hour (_tmp4_), g_date_time_get_minute (_tmp5_), g_date_time_get_second (_tmp6_), g_date_time_get_microsecond (_tmp7_), _tmp11_, reporter, output);
#line 19 "../src/debug.vala"
		_g_free0 (_tmp11_);
#line 19 "../src/debug.vala"
		_g_free0 (_tmp9_);
#line 19 "../src/debug.vala"
		_g_free0 (_tmp3_);
#line 15 "../src/debug.vala"
		_g_date_time_unref0 (now);
#line 162 "debug.c"
	}
}

static gchar*
debug_domain_color (Debugdomain _domain)
{
	gchar* result;
#line 38 "../src/debug.vala"
	switch (_domain) {
#line 38 "../src/debug.vala"
		case DEBUG_DOMAIN_ERROR:
#line 174 "debug.c"
		{
			gchar* _tmp0_;
#line 40 "../src/debug.vala"
			_tmp0_ = g_strdup ("00;31");
#line 40 "../src/debug.vala"
			result = _tmp0_;
#line 40 "../src/debug.vala"
			return result;
#line 183 "debug.c"
		}
#line 38 "../src/debug.vala"
		case DEBUG_DOMAIN_INFO:
#line 187 "debug.c"
		{
			gchar* _tmp1_;
#line 41 "../src/debug.vala"
			_tmp1_ = g_strdup ("00;34");
#line 41 "../src/debug.vala"
			result = _tmp1_;
#line 41 "../src/debug.vala"
			return result;
#line 196 "debug.c"
		}
#line 38 "../src/debug.vala"
		case DEBUG_DOMAIN_HAMACHI:
#line 200 "debug.c"
		{
			gchar* _tmp2_;
#line 42 "../src/debug.vala"
			_tmp2_ = g_strdup ("00;35");
#line 42 "../src/debug.vala"
			result = _tmp2_;
#line 42 "../src/debug.vala"
			return result;
#line 209 "debug.c"
		}
#line 38 "../src/debug.vala"
		case DEBUG_DOMAIN_ENVIRONMENT:
#line 213 "debug.c"
		{
			gchar* _tmp3_;
#line 43 "../src/debug.vala"
			_tmp3_ = g_strdup ("00;36");
#line 43 "../src/debug.vala"
			result = _tmp3_;
#line 43 "../src/debug.vala"
			return result;
#line 222 "debug.c"
		}
#line 38 "../src/debug.vala"
		case DEBUG_DOMAIN_GUI:
#line 226 "debug.c"
		{
			gchar* _tmp4_;
#line 44 "../src/debug.vala"
			_tmp4_ = g_strdup ("00;32");
#line 44 "../src/debug.vala"
			result = _tmp4_;
#line 44 "../src/debug.vala"
			return result;
#line 235 "debug.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 46 "../src/debug.vala"
			_tmp5_ = g_strdup ("0");
#line 46 "../src/debug.vala"
			result = _tmp5_;
#line 46 "../src/debug.vala"
			return result;
#line 246 "debug.c"
		}
	}
}

static gchar*
debug_domain_name (Debugdomain _domain)
{
	gchar* result;
#line 52 "../src/debug.vala"
	switch (_domain) {
#line 52 "../src/debug.vala"
		case DEBUG_DOMAIN_ERROR:
#line 259 "debug.c"
		{
			gchar* _tmp0_;
#line 54 "../src/debug.vala"
			_tmp0_ = g_strdup ("Error");
#line 54 "../src/debug.vala"
			result = _tmp0_;
#line 54 "../src/debug.vala"
			return result;
#line 268 "debug.c"
		}
#line 52 "../src/debug.vala"
		case DEBUG_DOMAIN_INFO:
#line 272 "debug.c"
		{
			gchar* _tmp1_;
#line 55 "../src/debug.vala"
			_tmp1_ = g_strdup ("Info");
#line 55 "../src/debug.vala"
			result = _tmp1_;
#line 55 "../src/debug.vala"
			return result;
#line 281 "debug.c"
		}
#line 52 "../src/debug.vala"
		case DEBUG_DOMAIN_HAMACHI:
#line 285 "debug.c"
		{
			gchar* _tmp2_;
#line 56 "../src/debug.vala"
			_tmp2_ = g_strdup ("Hamachi");
#line 56 "../src/debug.vala"
			result = _tmp2_;
#line 56 "../src/debug.vala"
			return result;
#line 294 "debug.c"
		}
#line 52 "../src/debug.vala"
		case DEBUG_DOMAIN_ENVIRONMENT:
#line 298 "debug.c"
		{
			gchar* _tmp3_;
#line 57 "../src/debug.vala"
			_tmp3_ = g_strdup ("Environment");
#line 57 "../src/debug.vala"
			result = _tmp3_;
#line 57 "../src/debug.vala"
			return result;
#line 307 "debug.c"
		}
#line 52 "../src/debug.vala"
		case DEBUG_DOMAIN_GUI:
#line 311 "debug.c"
		{
			gchar* _tmp4_;
#line 58 "../src/debug.vala"
			_tmp4_ = g_strdup ("Gui");
#line 58 "../src/debug.vala"
			result = _tmp4_;
#line 58 "../src/debug.vala"
			return result;
#line 320 "debug.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 60 "../src/debug.vala"
			_tmp5_ = g_strdup ("Unknown");
#line 60 "../src/debug.vala"
			result = _tmp5_;
#line 60 "../src/debug.vala"
			return result;
#line 331 "debug.c"
		}
	}
}

Debug*
debug_construct (GType object_type)
{
	Debug * self = NULL;
#line 11 "../src/debug.vala"
	self = (Debug*) g_object_new (object_type, NULL);
#line 11 "../src/debug.vala"
	return self;
#line 344 "debug.c"
}

Debug*
debug_new (void)
{
#line 11 "../src/debug.vala"
	return debug_construct (TYPE_DEBUG);
#line 352 "debug.c"
}

static void
debug_class_init (DebugClass * klass,
                  gpointer klass_data)
{
#line 11 "../src/debug.vala"
	debug_parent_class = g_type_class_peek_parent (klass);
#line 361 "debug.c"
}

static void
debug_instance_init (Debug * self,
                     gpointer klass)
{
}

static GType
debug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DebugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) debug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Debug), 0, (GInstanceInitFunc) debug_instance_init, NULL };
	GType debug_type_id;
	debug_type_id = g_type_register_static (G_TYPE_OBJECT, "Debug", &g_define_type_info, 0);
	return debug_type_id;
}

GType
debug_get_type (void)
{
	static volatile gsize debug_type_id__once = 0;
	if (g_once_init_enter (&debug_type_id__once)) {
		GType debug_type_id;
		debug_type_id = debug_get_type_once ();
		g_once_init_leave (&debug_type_id__once, debug_type_id);
	}
	return debug_type_id__once;
}

