/* message.c generated by valac 0.56.7, the Vala compiler
 * generated from message.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DIALOGS_TYPE_BASE (dialogs_base_get_type ())
#define DIALOGS_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_BASE, DialogsBase))
#define DIALOGS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_BASE, DialogsBaseClass))
#define DIALOGS_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_BASE))
#define DIALOGS_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_BASE))
#define DIALOGS_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_BASE, DialogsBaseClass))

typedef struct _DialogsBase DialogsBase;
typedef struct _DialogsBaseClass DialogsBaseClass;
typedef struct _DialogsBasePrivate DialogsBasePrivate;

#define DIALOGS_TYPE_MESSAGE (dialogs_message_get_type ())
#define DIALOGS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_MESSAGE, DialogsMessage))
#define DIALOGS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_MESSAGE, DialogsMessageClass))
#define DIALOGS_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_MESSAGE))
#define DIALOGS_IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_MESSAGE))
#define DIALOGS_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_MESSAGE, DialogsMessageClass))

typedef struct _DialogsMessage DialogsMessage;
typedef struct _DialogsMessageClass DialogsMessageClass;
typedef struct _DialogsMessagePrivate DialogsMessagePrivate;
enum  {
	DIALOGS_MESSAGE_0_PROPERTY,
	DIALOGS_MESSAGE_NUM_PROPERTIES
};
static GParamSpec* dialogs_message_properties[DIALOGS_MESSAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DialogsBase {
	GtkMessageDialog parent_instance;
	DialogsBasePrivate * priv;
	gint response_id;
};

struct _DialogsBaseClass {
	GtkMessageDialogClass parent_class;
};

struct _DialogsMessage {
	DialogsBase parent_instance;
	DialogsMessagePrivate * priv;
};

struct _DialogsMessageClass {
	DialogsBaseClass parent_class;
};

static gpointer dialogs_message_parent_class = NULL;
VALA_EXTERN gchar* text_close_label;
VALA_EXTERN gchar* text_hamachi_output;

VALA_EXTERN GType dialogs_base_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsBase, g_object_unref)
VALA_EXTERN GType dialogs_message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsMessage, g_object_unref)
VALA_EXTERN DialogsMessage* dialogs_message_new (GtkWindow* parent,
                                     const gchar* header_text,
                                     const gchar* message_text,
                                     GtkMessageType _message_type,
                                     const gchar* output);
VALA_EXTERN DialogsMessage* dialogs_message_construct (GType object_type,
                                           GtkWindow* parent,
                                           const gchar* header_text,
                                           const gchar* message_text,
                                           GtkMessageType _message_type,
                                           const gchar* output);
VALA_EXTERN DialogsBase* dialogs_base_new (GtkWindow* parent,
                               const gchar* header_text,
                               const gchar* message_text,
                               GtkMessageType _message_type);
VALA_EXTERN DialogsBase* dialogs_base_construct (GType object_type,
                                     GtkWindow* parent,
                                     const gchar* header_text,
                                     const gchar* message_text,
                                     GtkMessageType _message_type);
VALA_EXTERN void dialogs_base_add_content (DialogsBase* self,
                               GtkWidget* widget);
static GType dialogs_message_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/dialogs/message.vala"
	return self ? g_object_ref (self) : NULL;
#line 116 "message.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 137 "message.c"
}

DialogsMessage*
dialogs_message_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* header_text,
                           const gchar* message_text,
                           GtkMessageType _message_type,
                           const gchar* output)
{
	DialogsMessage * self = NULL;
	GtkButton* close_but = NULL;
	const gchar* _tmp0_;
	GtkWidget* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
#line 17 "../src/dialogs/message.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 17 "../src/dialogs/message.vala"
	g_return_val_if_fail (header_text != NULL, NULL);
#line 17 "../src/dialogs/message.vala"
	g_return_val_if_fail (message_text != NULL, NULL);
#line 19 "../src/dialogs/message.vala"
	self = (DialogsMessage*) dialogs_base_construct (object_type, parent, header_text, message_text, _message_type);
#line 21 "../src/dialogs/message.vala"
	_tmp0_ = text_close_label;
#line 21 "../src/dialogs/message.vala"
	_tmp1_ = gtk_dialog_add_button ((GtkDialog*) self, _tmp0_, (gint) GTK_RESPONSE_CLOSE);
#line 21 "../src/dialogs/message.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton));
#line 21 "../src/dialogs/message.vala"
	close_but = _tmp2_;
#line 22 "../src/dialogs/message.vala"
	_tmp3_ = close_but;
#line 22 "../src/dialogs/message.vala"
	gtk_widget_grab_default ((GtkWidget*) _tmp3_);
#line 24 "../src/dialogs/message.vala"
	if (output != NULL) {
#line 176 "message.c"
		GtkTextView* textview = NULL;
		GtkTextView* _tmp4_;
		GtkTextView* _tmp5_;
		GtkTextView* _tmp6_;
		GtkTextView* _tmp7_;
		GtkTextView* _tmp8_;
		GtkTextView* _tmp9_;
		GtkTextBuffer* buffer = NULL;
		GtkTextView* _tmp10_;
		GtkTextBuffer* _tmp11_;
		GtkTextBuffer* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextIter iter = {0};
		GtkTextBuffer* _tmp14_;
		GtkTextIter _tmp15_ = {0};
		GtkTextBuffer* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GtkScrolledWindow* sw = NULL;
		GtkScrolledWindow* _tmp19_;
		GtkScrolledWindow* _tmp20_;
		GtkScrolledWindow* _tmp21_;
		GtkScrolledWindow* _tmp22_;
		GtkScrolledWindow* _tmp23_;
		GtkScrolledWindow* _tmp24_;
		GtkTextView* _tmp25_;
		GtkExpander* expander = NULL;
		const gchar* _tmp26_;
		GtkExpander* _tmp27_;
		GtkExpander* _tmp28_;
		GtkScrolledWindow* _tmp29_;
		GtkExpander* _tmp30_;
		GtkExpander* _tmp31_;
#line 26 "../src/dialogs/message.vala"
		_tmp4_ = (GtkTextView*) gtk_text_view_new ();
#line 26 "../src/dialogs/message.vala"
		g_object_ref_sink (_tmp4_);
#line 26 "../src/dialogs/message.vala"
		textview = _tmp4_;
#line 27 "../src/dialogs/message.vala"
		_tmp5_ = textview;
#line 27 "../src/dialogs/message.vala"
		gtk_text_view_set_editable (_tmp5_, FALSE);
#line 28 "../src/dialogs/message.vala"
		_tmp6_ = textview;
#line 28 "../src/dialogs/message.vala"
		gtk_text_view_set_left_margin (_tmp6_, 3);
#line 29 "../src/dialogs/message.vala"
		_tmp7_ = textview;
#line 29 "../src/dialogs/message.vala"
		gtk_text_view_set_right_margin (_tmp7_, 3);
#line 30 "../src/dialogs/message.vala"
		_tmp8_ = textview;
#line 30 "../src/dialogs/message.vala"
		gtk_text_view_set_pixels_above_lines (_tmp8_, 3);
#line 31 "../src/dialogs/message.vala"
		_tmp9_ = textview;
#line 31 "../src/dialogs/message.vala"
		gtk_text_view_set_pixels_below_lines (_tmp9_, 3);
#line 33 "../src/dialogs/message.vala"
		_tmp10_ = textview;
#line 33 "../src/dialogs/message.vala"
		_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 33 "../src/dialogs/message.vala"
		_tmp12_ = _tmp11_;
#line 33 "../src/dialogs/message.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 33 "../src/dialogs/message.vala"
		buffer = _tmp13_;
#line 35 "../src/dialogs/message.vala"
		_tmp14_ = buffer;
#line 35 "../src/dialogs/message.vala"
		gtk_text_buffer_get_iter_at_offset (_tmp14_, &_tmp15_, 0);
#line 35 "../src/dialogs/message.vala"
		iter = _tmp15_;
#line 36 "../src/dialogs/message.vala"
		_tmp16_ = buffer;
#line 36 "../src/dialogs/message.vala"
		_tmp17_ = string_strip (output);
#line 36 "../src/dialogs/message.vala"
		_tmp18_ = _tmp17_;
#line 36 "../src/dialogs/message.vala"
		gtk_text_buffer_insert (_tmp16_, &iter, _tmp18_, -1);
#line 36 "../src/dialogs/message.vala"
		_g_free0 (_tmp18_);
#line 38 "../src/dialogs/message.vala"
		_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 38 "../src/dialogs/message.vala"
		g_object_ref_sink (_tmp19_);
#line 38 "../src/dialogs/message.vala"
		sw = _tmp19_;
#line 39 "../src/dialogs/message.vala"
		_tmp20_ = sw;
#line 39 "../src/dialogs/message.vala"
		g_object_set (_tmp20_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 40 "../src/dialogs/message.vala"
		_tmp21_ = sw;
#line 40 "../src/dialogs/message.vala"
		g_object_set (_tmp21_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 41 "../src/dialogs/message.vala"
		_tmp22_ = sw;
#line 41 "../src/dialogs/message.vala"
		gtk_scrolled_window_set_min_content_height (_tmp22_, 60);
#line 42 "../src/dialogs/message.vala"
		_tmp23_ = sw;
#line 42 "../src/dialogs/message.vala"
		gtk_scrolled_window_set_shadow_type (_tmp23_, GTK_SHADOW_IN);
#line 43 "../src/dialogs/message.vala"
		_tmp24_ = sw;
#line 43 "../src/dialogs/message.vala"
		_tmp25_ = textview;
#line 43 "../src/dialogs/message.vala"
		gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 45 "../src/dialogs/message.vala"
		_tmp26_ = text_hamachi_output;
#line 45 "../src/dialogs/message.vala"
		_tmp27_ = (GtkExpander*) gtk_expander_new_with_mnemonic (_tmp26_);
#line 45 "../src/dialogs/message.vala"
		g_object_ref_sink (_tmp27_);
#line 45 "../src/dialogs/message.vala"
		expander = _tmp27_;
#line 46 "../src/dialogs/message.vala"
		_tmp28_ = expander;
#line 46 "../src/dialogs/message.vala"
		_tmp29_ = sw;
#line 46 "../src/dialogs/message.vala"
		gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 47 "../src/dialogs/message.vala"
		_tmp30_ = expander;
#line 47 "../src/dialogs/message.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp30_);
#line 49 "../src/dialogs/message.vala"
		_tmp31_ = expander;
#line 49 "../src/dialogs/message.vala"
		dialogs_base_add_content ((DialogsBase*) self, (GtkWidget*) _tmp31_);
#line 24 "../src/dialogs/message.vala"
		_g_object_unref0 (expander);
#line 24 "../src/dialogs/message.vala"
		_g_object_unref0 (sw);
#line 24 "../src/dialogs/message.vala"
		_g_object_unref0 (buffer);
#line 24 "../src/dialogs/message.vala"
		_g_object_unref0 (textview);
#line 320 "message.c"
	}
#line 52 "../src/dialogs/message.vala"
	gtk_dialog_run ((GtkDialog*) self);
#line 17 "../src/dialogs/message.vala"
	_g_object_unref0 (close_but);
#line 17 "../src/dialogs/message.vala"
	return self;
#line 328 "message.c"
}

DialogsMessage*
dialogs_message_new (GtkWindow* parent,
                     const gchar* header_text,
                     const gchar* message_text,
                     GtkMessageType _message_type,
                     const gchar* output)
{
#line 17 "../src/dialogs/message.vala"
	return dialogs_message_construct (DIALOGS_TYPE_MESSAGE, parent, header_text, message_text, _message_type, output);
#line 340 "message.c"
}

static void
dialogs_message_class_init (DialogsMessageClass * klass,
                            gpointer klass_data)
{
#line 15 "../src/dialogs/message.vala"
	dialogs_message_parent_class = g_type_class_peek_parent (klass);
#line 349 "message.c"
}

static void
dialogs_message_instance_init (DialogsMessage * self,
                               gpointer klass)
{
}

static GType
dialogs_message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DialogsMessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialogs_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogsMessage), 0, (GInstanceInitFunc) dialogs_message_instance_init, NULL };
	GType dialogs_message_type_id;
	dialogs_message_type_id = g_type_register_static (DIALOGS_TYPE_BASE, "DialogsMessage", &g_define_type_info, 0);
	return dialogs_message_type_id;
}

GType
dialogs_message_get_type (void)
{
	static volatile gsize dialogs_message_type_id__once = 0;
	if (g_once_init_enter (&dialogs_message_type_id__once)) {
		GType dialogs_message_type_id;
		dialogs_message_type_id = dialogs_message_get_type_once ();
		g_once_init_leave (&dialogs_message_type_id__once, dialogs_message_type_id);
	}
	return dialogs_message_type_id__once;
}

