/* global-actions.c generated by valac 0.56.7, the Vala compiler
 * generated from global-actions.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2021 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define SETTINGS_schema_base_id "com.github.ztefn.haguichi"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GLOBAL_ACTIONS (global_actions_get_type ())
#define GLOBAL_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GLOBAL_ACTIONS, GlobalActions))
#define GLOBAL_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GLOBAL_ACTIONS, GlobalActionsClass))
#define IS_GLOBAL_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GLOBAL_ACTIONS))
#define IS_GLOBAL_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GLOBAL_ACTIONS))
#define GLOBAL_ACTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GLOBAL_ACTIONS, GlobalActionsClass))

typedef struct _GlobalActions GlobalActions;
typedef struct _GlobalActionsClass GlobalActionsClass;
typedef struct _GlobalActionsPrivate GlobalActionsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;
typedef struct _KeyPrivate KeyPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecGlobalActions ParamSpecGlobalActions;

struct _GlobalActions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GlobalActionsPrivate * priv;
};

struct _GlobalActionsClass {
	GTypeClass parent_class;
	void (*finalize) (GlobalActions *self);
};

struct _Key {
	GObject parent_instance;
	KeyPrivate * priv;
	gchar* parent;
	gchar* key_name;
};

struct _KeyClass {
	GObjectClass parent_class;
};

struct _ParamSpecGlobalActions {
	GParamSpec parent_instance;
};

static gpointer global_actions_parent_class = NULL;
VALA_EXTERN GSimpleAction* global_actions_connect;
GSimpleAction* global_actions_connect = NULL;
VALA_EXTERN GSimpleAction* global_actions_disconnect;
GSimpleAction* global_actions_disconnect = NULL;
VALA_EXTERN GSimpleAction* global_actions_approve_reject;
GSimpleAction* global_actions_approve_reject = NULL;
VALA_EXTERN GSimpleAction* global_actions_join_network;
GSimpleAction* global_actions_join_network = NULL;
VALA_EXTERN GSimpleAction* global_actions_create_network;
GSimpleAction* global_actions_create_network = NULL;
VALA_EXTERN GSimpleAction* global_actions_refresh;
GSimpleAction* global_actions_refresh = NULL;
VALA_EXTERN GSimpleAction* global_actions_start_search;
GSimpleAction* global_actions_start_search = NULL;
VALA_EXTERN GSimpleAction* global_actions_stop_search;
GSimpleAction* global_actions_stop_search = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_ipv4;
GSimpleAction* global_actions_copy_ipv4 = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_ipv6;
GSimpleAction* global_actions_copy_ipv6 = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_id;
GSimpleAction* global_actions_copy_id = NULL;
VALA_EXTERN GSimpleAction* global_actions_change_nick;
GSimpleAction* global_actions_change_nick = NULL;
VALA_EXTERN GSimpleAction* global_actions_open_config;
GSimpleAction* global_actions_open_config = NULL;
VALA_EXTERN GSimpleAction* global_actions_save_config;
GSimpleAction* global_actions_save_config = NULL;
VALA_EXTERN GSimpleAction* global_actions_restore_config;
GSimpleAction* global_actions_restore_config = NULL;
VALA_EXTERN GAction* global_actions_sort_by;
GAction* global_actions_sort_by = NULL;
VALA_EXTERN GAction* global_actions_show_offline;
GAction* global_actions_show_offline = NULL;
VALA_EXTERN GSimpleAction* global_actions_preferences;
GSimpleAction* global_actions_preferences = NULL;
VALA_EXTERN GSimpleAction* global_actions_info;
GSimpleAction* global_actions_info = NULL;
VALA_EXTERN GSimpleAction* global_actions_shortcuts;
GSimpleAction* global_actions_shortcuts = NULL;
VALA_EXTERN GSimpleAction* global_actions_help;
GSimpleAction* global_actions_help = NULL;
VALA_EXTERN GSimpleAction* global_actions_about;
GSimpleAction* global_actions_about = NULL;
VALA_EXTERN GSimpleAction* global_actions_quit;
GSimpleAction* global_actions_quit = NULL;
VALA_EXTERN gint controller_last_status;
VALA_EXTERN Key* settings_sort_network_list_by;
VALA_EXTERN Key* settings_show_offline_members;

VALA_EXTERN gpointer global_actions_ref (gpointer instance);
VALA_EXTERN void global_actions_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_global_actions (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_global_actions (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_global_actions (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_global_actions (const GValue* value);
VALA_EXTERN GType global_actions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GlobalActions, global_actions_unref)
VALA_EXTERN void global_actions_init (GtkApplication* app);
VALA_EXTERN void global_events_start_hamachi (void);
static void _global_events_start_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
VALA_EXTERN void global_events_stop_hamachi (void);
static void _global_events_stop_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
static void __lambda80_ (GVariant* variant);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void global_events_approve_or_reject (const gchar* action,
                                      const gchar* client_id,
                                      gchar** network_ids,
                                      gint network_ids_length1);
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static void ___lambda80__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void global_events_join_network (void);
static void _global_events_join_network_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
VALA_EXTERN void global_events_create_network (void);
static void _global_events_create_network_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self);
static void __lambda81_ (void);
VALA_EXTERN void controller_init (void);
VALA_EXTERN void controller_update_connection (void);
static void ___lambda81__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void global_events_start_search (void);
static void _global_events_start_search_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
VALA_EXTERN void global_events_stop_search (void);
static void _global_events_stop_search_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_copy_ipv4_to_clipboard (void);
static void _global_events_copy_ipv4_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void global_events_copy_ipv6_to_clipboard (void);
static void _global_events_copy_ipv6_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void global_events_copy_client_id_to_clipboard (void);
static void _global_events_copy_client_id_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                          GVariant* parameter,
                                                                          gpointer self);
VALA_EXTERN void global_events_change_nick (void);
static void _global_events_change_nick_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_open_config (void);
static void _global_events_open_config_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_save_config (void);
static void _global_events_save_config_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_restore_config (void);
static void _global_events_restore_config_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self);
VALA_EXTERN GType key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
VALA_EXTERN void global_events_preferences (void);
static void _global_events_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_information (void);
static void _global_events_information_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_shortcuts (void);
static void _global_events_shortcuts_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self);
VALA_EXTERN void global_events_help (void);
static void _global_events_help_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self);
VALA_EXTERN void global_events_about (void);
static void _global_events_about_g_simple_action_activate (GSimpleAction* _sender,
                                                    GVariant* parameter,
                                                    gpointer self);
VALA_EXTERN void global_events_quit_app (void);
static void _global_events_quit_app_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self);
VALA_EXTERN GlobalActions* global_actions_new (void);
VALA_EXTERN GlobalActions* global_actions_construct (GType object_type);
static void global_actions_finalize (GlobalActions * obj);
static GType global_actions_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static void
_global_events_start_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 49 "../src/global-actions.vala"
	global_events_start_hamachi ();
#line 280 "global-actions.c"
}

static void
_global_events_stop_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 52 "../src/global-actions.vala"
	global_events_stop_hamachi ();
#line 290 "global-actions.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 57 "../src/global-actions.vala"
	if (length >= 0) {
#line 299 "global-actions.c"
		gchar** result;
		gssize i;
#line 57 "../src/global-actions.vala"
		result = g_new0 (gchar*, length + 1);
#line 57 "../src/global-actions.vala"
		for (i = 0; i < length; i++) {
#line 306 "global-actions.c"
			gchar* _tmp0_;
#line 57 "../src/global-actions.vala"
			_tmp0_ = g_strdup (self[i]);
#line 57 "../src/global-actions.vala"
			result[i] = _tmp0_;
#line 312 "global-actions.c"
		}
#line 57 "../src/global-actions.vala"
		return result;
#line 316 "global-actions.c"
	}
#line 57 "../src/global-actions.vala"
	return NULL;
#line 320 "global-actions.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 65 "../src/global-actions.vala"
	if ((*length) == (*size)) {
#line 65 "../src/global-actions.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 65 "../src/global-actions.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 335 "global-actions.c"
	}
#line 65 "../src/global-actions.vala"
	(*array)[(*length)++] = value;
#line 65 "../src/global-actions.vala"
	(*array)[*length] = NULL;
#line 341 "global-actions.c"
}

static void
__lambda80_ (GVariant* variant)
{
	gchar** args = NULL;
	gsize _tmp0_ = 0;
	const gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 57 "../src/global-actions.vala"
	_tmp1_ = g_variant_get_strv (variant, &_tmp0_);
#line 57 "../src/global-actions.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp0_) : _tmp1_;
#line 57 "../src/global-actions.vala"
	_tmp2__length1 = _tmp0_;
#line 57 "../src/global-actions.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 57 "../src/global-actions.vala"
	args = _tmp2_;
#line 57 "../src/global-actions.vala"
	args_length1 = _tmp2__length1;
#line 57 "../src/global-actions.vala"
	_args_size_ = args_length1;
#line 59 "../src/global-actions.vala"
	_tmp3_ = args;
#line 59 "../src/global-actions.vala"
	_tmp3__length1 = args_length1;
#line 59 "../src/global-actions.vala"
	if (_tmp3__length1 > 2) {
#line 376 "global-actions.c"
		gchar** network_ids = NULL;
		gchar** _tmp4_;
		gint network_ids_length1;
		gint _network_ids_size_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 61 "../src/global-actions.vala"
		_tmp4_ = g_new0 (gchar*, 0 + 1);
#line 61 "../src/global-actions.vala"
		network_ids = _tmp4_;
#line 61 "../src/global-actions.vala"
		network_ids_length1 = 0;
#line 61 "../src/global-actions.vala"
		_network_ids_size_ = network_ids_length1;
#line 397 "global-actions.c"
		{
			gint i = 0;
#line 63 "../src/global-actions.vala"
			i = 2;
#line 402 "global-actions.c"
			{
				gboolean _tmp5_ = FALSE;
#line 63 "../src/global-actions.vala"
				_tmp5_ = TRUE;
#line 63 "../src/global-actions.vala"
				while (TRUE) {
#line 409 "global-actions.c"
					gchar** _tmp7_;
					gint _tmp7__length1;
					gchar** _tmp8_;
					gint _tmp8__length1;
					const gchar* _tmp9_;
					gchar* _tmp10_;
#line 63 "../src/global-actions.vala"
					if (!_tmp5_) {
#line 418 "global-actions.c"
						gint _tmp6_;
#line 63 "../src/global-actions.vala"
						_tmp6_ = i;
#line 63 "../src/global-actions.vala"
						i = _tmp6_ + 1;
#line 424 "global-actions.c"
					}
#line 63 "../src/global-actions.vala"
					_tmp5_ = FALSE;
#line 63 "../src/global-actions.vala"
					_tmp7_ = args;
#line 63 "../src/global-actions.vala"
					_tmp7__length1 = args_length1;
#line 63 "../src/global-actions.vala"
					if (!(i < _tmp7__length1)) {
#line 63 "../src/global-actions.vala"
						break;
#line 436 "global-actions.c"
					}
#line 65 "../src/global-actions.vala"
					_tmp8_ = args;
#line 65 "../src/global-actions.vala"
					_tmp8__length1 = args_length1;
#line 65 "../src/global-actions.vala"
					_tmp9_ = _tmp8_[i];
#line 65 "../src/global-actions.vala"
					_tmp10_ = g_strdup (_tmp9_);
#line 65 "../src/global-actions.vala"
					_vala_array_add4 (&network_ids, &network_ids_length1, &_network_ids_size_, _tmp10_);
#line 448 "global-actions.c"
				}
			}
		}
#line 68 "../src/global-actions.vala"
		_tmp11_ = args;
#line 68 "../src/global-actions.vala"
		_tmp11__length1 = args_length1;
#line 68 "../src/global-actions.vala"
		_tmp12_ = _tmp11_[0];
#line 68 "../src/global-actions.vala"
		_tmp13_ = args;
#line 68 "../src/global-actions.vala"
		_tmp13__length1 = args_length1;
#line 68 "../src/global-actions.vala"
		_tmp14_ = _tmp13_[1];
#line 68 "../src/global-actions.vala"
		_tmp15_ = network_ids;
#line 68 "../src/global-actions.vala"
		_tmp15__length1 = network_ids_length1;
#line 68 "../src/global-actions.vala"
		global_events_approve_or_reject (_tmp12_, _tmp14_, _tmp15_, (gint) _tmp15__length1);
#line 59 "../src/global-actions.vala"
		network_ids = (_vala_array_free (network_ids, network_ids_length1, (GDestroyNotify) g_free), NULL);
#line 472 "global-actions.c"
	} else {
#line 72 "../src/global-actions.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "GlobalActions.approve_reject", "Too few arguments, expected \"action, client_id, network_id1, network_" \
"id2, ...\"");
#line 476 "global-actions.c"
	}
#line 55 "../src/global-actions.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 480 "global-actions.c"
}

static void
___lambda80__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 55 "../src/global-actions.vala"
	__lambda80_ (parameter);
#line 490 "global-actions.c"
}

static void
_global_events_join_network_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 77 "../src/global-actions.vala"
	global_events_join_network ();
#line 500 "global-actions.c"
}

static void
_global_events_create_network_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 80 "../src/global-actions.vala"
	global_events_create_network ();
#line 510 "global-actions.c"
}

static void
__lambda81_ (void)
{
#line 85 "../src/global-actions.vala"
	if (controller_last_status <= 1) {
#line 87 "../src/global-actions.vala"
		controller_init ();
#line 520 "global-actions.c"
	}
#line 89 "../src/global-actions.vala"
	if (controller_last_status >= 6) {
#line 91 "../src/global-actions.vala"
		controller_update_connection ();
#line 526 "global-actions.c"
	}
}

static void
___lambda81__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 83 "../src/global-actions.vala"
	__lambda81_ ();
#line 537 "global-actions.c"
}

static void
_global_events_start_search_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 96 "../src/global-actions.vala"
	global_events_start_search ();
#line 547 "global-actions.c"
}

static void
_global_events_stop_search_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 99 "../src/global-actions.vala"
	global_events_stop_search ();
#line 557 "global-actions.c"
}

static void
_global_events_copy_ipv4_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 102 "../src/global-actions.vala"
	global_events_copy_ipv4_to_clipboard ();
#line 567 "global-actions.c"
}

static void
_global_events_copy_ipv6_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 105 "../src/global-actions.vala"
	global_events_copy_ipv6_to_clipboard ();
#line 577 "global-actions.c"
}

static void
_global_events_copy_client_id_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 108 "../src/global-actions.vala"
	global_events_copy_client_id_to_clipboard ();
#line 587 "global-actions.c"
}

static void
_global_events_change_nick_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 111 "../src/global-actions.vala"
	global_events_change_nick ();
#line 597 "global-actions.c"
}

static void
_global_events_open_config_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 114 "../src/global-actions.vala"
	global_events_open_config ();
#line 607 "global-actions.c"
}

static void
_global_events_save_config_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 117 "../src/global-actions.vala"
	global_events_save_config ();
#line 617 "global-actions.c"
}

static void
_global_events_restore_config_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 120 "../src/global-actions.vala"
	global_events_restore_config ();
#line 627 "global-actions.c"
}

static void
_global_events_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 127 "../src/global-actions.vala"
	global_events_preferences ();
#line 637 "global-actions.c"
}

static void
_global_events_information_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 130 "../src/global-actions.vala"
	global_events_information ();
#line 647 "global-actions.c"
}

static void
_global_events_shortcuts_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self)
{
#line 133 "../src/global-actions.vala"
	global_events_shortcuts ();
#line 657 "global-actions.c"
}

static void
_global_events_help_g_simple_action_activate (GSimpleAction* _sender,
                                              GVariant* parameter,
                                              gpointer self)
{
#line 136 "../src/global-actions.vala"
	global_events_help ();
#line 667 "global-actions.c"
}

static void
_global_events_about_g_simple_action_activate (GSimpleAction* _sender,
                                               GVariant* parameter,
                                               gpointer self)
{
#line 139 "../src/global-actions.vala"
	global_events_about ();
#line 677 "global-actions.c"
}

static void
_global_events_quit_app_g_simple_action_activate (GSimpleAction* _sender,
                                                  GVariant* parameter,
                                                  gpointer self)
{
#line 142 "../src/global-actions.vala"
	global_events_quit_app ();
#line 687 "global-actions.c"
}

void
global_actions_init (GtkApplication* app)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	const GVariantType* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
	GSimpleAction* _tmp20_;
	GSimpleAction* _tmp21_;
	GSimpleAction* _tmp22_;
	GSimpleAction* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GSimpleAction* _tmp26_;
	GSimpleAction* _tmp27_;
	GSimpleAction* _tmp28_;
	GSimpleAction* _tmp29_;
	GSimpleAction* _tmp30_;
	Key* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GSettings* _tmp35_;
	GSettings* _tmp36_;
	Key* _tmp37_;
	const gchar* _tmp38_;
	GAction* _tmp39_;
	Key* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GSettings* _tmp44_;
	GSettings* _tmp45_;
	Key* _tmp46_;
	const gchar* _tmp47_;
	GAction* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	GSimpleAction* _tmp51_;
	GSimpleAction* _tmp52_;
	GSimpleAction* _tmp53_;
	GSimpleAction* _tmp54_;
	GSimpleAction* _tmp55_;
	GSimpleAction* _tmp56_;
	GSimpleAction* _tmp57_;
	GSimpleAction* _tmp58_;
	GSimpleAction* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleAction* _tmp61_;
	GSimpleAction* _tmp62_;
	GSimpleAction* _tmp63_;
	GSimpleAction* _tmp64_;
	GSimpleAction* _tmp65_;
	GSimpleAction* _tmp66_;
	GSimpleAction* _tmp67_;
	GSimpleAction* _tmp68_;
	GSimpleAction* _tmp69_;
	GSimpleAction* _tmp70_;
	GSimpleAction* _tmp71_;
	GSimpleAction* _tmp72_;
	GSimpleAction* _tmp73_;
	GSimpleAction* _tmp74_;
	GSimpleAction* _tmp75_;
	GAction* _tmp76_;
	GAction* _tmp77_;
	GSimpleAction* _tmp78_;
	GSimpleAction* _tmp79_;
	GSimpleAction* _tmp80_;
	GSimpleAction* _tmp81_;
	GSimpleAction* _tmp82_;
	GSimpleAction* _tmp83_;
	gchar* _tmp84_;
	gchar** _tmp85_;
	gchar** _tmp86_;
	gint _tmp86__length1;
	gchar* _tmp87_;
	gchar** _tmp88_;
	gchar** _tmp89_;
	gint _tmp89__length1;
	gchar* _tmp90_;
	gchar** _tmp91_;
	gchar** _tmp92_;
	gint _tmp92__length1;
	gchar* _tmp93_;
	gchar** _tmp94_;
	gchar** _tmp95_;
	gint _tmp95__length1;
	gchar* _tmp96_;
	gchar* _tmp97_;
	gchar** _tmp98_;
	gchar** _tmp99_;
	gint _tmp99__length1;
	gchar* _tmp100_;
	gchar** _tmp101_;
	gchar** _tmp102_;
	gint _tmp102__length1;
	Key* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	gchar** _tmp108_;
	gchar** _tmp109_;
	gint _tmp109__length1;
	gchar* _tmp110_;
	gchar** _tmp111_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	gchar* _tmp113_;
	gchar** _tmp114_;
	gchar** _tmp115_;
	gint _tmp115__length1;
	gchar* _tmp116_;
	gchar** _tmp117_;
	gchar** _tmp118_;
	gint _tmp118__length1;
	gchar* _tmp119_;
	gchar** _tmp120_;
	gchar** _tmp121_;
	gint _tmp121__length1;
	gchar* _tmp122_;
	gchar** _tmp123_;
	gchar** _tmp124_;
	gint _tmp124__length1;
#line 46 "../src/global-actions.vala"
	g_return_if_fail (app != NULL);
#line 48 "../src/global-actions.vala"
	_tmp0_ = g_simple_action_new ("connect", NULL);
#line 48 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_connect);
#line 48 "../src/global-actions.vala"
	global_actions_connect = _tmp0_;
#line 49 "../src/global-actions.vala"
	_tmp1_ = global_actions_connect;
#line 49 "../src/global-actions.vala"
	g_signal_connect (_tmp1_, "activate", (GCallback) _global_events_start_hamachi_g_simple_action_activate, NULL);
#line 51 "../src/global-actions.vala"
	_tmp2_ = g_simple_action_new ("disconnect", NULL);
#line 51 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_disconnect);
#line 51 "../src/global-actions.vala"
	global_actions_disconnect = _tmp2_;
#line 52 "../src/global-actions.vala"
	_tmp3_ = global_actions_disconnect;
#line 52 "../src/global-actions.vala"
	g_signal_connect (_tmp3_, "activate", (GCallback) _global_events_stop_hamachi_g_simple_action_activate, NULL);
#line 54 "../src/global-actions.vala"
	_tmp4_ = G_VARIANT_TYPE_STRING_ARRAY;
#line 54 "../src/global-actions.vala"
	_tmp5_ = g_simple_action_new ("approve-reject", _tmp4_);
#line 54 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_approve_reject);
#line 54 "../src/global-actions.vala"
	global_actions_approve_reject = _tmp5_;
#line 55 "../src/global-actions.vala"
	_tmp6_ = global_actions_approve_reject;
#line 55 "../src/global-actions.vala"
	g_signal_connect (_tmp6_, "activate", (GCallback) ___lambda80__g_simple_action_activate, NULL);
#line 76 "../src/global-actions.vala"
	_tmp7_ = g_simple_action_new ("join-network", NULL);
#line 76 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_join_network);
#line 76 "../src/global-actions.vala"
	global_actions_join_network = _tmp7_;
#line 77 "../src/global-actions.vala"
	_tmp8_ = global_actions_join_network;
#line 77 "../src/global-actions.vala"
	g_signal_connect (_tmp8_, "activate", (GCallback) _global_events_join_network_g_simple_action_activate, NULL);
#line 79 "../src/global-actions.vala"
	_tmp9_ = g_simple_action_new ("create-network", NULL);
#line 79 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_create_network);
#line 79 "../src/global-actions.vala"
	global_actions_create_network = _tmp9_;
#line 80 "../src/global-actions.vala"
	_tmp10_ = global_actions_create_network;
#line 80 "../src/global-actions.vala"
	g_signal_connect (_tmp10_, "activate", (GCallback) _global_events_create_network_g_simple_action_activate, NULL);
#line 82 "../src/global-actions.vala"
	_tmp11_ = g_simple_action_new ("refresh", NULL);
#line 82 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_refresh);
#line 82 "../src/global-actions.vala"
	global_actions_refresh = _tmp11_;
#line 83 "../src/global-actions.vala"
	_tmp12_ = global_actions_refresh;
#line 83 "../src/global-actions.vala"
	g_signal_connect (_tmp12_, "activate", (GCallback) ___lambda81__g_simple_action_activate, NULL);
#line 95 "../src/global-actions.vala"
	_tmp13_ = g_simple_action_new ("start-search", NULL);
#line 95 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_start_search);
#line 95 "../src/global-actions.vala"
	global_actions_start_search = _tmp13_;
#line 96 "../src/global-actions.vala"
	_tmp14_ = global_actions_start_search;
#line 96 "../src/global-actions.vala"
	g_signal_connect (_tmp14_, "activate", (GCallback) _global_events_start_search_g_simple_action_activate, NULL);
#line 98 "../src/global-actions.vala"
	_tmp15_ = g_simple_action_new ("stop-search", NULL);
#line 98 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_stop_search);
#line 98 "../src/global-actions.vala"
	global_actions_stop_search = _tmp15_;
#line 99 "../src/global-actions.vala"
	_tmp16_ = global_actions_stop_search;
#line 99 "../src/global-actions.vala"
	g_signal_connect (_tmp16_, "activate", (GCallback) _global_events_stop_search_g_simple_action_activate, NULL);
#line 101 "../src/global-actions.vala"
	_tmp17_ = g_simple_action_new ("copy-ipv4", NULL);
#line 101 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_copy_ipv4);
#line 101 "../src/global-actions.vala"
	global_actions_copy_ipv4 = _tmp17_;
#line 102 "../src/global-actions.vala"
	_tmp18_ = global_actions_copy_ipv4;
#line 102 "../src/global-actions.vala"
	g_signal_connect (_tmp18_, "activate", (GCallback) _global_events_copy_ipv4_to_clipboard_g_simple_action_activate, NULL);
#line 104 "../src/global-actions.vala"
	_tmp19_ = g_simple_action_new ("copy-ipv6", NULL);
#line 104 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_copy_ipv6);
#line 104 "../src/global-actions.vala"
	global_actions_copy_ipv6 = _tmp19_;
#line 105 "../src/global-actions.vala"
	_tmp20_ = global_actions_copy_ipv6;
#line 105 "../src/global-actions.vala"
	g_signal_connect (_tmp20_, "activate", (GCallback) _global_events_copy_ipv6_to_clipboard_g_simple_action_activate, NULL);
#line 107 "../src/global-actions.vala"
	_tmp21_ = g_simple_action_new ("copy-id", NULL);
#line 107 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_copy_id);
#line 107 "../src/global-actions.vala"
	global_actions_copy_id = _tmp21_;
#line 108 "../src/global-actions.vala"
	_tmp22_ = global_actions_copy_id;
#line 108 "../src/global-actions.vala"
	g_signal_connect (_tmp22_, "activate", (GCallback) _global_events_copy_client_id_to_clipboard_g_simple_action_activate, NULL);
#line 110 "../src/global-actions.vala"
	_tmp23_ = g_simple_action_new ("change-nick", NULL);
#line 110 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_change_nick);
#line 110 "../src/global-actions.vala"
	global_actions_change_nick = _tmp23_;
#line 111 "../src/global-actions.vala"
	_tmp24_ = global_actions_change_nick;
#line 111 "../src/global-actions.vala"
	g_signal_connect (_tmp24_, "activate", (GCallback) _global_events_change_nick_g_simple_action_activate, NULL);
#line 113 "../src/global-actions.vala"
	_tmp25_ = g_simple_action_new ("open-config", NULL);
#line 113 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_open_config);
#line 113 "../src/global-actions.vala"
	global_actions_open_config = _tmp25_;
#line 114 "../src/global-actions.vala"
	_tmp26_ = global_actions_open_config;
#line 114 "../src/global-actions.vala"
	g_signal_connect (_tmp26_, "activate", (GCallback) _global_events_open_config_g_simple_action_activate, NULL);
#line 116 "../src/global-actions.vala"
	_tmp27_ = g_simple_action_new ("save-config", NULL);
#line 116 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_save_config);
#line 116 "../src/global-actions.vala"
	global_actions_save_config = _tmp27_;
#line 117 "../src/global-actions.vala"
	_tmp28_ = global_actions_save_config;
#line 117 "../src/global-actions.vala"
	g_signal_connect (_tmp28_, "activate", (GCallback) _global_events_save_config_g_simple_action_activate, NULL);
#line 119 "../src/global-actions.vala"
	_tmp29_ = g_simple_action_new ("restore-config", NULL);
#line 119 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_restore_config);
#line 119 "../src/global-actions.vala"
	global_actions_restore_config = _tmp29_;
#line 120 "../src/global-actions.vala"
	_tmp30_ = global_actions_restore_config;
#line 120 "../src/global-actions.vala"
	g_signal_connect (_tmp30_, "activate", (GCallback) _global_events_restore_config_g_simple_action_activate, NULL);
#line 122 "../src/global-actions.vala"
	_tmp31_ = settings_sort_network_list_by;
#line 122 "../src/global-actions.vala"
	_tmp32_ = _tmp31_->parent;
#line 122 "../src/global-actions.vala"
	_tmp33_ = g_strconcat (SETTINGS_schema_base_id ".", _tmp32_, NULL);
#line 122 "../src/global-actions.vala"
	_tmp34_ = _tmp33_;
#line 122 "../src/global-actions.vala"
	_tmp35_ = g_settings_new (_tmp34_);
#line 122 "../src/global-actions.vala"
	_tmp36_ = _tmp35_;
#line 122 "../src/global-actions.vala"
	_tmp37_ = settings_sort_network_list_by;
#line 122 "../src/global-actions.vala"
	_tmp38_ = _tmp37_->key_name;
#line 122 "../src/global-actions.vala"
	_tmp39_ = g_settings_create_action (_tmp36_, _tmp38_);
#line 122 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_sort_by);
#line 122 "../src/global-actions.vala"
	global_actions_sort_by = _tmp39_;
#line 122 "../src/global-actions.vala"
	_g_object_unref0 (_tmp36_);
#line 122 "../src/global-actions.vala"
	_g_free0 (_tmp34_);
#line 124 "../src/global-actions.vala"
	_tmp40_ = settings_show_offline_members;
#line 124 "../src/global-actions.vala"
	_tmp41_ = _tmp40_->parent;
#line 124 "../src/global-actions.vala"
	_tmp42_ = g_strconcat (SETTINGS_schema_base_id ".", _tmp41_, NULL);
#line 124 "../src/global-actions.vala"
	_tmp43_ = _tmp42_;
#line 124 "../src/global-actions.vala"
	_tmp44_ = g_settings_new (_tmp43_);
#line 124 "../src/global-actions.vala"
	_tmp45_ = _tmp44_;
#line 124 "../src/global-actions.vala"
	_tmp46_ = settings_show_offline_members;
#line 124 "../src/global-actions.vala"
	_tmp47_ = _tmp46_->key_name;
#line 124 "../src/global-actions.vala"
	_tmp48_ = g_settings_create_action (_tmp45_, _tmp47_);
#line 124 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_show_offline);
#line 124 "../src/global-actions.vala"
	global_actions_show_offline = _tmp48_;
#line 124 "../src/global-actions.vala"
	_g_object_unref0 (_tmp45_);
#line 124 "../src/global-actions.vala"
	_g_free0 (_tmp43_);
#line 126 "../src/global-actions.vala"
	_tmp49_ = g_simple_action_new ("preferences", NULL);
#line 126 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_preferences);
#line 126 "../src/global-actions.vala"
	global_actions_preferences = _tmp49_;
#line 127 "../src/global-actions.vala"
	_tmp50_ = global_actions_preferences;
#line 127 "../src/global-actions.vala"
	g_signal_connect (_tmp50_, "activate", (GCallback) _global_events_preferences_g_simple_action_activate, NULL);
#line 129 "../src/global-actions.vala"
	_tmp51_ = g_simple_action_new ("info", NULL);
#line 129 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_info);
#line 129 "../src/global-actions.vala"
	global_actions_info = _tmp51_;
#line 130 "../src/global-actions.vala"
	_tmp52_ = global_actions_info;
#line 130 "../src/global-actions.vala"
	g_signal_connect (_tmp52_, "activate", (GCallback) _global_events_information_g_simple_action_activate, NULL);
#line 132 "../src/global-actions.vala"
	_tmp53_ = g_simple_action_new ("shortcuts", NULL);
#line 132 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_shortcuts);
#line 132 "../src/global-actions.vala"
	global_actions_shortcuts = _tmp53_;
#line 133 "../src/global-actions.vala"
	_tmp54_ = global_actions_shortcuts;
#line 133 "../src/global-actions.vala"
	g_signal_connect (_tmp54_, "activate", (GCallback) _global_events_shortcuts_g_simple_action_activate, NULL);
#line 135 "../src/global-actions.vala"
	_tmp55_ = g_simple_action_new ("help", NULL);
#line 135 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_help);
#line 135 "../src/global-actions.vala"
	global_actions_help = _tmp55_;
#line 136 "../src/global-actions.vala"
	_tmp56_ = global_actions_help;
#line 136 "../src/global-actions.vala"
	g_signal_connect (_tmp56_, "activate", (GCallback) _global_events_help_g_simple_action_activate, NULL);
#line 138 "../src/global-actions.vala"
	_tmp57_ = g_simple_action_new ("about", NULL);
#line 138 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_about);
#line 138 "../src/global-actions.vala"
	global_actions_about = _tmp57_;
#line 139 "../src/global-actions.vala"
	_tmp58_ = global_actions_about;
#line 139 "../src/global-actions.vala"
	g_signal_connect (_tmp58_, "activate", (GCallback) _global_events_about_g_simple_action_activate, NULL);
#line 141 "../src/global-actions.vala"
	_tmp59_ = g_simple_action_new ("quit", NULL);
#line 141 "../src/global-actions.vala"
	_g_object_unref0 (global_actions_quit);
#line 141 "../src/global-actions.vala"
	global_actions_quit = _tmp59_;
#line 142 "../src/global-actions.vala"
	_tmp60_ = global_actions_quit;
#line 142 "../src/global-actions.vala"
	g_signal_connect (_tmp60_, "activate", (GCallback) _global_events_quit_app_g_simple_action_activate, NULL);
#line 144 "../src/global-actions.vala"
	_tmp61_ = global_actions_connect;
#line 144 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp61_);
#line 145 "../src/global-actions.vala"
	_tmp62_ = global_actions_disconnect;
#line 145 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp62_);
#line 146 "../src/global-actions.vala"
	_tmp63_ = global_actions_approve_reject;
#line 146 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp63_);
#line 147 "../src/global-actions.vala"
	_tmp64_ = global_actions_join_network;
#line 147 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp64_);
#line 148 "../src/global-actions.vala"
	_tmp65_ = global_actions_create_network;
#line 148 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp65_);
#line 149 "../src/global-actions.vala"
	_tmp66_ = global_actions_refresh;
#line 149 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp66_);
#line 150 "../src/global-actions.vala"
	_tmp67_ = global_actions_start_search;
#line 150 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp67_);
#line 151 "../src/global-actions.vala"
	_tmp68_ = global_actions_stop_search;
#line 151 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp68_);
#line 152 "../src/global-actions.vala"
	_tmp69_ = global_actions_copy_ipv4;
#line 152 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp69_);
#line 153 "../src/global-actions.vala"
	_tmp70_ = global_actions_copy_ipv6;
#line 153 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp70_);
#line 154 "../src/global-actions.vala"
	_tmp71_ = global_actions_copy_id;
#line 154 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp71_);
#line 155 "../src/global-actions.vala"
	_tmp72_ = global_actions_change_nick;
#line 155 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp72_);
#line 156 "../src/global-actions.vala"
	_tmp73_ = global_actions_open_config;
#line 156 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp73_);
#line 157 "../src/global-actions.vala"
	_tmp74_ = global_actions_save_config;
#line 157 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp74_);
#line 158 "../src/global-actions.vala"
	_tmp75_ = global_actions_restore_config;
#line 158 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp75_);
#line 159 "../src/global-actions.vala"
	_tmp76_ = global_actions_sort_by;
#line 159 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, _tmp76_);
#line 160 "../src/global-actions.vala"
	_tmp77_ = global_actions_show_offline;
#line 160 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, _tmp77_);
#line 161 "../src/global-actions.vala"
	_tmp78_ = global_actions_preferences;
#line 161 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp78_);
#line 162 "../src/global-actions.vala"
	_tmp79_ = global_actions_shortcuts;
#line 162 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp79_);
#line 163 "../src/global-actions.vala"
	_tmp80_ = global_actions_info;
#line 163 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp80_);
#line 164 "../src/global-actions.vala"
	_tmp81_ = global_actions_help;
#line 164 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp81_);
#line 165 "../src/global-actions.vala"
	_tmp82_ = global_actions_about;
#line 165 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp82_);
#line 166 "../src/global-actions.vala"
	_tmp83_ = global_actions_quit;
#line 166 "../src/global-actions.vala"
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp83_);
#line 168 "../src/global-actions.vala"
	_tmp84_ = g_strdup ("<Control>O");
#line 168 "../src/global-actions.vala"
	_tmp85_ = g_new0 (gchar*, 1 + 1);
#line 168 "../src/global-actions.vala"
	_tmp85_[0] = _tmp84_;
#line 168 "../src/global-actions.vala"
	_tmp86_ = _tmp85_;
#line 168 "../src/global-actions.vala"
	_tmp86__length1 = 1;
#line 168 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.connect", _tmp86_);
#line 168 "../src/global-actions.vala"
	_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_free), NULL);
#line 169 "../src/global-actions.vala"
	_tmp87_ = g_strdup ("<Control>D");
#line 169 "../src/global-actions.vala"
	_tmp88_ = g_new0 (gchar*, 1 + 1);
#line 169 "../src/global-actions.vala"
	_tmp88_[0] = _tmp87_;
#line 169 "../src/global-actions.vala"
	_tmp89_ = _tmp88_;
#line 169 "../src/global-actions.vala"
	_tmp89__length1 = 1;
#line 169 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.disconnect", _tmp89_);
#line 169 "../src/global-actions.vala"
	_tmp89_ = (_vala_array_free (_tmp89_, _tmp89__length1, (GDestroyNotify) g_free), NULL);
#line 170 "../src/global-actions.vala"
	_tmp90_ = g_strdup ("<Control>J");
#line 170 "../src/global-actions.vala"
	_tmp91_ = g_new0 (gchar*, 1 + 1);
#line 170 "../src/global-actions.vala"
	_tmp91_[0] = _tmp90_;
#line 170 "../src/global-actions.vala"
	_tmp92_ = _tmp91_;
#line 170 "../src/global-actions.vala"
	_tmp92__length1 = 1;
#line 170 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.join-network", _tmp92_);
#line 170 "../src/global-actions.vala"
	_tmp92_ = (_vala_array_free (_tmp92_, _tmp92__length1, (GDestroyNotify) g_free), NULL);
#line 171 "../src/global-actions.vala"
	_tmp93_ = g_strdup ("<Control>N");
#line 171 "../src/global-actions.vala"
	_tmp94_ = g_new0 (gchar*, 1 + 1);
#line 171 "../src/global-actions.vala"
	_tmp94_[0] = _tmp93_;
#line 171 "../src/global-actions.vala"
	_tmp95_ = _tmp94_;
#line 171 "../src/global-actions.vala"
	_tmp95__length1 = 1;
#line 171 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.create-network", _tmp95_);
#line 171 "../src/global-actions.vala"
	_tmp95_ = (_vala_array_free (_tmp95_, _tmp95__length1, (GDestroyNotify) g_free), NULL);
#line 172 "../src/global-actions.vala"
	_tmp96_ = g_strdup ("F5");
#line 172 "../src/global-actions.vala"
	_tmp97_ = g_strdup ("<Control>R");
#line 172 "../src/global-actions.vala"
	_tmp98_ = g_new0 (gchar*, 2 + 1);
#line 172 "../src/global-actions.vala"
	_tmp98_[0] = _tmp96_;
#line 172 "../src/global-actions.vala"
	_tmp98_[1] = _tmp97_;
#line 172 "../src/global-actions.vala"
	_tmp99_ = _tmp98_;
#line 172 "../src/global-actions.vala"
	_tmp99__length1 = 2;
#line 172 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.refresh", _tmp99_);
#line 172 "../src/global-actions.vala"
	_tmp99_ = (_vala_array_free (_tmp99_, _tmp99__length1, (GDestroyNotify) g_free), NULL);
#line 173 "../src/global-actions.vala"
	_tmp100_ = g_strdup ("<Control>F");
#line 173 "../src/global-actions.vala"
	_tmp101_ = g_new0 (gchar*, 1 + 1);
#line 173 "../src/global-actions.vala"
	_tmp101_[0] = _tmp100_;
#line 173 "../src/global-actions.vala"
	_tmp102_ = _tmp101_;
#line 173 "../src/global-actions.vala"
	_tmp102__length1 = 1;
#line 173 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.start-search", _tmp102_);
#line 173 "../src/global-actions.vala"
	_tmp102_ = (_vala_array_free (_tmp102_, _tmp102__length1, (GDestroyNotify) g_free), NULL);
#line 174 "../src/global-actions.vala"
	_tmp103_ = settings_show_offline_members;
#line 174 "../src/global-actions.vala"
	_tmp104_ = _tmp103_->key_name;
#line 174 "../src/global-actions.vala"
	_tmp105_ = g_strconcat ("app.", _tmp104_, NULL);
#line 174 "../src/global-actions.vala"
	_tmp106_ = _tmp105_;
#line 174 "../src/global-actions.vala"
	_tmp107_ = g_strdup ("<Control>M");
#line 174 "../src/global-actions.vala"
	_tmp108_ = g_new0 (gchar*, 1 + 1);
#line 174 "../src/global-actions.vala"
	_tmp108_[0] = _tmp107_;
#line 174 "../src/global-actions.vala"
	_tmp109_ = _tmp108_;
#line 174 "../src/global-actions.vala"
	_tmp109__length1 = 1;
#line 174 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, _tmp106_, _tmp109_);
#line 174 "../src/global-actions.vala"
	_tmp109_ = (_vala_array_free (_tmp109_, _tmp109__length1, (GDestroyNotify) g_free), NULL);
#line 174 "../src/global-actions.vala"
	_g_free0 (_tmp106_);
#line 175 "../src/global-actions.vala"
	_tmp110_ = g_strdup ("<Control>P");
#line 175 "../src/global-actions.vala"
	_tmp111_ = g_new0 (gchar*, 1 + 1);
#line 175 "../src/global-actions.vala"
	_tmp111_[0] = _tmp110_;
#line 175 "../src/global-actions.vala"
	_tmp112_ = _tmp111_;
#line 175 "../src/global-actions.vala"
	_tmp112__length1 = 1;
#line 175 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.preferences", _tmp112_);
#line 175 "../src/global-actions.vala"
	_tmp112_ = (_vala_array_free (_tmp112_, _tmp112__length1, (GDestroyNotify) g_free), NULL);
#line 176 "../src/global-actions.vala"
	_tmp113_ = g_strdup ("<Control>question");
#line 176 "../src/global-actions.vala"
	_tmp114_ = g_new0 (gchar*, 1 + 1);
#line 176 "../src/global-actions.vala"
	_tmp114_[0] = _tmp113_;
#line 176 "../src/global-actions.vala"
	_tmp115_ = _tmp114_;
#line 176 "../src/global-actions.vala"
	_tmp115__length1 = 1;
#line 176 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.shortcuts", _tmp115_);
#line 176 "../src/global-actions.vala"
	_tmp115_ = (_vala_array_free (_tmp115_, _tmp115__length1, (GDestroyNotify) g_free), NULL);
#line 177 "../src/global-actions.vala"
	_tmp116_ = g_strdup ("F2");
#line 177 "../src/global-actions.vala"
	_tmp117_ = g_new0 (gchar*, 1 + 1);
#line 177 "../src/global-actions.vala"
	_tmp117_[0] = _tmp116_;
#line 177 "../src/global-actions.vala"
	_tmp118_ = _tmp117_;
#line 177 "../src/global-actions.vala"
	_tmp118__length1 = 1;
#line 177 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.info", _tmp118_);
#line 177 "../src/global-actions.vala"
	_tmp118_ = (_vala_array_free (_tmp118_, _tmp118__length1, (GDestroyNotify) g_free), NULL);
#line 178 "../src/global-actions.vala"
	_tmp119_ = g_strdup ("F1");
#line 178 "../src/global-actions.vala"
	_tmp120_ = g_new0 (gchar*, 1 + 1);
#line 178 "../src/global-actions.vala"
	_tmp120_[0] = _tmp119_;
#line 178 "../src/global-actions.vala"
	_tmp121_ = _tmp120_;
#line 178 "../src/global-actions.vala"
	_tmp121__length1 = 1;
#line 178 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.help", _tmp121_);
#line 178 "../src/global-actions.vala"
	_tmp121_ = (_vala_array_free (_tmp121_, _tmp121__length1, (GDestroyNotify) g_free), NULL);
#line 179 "../src/global-actions.vala"
	_tmp122_ = g_strdup ("<Control>Q");
#line 179 "../src/global-actions.vala"
	_tmp123_ = g_new0 (gchar*, 1 + 1);
#line 179 "../src/global-actions.vala"
	_tmp123_[0] = _tmp122_;
#line 179 "../src/global-actions.vala"
	_tmp124_ = _tmp123_;
#line 179 "../src/global-actions.vala"
	_tmp124__length1 = 1;
#line 179 "../src/global-actions.vala"
	gtk_application_set_accels_for_action (app, "app.quit", _tmp124_);
#line 179 "../src/global-actions.vala"
	_tmp124_ = (_vala_array_free (_tmp124_, _tmp124__length1, (GDestroyNotify) g_free), NULL);
#line 1370 "global-actions.c"
}

GlobalActions*
global_actions_construct (GType object_type)
{
	GlobalActions* self = NULL;
#line 11 "../src/global-actions.vala"
	self = (GlobalActions*) g_type_create_instance (object_type);
#line 11 "../src/global-actions.vala"
	return self;
#line 1381 "global-actions.c"
}

GlobalActions*
global_actions_new (void)
{
#line 11 "../src/global-actions.vala"
	return global_actions_construct (TYPE_GLOBAL_ACTIONS);
#line 1389 "global-actions.c"
}

static void
value_global_actions_init (GValue* value)
{
#line 11 "../src/global-actions.vala"
	value->data[0].v_pointer = NULL;
#line 1397 "global-actions.c"
}

static void
value_global_actions_free_value (GValue* value)
{
#line 11 "../src/global-actions.vala"
	if (value->data[0].v_pointer) {
#line 11 "../src/global-actions.vala"
		global_actions_unref (value->data[0].v_pointer);
#line 1407 "global-actions.c"
	}
}

static void
value_global_actions_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 11 "../src/global-actions.vala"
	if (src_value->data[0].v_pointer) {
#line 11 "../src/global-actions.vala"
		dest_value->data[0].v_pointer = global_actions_ref (src_value->data[0].v_pointer);
#line 1419 "global-actions.c"
	} else {
#line 11 "../src/global-actions.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1423 "global-actions.c"
	}
}

static gpointer
value_global_actions_peek_pointer (const GValue* value)
{
#line 11 "../src/global-actions.vala"
	return value->data[0].v_pointer;
#line 1432 "global-actions.c"
}

static gchar*
value_global_actions_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 11 "../src/global-actions.vala"
	if (collect_values[0].v_pointer) {
#line 1443 "global-actions.c"
		GlobalActions * object;
		object = collect_values[0].v_pointer;
#line 11 "../src/global-actions.vala"
		if (object->parent_instance.g_class == NULL) {
#line 11 "../src/global-actions.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1450 "global-actions.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 11 "../src/global-actions.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1454 "global-actions.c"
		}
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = global_actions_ref (object);
#line 1458 "global-actions.c"
	} else {
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = NULL;
#line 1462 "global-actions.c"
	}
#line 11 "../src/global-actions.vala"
	return NULL;
#line 1466 "global-actions.c"
}

static gchar*
value_global_actions_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	GlobalActions ** object_p;
	object_p = collect_values[0].v_pointer;
#line 11 "../src/global-actions.vala"
	if (!object_p) {
#line 11 "../src/global-actions.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1481 "global-actions.c"
	}
#line 11 "../src/global-actions.vala"
	if (!value->data[0].v_pointer) {
#line 11 "../src/global-actions.vala"
		*object_p = NULL;
#line 1487 "global-actions.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 11 "../src/global-actions.vala"
		*object_p = value->data[0].v_pointer;
#line 1491 "global-actions.c"
	} else {
#line 11 "../src/global-actions.vala"
		*object_p = global_actions_ref (value->data[0].v_pointer);
#line 1495 "global-actions.c"
	}
#line 11 "../src/global-actions.vala"
	return NULL;
#line 1499 "global-actions.c"
}

GParamSpec*
param_spec_global_actions (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecGlobalActions* spec;
#line 11 "../src/global-actions.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GLOBAL_ACTIONS), NULL);
#line 11 "../src/global-actions.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 11 "../src/global-actions.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 11 "../src/global-actions.vala"
	return G_PARAM_SPEC (spec);
#line 1518 "global-actions.c"
}

gpointer
value_get_global_actions (const GValue* value)
{
#line 11 "../src/global-actions.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS), NULL);
#line 11 "../src/global-actions.vala"
	return value->data[0].v_pointer;
#line 1528 "global-actions.c"
}

void
value_set_global_actions (GValue* value,
                          gpointer v_object)
{
	GlobalActions * old;
#line 11 "../src/global-actions.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS));
#line 11 "../src/global-actions.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/global-actions.vala"
	if (v_object) {
#line 11 "../src/global-actions.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GLOBAL_ACTIONS));
#line 11 "../src/global-actions.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = v_object;
#line 11 "../src/global-actions.vala"
		global_actions_ref (value->data[0].v_pointer);
#line 1550 "global-actions.c"
	} else {
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = NULL;
#line 1554 "global-actions.c"
	}
#line 11 "../src/global-actions.vala"
	if (old) {
#line 11 "../src/global-actions.vala"
		global_actions_unref (old);
#line 1560 "global-actions.c"
	}
}

void
value_take_global_actions (GValue* value,
                           gpointer v_object)
{
	GlobalActions * old;
#line 11 "../src/global-actions.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS));
#line 11 "../src/global-actions.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/global-actions.vala"
	if (v_object) {
#line 11 "../src/global-actions.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GLOBAL_ACTIONS));
#line 11 "../src/global-actions.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = v_object;
#line 1581 "global-actions.c"
	} else {
#line 11 "../src/global-actions.vala"
		value->data[0].v_pointer = NULL;
#line 1585 "global-actions.c"
	}
#line 11 "../src/global-actions.vala"
	if (old) {
#line 11 "../src/global-actions.vala"
		global_actions_unref (old);
#line 1591 "global-actions.c"
	}
}

static void
global_actions_class_init (GlobalActionsClass * klass,
                           gpointer klass_data)
{
#line 11 "../src/global-actions.vala"
	global_actions_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/global-actions.vala"
	((GlobalActionsClass *) klass)->finalize = global_actions_finalize;
#line 1603 "global-actions.c"
}

static void
global_actions_instance_init (GlobalActions * self,
                              gpointer klass)
{
#line 11 "../src/global-actions.vala"
	self->ref_count = 1;
#line 1612 "global-actions.c"
}

static void
global_actions_finalize (GlobalActions * obj)
{
	GlobalActions * self;
#line 11 "../src/global-actions.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GLOBAL_ACTIONS, GlobalActions);
#line 11 "../src/global-actions.vala"
	g_signal_handlers_destroy (self);
#line 1623 "global-actions.c"
}

static GType
global_actions_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_global_actions_init, value_global_actions_free_value, value_global_actions_copy_value, value_global_actions_peek_pointer, "p", value_global_actions_collect_value, "p", value_global_actions_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GlobalActionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) global_actions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GlobalActions), 0, (GInstanceInitFunc) global_actions_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType global_actions_type_id;
	global_actions_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GlobalActions", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return global_actions_type_id;
}

GType
global_actions_get_type (void)
{
	static volatile gsize global_actions_type_id__once = 0;
	if (g_once_init_enter (&global_actions_type_id__once)) {
		GType global_actions_type_id;
		global_actions_type_id = global_actions_get_type_once ();
		g_once_init_leave (&global_actions_type_id__once, global_actions_type_id);
	}
	return global_actions_type_id__once;
}

gpointer
global_actions_ref (gpointer instance)
{
	GlobalActions * self;
	self = instance;
#line 11 "../src/global-actions.vala"
	g_atomic_int_inc (&self->ref_count);
#line 11 "../src/global-actions.vala"
	return instance;
#line 1658 "global-actions.c"
}

void
global_actions_unref (gpointer instance)
{
	GlobalActions * self;
	self = instance;
#line 11 "../src/global-actions.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 11 "../src/global-actions.vala"
		GLOBAL_ACTIONS_GET_CLASS (self)->finalize (self);
#line 11 "../src/global-actions.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1672 "global-actions.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

