/* headerbar.c generated by valac 0.56.7, the Vala compiler
 * generated from headerbar.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2022 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HEADERBAR (headerbar_get_type ())
#define HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HEADERBAR, Headerbar))
#define HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HEADERBAR, HeaderbarClass))
#define IS_HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HEADERBAR))
#define IS_HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HEADERBAR))
#define HEADERBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HEADERBAR, HeaderbarClass))

typedef struct _Headerbar Headerbar;
typedef struct _HeaderbarClass HeaderbarClass;
typedef struct _HeaderbarPrivate HeaderbarPrivate;
enum  {
	HEADERBAR_0_PROPERTY,
	HEADERBAR_NUM_PROPERTIES
};
static GParamSpec* headerbar_properties[HEADERBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block21Data Block21Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _Headerbar {
	GtkHeaderBar parent_instance;
	HeaderbarPrivate * priv;
	GtkToggleButton* connect_but;
	GtkToggleButton* search_but;
};

struct _HeaderbarClass {
	GtkHeaderBarClass parent_class;
};

struct _HeaderbarPrivate {
	gchar* mode;
	GtkMenuButton* network_but;
	GtkMenuButton* client_but;
	GtkButton* refresh_but;
	GtkMenuButton* gear_but;
	GtkBox* box;
	gint minimum_width;
	gint last_allocated;
	gint connect_but_width;
	gint client_but_width;
	gint box_width;
	gint gear_but_width;
	gint search_but_width;
};

struct _Block21Data {
	int _ref_count_;
	Headerbar* self;
	GMenuItem* copy_ipv4;
	GMenuItem* copy_ipv6;
	GMenuItem* copy_id;
	GMenu* copy_section;
};

static gint Headerbar_private_offset;
static gpointer headerbar_parent_class = NULL;
VALA_EXTERN gboolean haguichi_window_use_header_bar;
VALA_EXTERN gchar* text_join_network_label;
VALA_EXTERN gchar* text_create_network_label;
VALA_EXTERN gchar* text_copy_address_ipv4_label;
VALA_EXTERN gchar* text_copy_address_ipv6_label;
VALA_EXTERN gchar* text_copy_client_id_label;
VALA_EXTERN gchar* text_change_nick_label;
VALA_EXTERN gchar* text_information_label;
VALA_EXTERN gchar* text_search_tip;
VALA_EXTERN gchar* text_refresh_tip;
VALA_EXTERN gchar* text_config_folder_label;
VALA_EXTERN gchar* text_config_save_label;
VALA_EXTERN gchar* text_config_restore_label;
VALA_EXTERN gchar* text_sort_by_name;
VALA_EXTERN gchar* text_sort_by_status;
VALA_EXTERN gchar* text_show_offline_members;
VALA_EXTERN gchar* text_preferences_label;
VALA_EXTERN gchar* text_shortcuts_label;
VALA_EXTERN gchar* text_help_label;
VALA_EXTERN gchar* text_about_label;
VALA_EXTERN gchar* text_quit_label;
VALA_EXTERN gchar* text_config_label;
VALA_EXTERN GtkAccelGroup* haguichi_window_accel_group;
VALA_EXTERN gint haguichi_window_minimum_width;
VALA_EXTERN GSimpleAction* global_actions_connect;
VALA_EXTERN GSimpleAction* global_actions_disconnect;
VALA_EXTERN GSimpleAction* global_actions_info;
VALA_EXTERN GSimpleAction* global_actions_join_network;
VALA_EXTERN GSimpleAction* global_actions_create_network;
VALA_EXTERN GSimpleAction* global_actions_refresh;
VALA_EXTERN GSimpleAction* global_actions_start_search;
VALA_EXTERN gchar* text_initializing;
VALA_EXTERN gchar* text_configuring;
VALA_EXTERN gint controller_restore_countdown;
VALA_EXTERN gchar* text_connecting;
VALA_EXTERN gchar* text_disconnect_tip;
VALA_EXTERN gchar* text_connected;
VALA_EXTERN gchar* text_connect_tip;
VALA_EXTERN gchar* text_disconnected;

VALA_EXTERN GType headerbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Headerbar, g_object_unref)
VALA_EXTERN Headerbar* headerbar_new (void);
VALA_EXTERN Headerbar* headerbar_construct (GType object_type);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static void __lambda93_ (Block21Data* _data21_);
VALA_EXTERN gchar** hamachi_get_address (gint* result_length1);
VALA_EXTERN gchar* hamachi_get_client_id (void);
static void ___lambda93__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static GVariant* _variant_new5 (const gchar* value);
static GVariant* _variant_new6 (const gchar* value);
VALA_EXTERN void headerbar_hide_all_buttons (Headerbar* self);
VALA_EXTERN void headerbar_show_all_buttons (Headerbar* self);
VALA_EXTERN void headerbar_show_hide_buttons (Headerbar* self,
                                  gint allocated,
                                  gint minimum);
static void headerbar_real_get_preferred_width (GtkWidget* base,
                                         gint* new_minimum_width,
                                         gint* new_natural_width);
VALA_EXTERN void headerbar_set_mode (Headerbar* self,
                         const gchar* _mode);
VALA_EXTERN gchar* utils_format (gchar* text,
                     const gchar* param1,
                     const gchar* param2,
                     const gchar* param3);
VALA_EXTERN gchar* text_reconnecting (gint count);
VALA_EXTERN void global_events_stop_search (void);
static void headerbar_finalize (GObject * obj);
static GType headerbar_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
headerbar_get_instance_private (Headerbar* self)
{
	return G_STRUCT_MEMBER_P (self, Headerbar_private_offset);
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 35 "../src/headerbar.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 35 "../src/headerbar.vala"
	return _data21_;
#line 182 "headerbar.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 35 "../src/headerbar.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 192 "headerbar.c"
		Headerbar* self;
#line 35 "../src/headerbar.vala"
		self = _data21_->self;
#line 35 "../src/headerbar.vala"
		_g_object_unref0 (_data21_->copy_section);
#line 35 "../src/headerbar.vala"
		_g_object_unref0 (_data21_->copy_id);
#line 35 "../src/headerbar.vala"
		_g_object_unref0 (_data21_->copy_ipv6);
#line 35 "../src/headerbar.vala"
		_g_object_unref0 (_data21_->copy_ipv4);
#line 35 "../src/headerbar.vala"
		_g_object_unref0 (self);
#line 35 "../src/headerbar.vala"
		g_slice_free (Block21Data, _data21_);
#line 208 "headerbar.c"
	}
}

static void
__lambda93_ (Block21Data* _data21_)
{
	Headerbar* self;
	GtkMenuButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 86 "../src/headerbar.vala"
	self = _data21_->self;
#line 88 "../src/headerbar.vala"
	_tmp0_ = self->priv->client_but;
#line 88 "../src/headerbar.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 88 "../src/headerbar.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/headerbar.vala"
	if (_tmp2_) {
#line 229 "headerbar.c"
		gchar** address = NULL;
		gint _tmp3_ = 0;
		gchar** _tmp4_;
		gint address_length1;
		gint _address_size_;
		gchar* ipv4 = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* ipv6 = NULL;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
#line 90 "../src/headerbar.vala"
		_tmp4_ = hamachi_get_address (&_tmp3_);
#line 90 "../src/headerbar.vala"
		address = _tmp4_;
#line 90 "../src/headerbar.vala"
		address_length1 = _tmp3_;
#line 90 "../src/headerbar.vala"
		_address_size_ = address_length1;
#line 91 "../src/headerbar.vala"
		_tmp5_ = address;
#line 91 "../src/headerbar.vala"
		_tmp5__length1 = address_length1;
#line 91 "../src/headerbar.vala"
		_tmp6_ = _tmp5_[0];
#line 91 "../src/headerbar.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 91 "../src/headerbar.vala"
		ipv4 = _tmp7_;
#line 92 "../src/headerbar.vala"
		_tmp8_ = address;
#line 92 "../src/headerbar.vala"
		_tmp8__length1 = address_length1;
#line 92 "../src/headerbar.vala"
		_tmp9_ = _tmp8_[1];
#line 92 "../src/headerbar.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 92 "../src/headerbar.vala"
		ipv6 = _tmp10_;
#line 94 "../src/headerbar.vala"
		g_menu_remove_all (_data21_->copy_section);
#line 96 "../src/headerbar.vala"
		_tmp11_ = ipv4;
#line 96 "../src/headerbar.vala"
		if (_tmp11_ != NULL) {
#line 98 "../src/headerbar.vala"
			g_menu_append_item (_data21_->copy_section, _data21_->copy_ipv4);
#line 286 "headerbar.c"
		}
#line 100 "../src/headerbar.vala"
		_tmp12_ = ipv6;
#line 100 "../src/headerbar.vala"
		if (_tmp12_ != NULL) {
#line 102 "../src/headerbar.vala"
			g_menu_append_item (_data21_->copy_section, _data21_->copy_ipv6);
#line 294 "headerbar.c"
		}
#line 104 "../src/headerbar.vala"
		_tmp13_ = hamachi_get_client_id ();
#line 104 "../src/headerbar.vala"
		_tmp14_ = _tmp13_;
#line 104 "../src/headerbar.vala"
		_tmp15_ = g_strcmp0 (_tmp14_, "") != 0;
#line 104 "../src/headerbar.vala"
		_g_free0 (_tmp14_);
#line 104 "../src/headerbar.vala"
		if (_tmp15_) {
#line 106 "../src/headerbar.vala"
			g_menu_append_item (_data21_->copy_section, _data21_->copy_id);
#line 308 "headerbar.c"
		}
#line 88 "../src/headerbar.vala"
		_g_free0 (ipv6);
#line 88 "../src/headerbar.vala"
		_g_free0 (ipv4);
#line 88 "../src/headerbar.vala"
		address = (_vala_array_free (address, address_length1, (GDestroyNotify) g_free), NULL);
#line 316 "headerbar.c"
	}
}

static void
___lambda93__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 86 "../src/headerbar.vala"
	__lambda93_ (self);
#line 326 "headerbar.c"
}

static GVariant*
_variant_new5 (const gchar* value)
{
#line 135 "../src/headerbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 334 "headerbar.c"
}

static GVariant*
_variant_new6 (const gchar* value)
{
#line 138 "../src/headerbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 342 "headerbar.c"
}

Headerbar*
headerbar_construct (GType object_type)
{
	Headerbar * self = NULL;
	Block21Data* _data21_;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GMenuItem* join = NULL;
	const gchar* _tmp8_;
	GMenuItem* _tmp9_;
	GMenuItem* create = NULL;
	const gchar* _tmp10_;
	GMenuItem* _tmp11_;
	GMenu* network_menu = NULL;
	GMenu* _tmp12_;
	GtkMenuButton* _tmp13_;
	GtkMenuButton* _tmp14_;
	GtkMenuButton* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkMenuButton* _tmp18_;
	const gchar* _tmp19_;
	GMenuItem* _tmp20_;
	const gchar* _tmp21_;
	GMenuItem* _tmp22_;
	const gchar* _tmp23_;
	GMenuItem* _tmp24_;
	GMenuItem* change_nick = NULL;
	const gchar* _tmp25_;
	GMenuItem* _tmp26_;
	GMenuItem* info = NULL;
	const gchar* _tmp27_;
	GMenuItem* _tmp28_;
	GMenu* info_section = NULL;
	GMenu* _tmp29_;
	GMenu* nick_section = NULL;
	GMenu* _tmp30_;
	GMenu* _tmp31_;
	GMenu* client_menu = NULL;
	GMenu* _tmp32_;
	GtkMenuButton* _tmp33_;
	GtkMenuButton* _tmp34_;
	GtkMenuButton* _tmp35_;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	GtkMenuButton* _tmp38_;
	GtkMenuButton* _tmp39_;
	GtkToggleButton* _tmp40_;
	GtkToggleButton* _tmp41_;
	GtkToggleButton* _tmp42_;
	GtkImage* _tmp43_;
	GtkImage* _tmp44_;
	GtkToggleButton* _tmp45_;
	GtkToggleButton* _tmp46_;
	const gchar* _tmp47_;
	GtkToggleButton* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkImage* _tmp52_;
	GtkImage* _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
	const gchar* _tmp56_;
	GtkButton* _tmp57_;
	GMenu* gear_menu = NULL;
	GMenu* _tmp58_;
	GMenuItem* open_config = NULL;
	const gchar* _tmp59_;
	GMenuItem* _tmp60_;
	GMenuItem* save_config = NULL;
	const gchar* _tmp61_;
	GMenuItem* _tmp62_;
	GMenuItem* restore_config = NULL;
	const gchar* _tmp63_;
	GMenuItem* _tmp64_;
	GMenuItem* sort_by_name = NULL;
	const gchar* _tmp65_;
	GMenuItem* _tmp66_;
	GVariant* _tmp67_;
	GMenuItem* sort_by_status = NULL;
	const gchar* _tmp68_;
	GMenuItem* _tmp69_;
	GVariant* _tmp70_;
	GMenuItem* show_offline = NULL;
	const gchar* _tmp71_;
	GMenuItem* _tmp72_;
	GMenuItem* preferences = NULL;
	const gchar* _tmp73_;
	GMenuItem* _tmp74_;
	GMenuItem* shortcuts = NULL;
	const gchar* _tmp75_;
	GMenuItem* _tmp76_;
	GMenuItem* help = NULL;
	const gchar* _tmp77_;
	GMenuItem* _tmp78_;
	GMenuItem* about = NULL;
	const gchar* _tmp79_;
	GMenuItem* _tmp80_;
	GMenuItem* quit = NULL;
	const gchar* _tmp81_;
	GMenuItem* _tmp82_;
	GMenu* backup_section = NULL;
	GMenu* _tmp83_;
	GMenu* open_section = NULL;
	GMenu* _tmp84_;
	GMenu* config_submenu = NULL;
	GMenu* _tmp85_;
	GMenu* sort_section = NULL;
	GMenu* _tmp86_;
	GMenu* filter_section = NULL;
	GMenu* _tmp87_;
	GMenu* meta_section = NULL;
	GMenu* _tmp88_;
	GMenu* quit_section = NULL;
	GMenu* _tmp89_;
	const gchar* _tmp90_;
	GtkMenuButton* _tmp91_;
	GtkMenuButton* _tmp92_;
	GtkMenuButton* _tmp93_;
	GtkImage* _tmp94_;
	GtkImage* _tmp95_;
	GtkMenuButton* _tmp96_;
	GtkMenuButton* _tmp97_;
	GtkAccelGroup* _tmp98_;
	GtkBox* _tmp99_;
	GtkBox* _tmp100_;
	GtkStyleContext* _tmp101_;
	GtkBox* _tmp102_;
	GtkMenuButton* _tmp103_;
	GtkBox* _tmp104_;
	GtkButton* _tmp105_;
	GtkToggleButton* _tmp106_;
	GtkMenuButton* _tmp107_;
	GtkBox* _tmp108_;
	GtkMenuButton* _tmp109_;
	GtkToggleButton* _tmp110_;
	GtkToggleButton* _tmp111_;
	gint _tmp112_ = 0;
	GtkMenuButton* _tmp113_;
	gint _tmp114_ = 0;
	GtkBox* _tmp115_;
	gint _tmp116_ = 0;
	GtkToggleButton* _tmp117_;
	gint _tmp118_ = 0;
	GtkMenuButton* _tmp119_;
	gint _tmp120_ = 0;
	gint _tmp121_ = 0;
#line 35 "../src/headerbar.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 35 "../src/headerbar.vala"
	_data21_->_ref_count_ = 1;
#line 35 "../src/headerbar.vala"
	self = (Headerbar*) g_object_new (object_type, NULL);
#line 35 "../src/headerbar.vala"
	_data21_->self = g_object_ref (self);
#line 37 "../src/headerbar.vala"
	gtk_header_bar_set_show_close_button ((GtkHeaderBar*) self, haguichi_window_use_header_bar);
#line 40 "../src/headerbar.vala"
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 40 "../src/headerbar.vala"
	g_object_ref_sink (_tmp0_);
#line 40 "../src/headerbar.vala"
	_g_object_unref0 (self->connect_but);
#line 40 "../src/headerbar.vala"
	self->connect_but = _tmp0_;
#line 41 "../src/headerbar.vala"
	_tmp1_ = self->connect_but;
#line 41 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 42 "../src/headerbar.vala"
	_tmp2_ = self->connect_but;
#line 42 "../src/headerbar.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("system-shutdown-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 42 "../src/headerbar.vala"
	g_object_ref_sink (_tmp3_);
#line 42 "../src/headerbar.vala"
	_tmp4_ = _tmp3_;
#line 42 "../src/headerbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp2_, (GtkWidget*) _tmp4_);
#line 42 "../src/headerbar.vala"
	_g_object_unref0 (_tmp4_);
#line 43 "../src/headerbar.vala"
	_tmp5_ = self->connect_but;
#line 43 "../src/headerbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp5_, "app.connect");
#line 44 "../src/headerbar.vala"
	_tmp6_ = self->connect_but;
#line 44 "../src/headerbar.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 44 "../src/headerbar.vala"
	gtk_style_context_add_class (_tmp7_, "suggested-action");
#line 47 "../src/headerbar.vala"
	_tmp8_ = text_join_network_label;
#line 47 "../src/headerbar.vala"
	_tmp9_ = g_menu_item_new (_tmp8_, "app.join-network");
#line 47 "../src/headerbar.vala"
	join = _tmp9_;
#line 48 "../src/headerbar.vala"
	_tmp10_ = text_create_network_label;
#line 48 "../src/headerbar.vala"
	_tmp11_ = g_menu_item_new (_tmp10_, "app.create-network");
#line 48 "../src/headerbar.vala"
	create = _tmp11_;
#line 50 "../src/headerbar.vala"
	_tmp12_ = g_menu_new ();
#line 50 "../src/headerbar.vala"
	network_menu = _tmp12_;
#line 51 "../src/headerbar.vala"
	g_menu_append_item (network_menu, join);
#line 52 "../src/headerbar.vala"
	g_menu_append_item (network_menu, create);
#line 54 "../src/headerbar.vala"
	_tmp13_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 54 "../src/headerbar.vala"
	g_object_ref_sink (_tmp13_);
#line 54 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->network_but);
#line 54 "../src/headerbar.vala"
	self->priv->network_but = _tmp13_;
#line 55 "../src/headerbar.vala"
	_tmp14_ = self->priv->network_but;
#line 55 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 56 "../src/headerbar.vala"
	_tmp15_ = self->priv->network_but;
#line 56 "../src/headerbar.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 56 "../src/headerbar.vala"
	g_object_ref_sink (_tmp16_);
#line 56 "../src/headerbar.vala"
	_tmp17_ = _tmp16_;
#line 56 "../src/headerbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp15_, (GtkWidget*) _tmp17_);
#line 56 "../src/headerbar.vala"
	_g_object_unref0 (_tmp17_);
#line 57 "../src/headerbar.vala"
	_tmp18_ = self->priv->network_but;
#line 57 "../src/headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp18_, (GMenuModel*) network_menu);
#line 60 "../src/headerbar.vala"
	_tmp19_ = text_copy_address_ipv4_label;
#line 60 "../src/headerbar.vala"
	_tmp20_ = g_menu_item_new (_tmp19_, "app.copy-ipv4");
#line 60 "../src/headerbar.vala"
	_data21_->copy_ipv4 = _tmp20_;
#line 61 "../src/headerbar.vala"
	_tmp21_ = text_copy_address_ipv6_label;
#line 61 "../src/headerbar.vala"
	_tmp22_ = g_menu_item_new (_tmp21_, "app.copy-ipv6");
#line 61 "../src/headerbar.vala"
	_data21_->copy_ipv6 = _tmp22_;
#line 62 "../src/headerbar.vala"
	_tmp23_ = text_copy_client_id_label;
#line 62 "../src/headerbar.vala"
	_tmp24_ = g_menu_item_new (_tmp23_, "app.copy-id");
#line 62 "../src/headerbar.vala"
	_data21_->copy_id = _tmp24_;
#line 63 "../src/headerbar.vala"
	_tmp25_ = text_change_nick_label;
#line 63 "../src/headerbar.vala"
	_tmp26_ = g_menu_item_new (_tmp25_, "app.change-nick");
#line 63 "../src/headerbar.vala"
	change_nick = _tmp26_;
#line 64 "../src/headerbar.vala"
	_tmp27_ = text_information_label;
#line 64 "../src/headerbar.vala"
	_tmp28_ = g_menu_item_new (_tmp27_, "app.info");
#line 64 "../src/headerbar.vala"
	info = _tmp28_;
#line 66 "../src/headerbar.vala"
	_tmp29_ = g_menu_new ();
#line 66 "../src/headerbar.vala"
	info_section = _tmp29_;
#line 67 "../src/headerbar.vala"
	g_menu_append_item (info_section, info);
#line 69 "../src/headerbar.vala"
	_tmp30_ = g_menu_new ();
#line 69 "../src/headerbar.vala"
	nick_section = _tmp30_;
#line 70 "../src/headerbar.vala"
	g_menu_append_item (nick_section, change_nick);
#line 72 "../src/headerbar.vala"
	_tmp31_ = g_menu_new ();
#line 72 "../src/headerbar.vala"
	_data21_->copy_section = _tmp31_;
#line 73 "../src/headerbar.vala"
	g_menu_append_item (_data21_->copy_section, _data21_->copy_ipv4);
#line 74 "../src/headerbar.vala"
	g_menu_append_item (_data21_->copy_section, _data21_->copy_ipv6);
#line 75 "../src/headerbar.vala"
	g_menu_append_item (_data21_->copy_section, _data21_->copy_id);
#line 77 "../src/headerbar.vala"
	_tmp32_ = g_menu_new ();
#line 77 "../src/headerbar.vala"
	client_menu = _tmp32_;
#line 78 "../src/headerbar.vala"
	g_menu_append_section (client_menu, NULL, (GMenuModel*) info_section);
#line 79 "../src/headerbar.vala"
	g_menu_append_section (client_menu, NULL, (GMenuModel*) nick_section);
#line 80 "../src/headerbar.vala"
	g_menu_append_section (client_menu, NULL, (GMenuModel*) _data21_->copy_section);
#line 82 "../src/headerbar.vala"
	_tmp33_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 82 "../src/headerbar.vala"
	g_object_ref_sink (_tmp33_);
#line 82 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->client_but);
#line 82 "../src/headerbar.vala"
	self->priv->client_but = _tmp33_;
#line 83 "../src/headerbar.vala"
	_tmp34_ = self->priv->client_but;
#line 83 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
#line 84 "../src/headerbar.vala"
	_tmp35_ = self->priv->client_but;
#line 84 "../src/headerbar.vala"
	_tmp36_ = (GtkImage*) gtk_image_new_from_icon_name ("avatar-default-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 84 "../src/headerbar.vala"
	g_object_ref_sink (_tmp36_);
#line 84 "../src/headerbar.vala"
	_tmp37_ = _tmp36_;
#line 84 "../src/headerbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp35_, (GtkWidget*) _tmp37_);
#line 84 "../src/headerbar.vala"
	_g_object_unref0 (_tmp37_);
#line 85 "../src/headerbar.vala"
	_tmp38_ = self->priv->client_but;
#line 85 "../src/headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp38_, (GMenuModel*) client_menu);
#line 86 "../src/headerbar.vala"
	_tmp39_ = self->priv->client_but;
#line 86 "../src/headerbar.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp39_, "toggled", (GCallback) ___lambda93__gtk_toggle_button_toggled, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
#line 112 "../src/headerbar.vala"
	_tmp40_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 112 "../src/headerbar.vala"
	g_object_ref_sink (_tmp40_);
#line 112 "../src/headerbar.vala"
	_g_object_unref0 (self->search_but);
#line 112 "../src/headerbar.vala"
	self->search_but = _tmp40_;
#line 113 "../src/headerbar.vala"
	_tmp41_ = self->search_but;
#line 113 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_CENTER);
#line 114 "../src/headerbar.vala"
	_tmp42_ = self->search_but;
#line 114 "../src/headerbar.vala"
	_tmp43_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-find-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 114 "../src/headerbar.vala"
	g_object_ref_sink (_tmp43_);
#line 114 "../src/headerbar.vala"
	_tmp44_ = _tmp43_;
#line 114 "../src/headerbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp42_, (GtkWidget*) _tmp44_);
#line 114 "../src/headerbar.vala"
	_g_object_unref0 (_tmp44_);
#line 115 "../src/headerbar.vala"
	_tmp45_ = self->search_but;
#line 115 "../src/headerbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp45_, "app.start-search");
#line 116 "../src/headerbar.vala"
	_tmp46_ = self->search_but;
#line 116 "../src/headerbar.vala"
	_tmp47_ = text_search_tip;
#line 116 "../src/headerbar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp46_, _tmp47_);
#line 117 "../src/headerbar.vala"
	_tmp48_ = self->search_but;
#line 117 "../src/headerbar.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) _tmp48_, FALSE);
#line 120 "../src/headerbar.vala"
	_tmp49_ = (GtkButton*) gtk_button_new ();
#line 120 "../src/headerbar.vala"
	g_object_ref_sink (_tmp49_);
#line 120 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->refresh_but);
#line 120 "../src/headerbar.vala"
	self->priv->refresh_but = _tmp49_;
#line 121 "../src/headerbar.vala"
	_tmp50_ = self->priv->refresh_but;
#line 121 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
#line 122 "../src/headerbar.vala"
	_tmp51_ = self->priv->refresh_but;
#line 122 "../src/headerbar.vala"
	_tmp52_ = (GtkImage*) gtk_image_new_from_icon_name ("view-refresh-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 122 "../src/headerbar.vala"
	g_object_ref_sink (_tmp52_);
#line 122 "../src/headerbar.vala"
	_tmp53_ = _tmp52_;
#line 122 "../src/headerbar.vala"
	gtk_button_set_image (_tmp51_, (GtkWidget*) _tmp53_);
#line 122 "../src/headerbar.vala"
	_g_object_unref0 (_tmp53_);
#line 123 "../src/headerbar.vala"
	_tmp54_ = self->priv->refresh_but;
#line 123 "../src/headerbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp54_, "app.refresh");
#line 124 "../src/headerbar.vala"
	_tmp55_ = self->priv->refresh_but;
#line 124 "../src/headerbar.vala"
	_tmp56_ = text_refresh_tip;
#line 124 "../src/headerbar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp55_, _tmp56_);
#line 125 "../src/headerbar.vala"
	_tmp57_ = self->priv->refresh_but;
#line 125 "../src/headerbar.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) _tmp57_, FALSE);
#line 128 "../src/headerbar.vala"
	_tmp58_ = g_menu_new ();
#line 128 "../src/headerbar.vala"
	gear_menu = _tmp58_;
#line 130 "../src/headerbar.vala"
	_tmp59_ = text_config_folder_label;
#line 130 "../src/headerbar.vala"
	_tmp60_ = g_menu_item_new (_tmp59_, "app.open-config");
#line 130 "../src/headerbar.vala"
	open_config = _tmp60_;
#line 131 "../src/headerbar.vala"
	_tmp61_ = text_config_save_label;
#line 131 "../src/headerbar.vala"
	_tmp62_ = g_menu_item_new (_tmp61_, "app.save-config");
#line 131 "../src/headerbar.vala"
	save_config = _tmp62_;
#line 132 "../src/headerbar.vala"
	_tmp63_ = text_config_restore_label;
#line 132 "../src/headerbar.vala"
	_tmp64_ = g_menu_item_new (_tmp63_, "app.restore-config");
#line 132 "../src/headerbar.vala"
	restore_config = _tmp64_;
#line 134 "../src/headerbar.vala"
	_tmp65_ = text_sort_by_name;
#line 134 "../src/headerbar.vala"
	_tmp66_ = g_menu_item_new (_tmp65_, "app.sort-by");
#line 134 "../src/headerbar.vala"
	sort_by_name = _tmp66_;
#line 135 "../src/headerbar.vala"
	_tmp67_ = _variant_new5 ("name");
#line 135 "../src/headerbar.vala"
	g_menu_item_set_attribute_value (sort_by_name, "target", _tmp67_);
#line 135 "../src/headerbar.vala"
	_g_variant_unref0 (_tmp67_);
#line 137 "../src/headerbar.vala"
	_tmp68_ = text_sort_by_status;
#line 137 "../src/headerbar.vala"
	_tmp69_ = g_menu_item_new (_tmp68_, "app.sort-by");
#line 137 "../src/headerbar.vala"
	sort_by_status = _tmp69_;
#line 138 "../src/headerbar.vala"
	_tmp70_ = _variant_new6 ("status");
#line 138 "../src/headerbar.vala"
	g_menu_item_set_attribute_value (sort_by_status, "target", _tmp70_);
#line 138 "../src/headerbar.vala"
	_g_variant_unref0 (_tmp70_);
#line 140 "../src/headerbar.vala"
	_tmp71_ = text_show_offline_members;
#line 140 "../src/headerbar.vala"
	_tmp72_ = g_menu_item_new (_tmp71_, "app.show-offline-members");
#line 140 "../src/headerbar.vala"
	show_offline = _tmp72_;
#line 141 "../src/headerbar.vala"
	_tmp73_ = text_preferences_label;
#line 141 "../src/headerbar.vala"
	_tmp74_ = g_menu_item_new (_tmp73_, "app.preferences");
#line 141 "../src/headerbar.vala"
	preferences = _tmp74_;
#line 142 "../src/headerbar.vala"
	_tmp75_ = text_shortcuts_label;
#line 142 "../src/headerbar.vala"
	_tmp76_ = g_menu_item_new (_tmp75_, "app.shortcuts");
#line 142 "../src/headerbar.vala"
	shortcuts = _tmp76_;
#line 143 "../src/headerbar.vala"
	_tmp77_ = text_help_label;
#line 143 "../src/headerbar.vala"
	_tmp78_ = g_menu_item_new (_tmp77_, "app.help");
#line 143 "../src/headerbar.vala"
	help = _tmp78_;
#line 144 "../src/headerbar.vala"
	_tmp79_ = text_about_label;
#line 144 "../src/headerbar.vala"
	_tmp80_ = g_menu_item_new (_tmp79_, "app.about");
#line 144 "../src/headerbar.vala"
	about = _tmp80_;
#line 145 "../src/headerbar.vala"
	_tmp81_ = text_quit_label;
#line 145 "../src/headerbar.vala"
	_tmp82_ = g_menu_item_new (_tmp81_, "app.quit");
#line 145 "../src/headerbar.vala"
	quit = _tmp82_;
#line 147 "../src/headerbar.vala"
	_tmp83_ = g_menu_new ();
#line 147 "../src/headerbar.vala"
	backup_section = _tmp83_;
#line 148 "../src/headerbar.vala"
	g_menu_append_item (backup_section, save_config);
#line 149 "../src/headerbar.vala"
	g_menu_append_item (backup_section, restore_config);
#line 151 "../src/headerbar.vala"
	_tmp84_ = g_menu_new ();
#line 151 "../src/headerbar.vala"
	open_section = _tmp84_;
#line 152 "../src/headerbar.vala"
	g_menu_append_item (open_section, open_config);
#line 154 "../src/headerbar.vala"
	_tmp85_ = g_menu_new ();
#line 154 "../src/headerbar.vala"
	config_submenu = _tmp85_;
#line 155 "../src/headerbar.vala"
	g_menu_append_section (config_submenu, NULL, (GMenuModel*) backup_section);
#line 156 "../src/headerbar.vala"
	g_menu_append_section (config_submenu, NULL, (GMenuModel*) open_section);
#line 158 "../src/headerbar.vala"
	_tmp86_ = g_menu_new ();
#line 158 "../src/headerbar.vala"
	sort_section = _tmp86_;
#line 159 "../src/headerbar.vala"
	g_menu_append_item (sort_section, sort_by_name);
#line 160 "../src/headerbar.vala"
	g_menu_append_item (sort_section, sort_by_status);
#line 162 "../src/headerbar.vala"
	_tmp87_ = g_menu_new ();
#line 162 "../src/headerbar.vala"
	filter_section = _tmp87_;
#line 163 "../src/headerbar.vala"
	g_menu_append_item (filter_section, show_offline);
#line 165 "../src/headerbar.vala"
	_tmp88_ = g_menu_new ();
#line 165 "../src/headerbar.vala"
	meta_section = _tmp88_;
#line 166 "../src/headerbar.vala"
	g_menu_append_item (meta_section, preferences);
#line 167 "../src/headerbar.vala"
	g_menu_append_item (meta_section, shortcuts);
#line 168 "../src/headerbar.vala"
	g_menu_append_item (meta_section, help);
#line 169 "../src/headerbar.vala"
	g_menu_append_item (meta_section, about);
#line 171 "../src/headerbar.vala"
	_tmp89_ = g_menu_new ();
#line 171 "../src/headerbar.vala"
	quit_section = _tmp89_;
#line 172 "../src/headerbar.vala"
	g_menu_append_item (quit_section, quit);
#line 174 "../src/headerbar.vala"
	_tmp90_ = text_config_label;
#line 174 "../src/headerbar.vala"
	g_menu_append_submenu (gear_menu, _tmp90_, (GMenuModel*) config_submenu);
#line 175 "../src/headerbar.vala"
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) sort_section);
#line 176 "../src/headerbar.vala"
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) filter_section);
#line 177 "../src/headerbar.vala"
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) meta_section);
#line 178 "../src/headerbar.vala"
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) quit_section);
#line 180 "../src/headerbar.vala"
	_tmp91_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 180 "../src/headerbar.vala"
	g_object_ref_sink (_tmp91_);
#line 180 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->gear_but);
#line 180 "../src/headerbar.vala"
	self->priv->gear_but = _tmp91_;
#line 181 "../src/headerbar.vala"
	_tmp92_ = self->priv->gear_but;
#line 181 "../src/headerbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp92_, GTK_ALIGN_CENTER);
#line 182 "../src/headerbar.vala"
	_tmp93_ = self->priv->gear_but;
#line 182 "../src/headerbar.vala"
	_tmp94_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 182 "../src/headerbar.vala"
	g_object_ref_sink (_tmp94_);
#line 182 "../src/headerbar.vala"
	_tmp95_ = _tmp94_;
#line 182 "../src/headerbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp93_, (GtkWidget*) _tmp95_);
#line 182 "../src/headerbar.vala"
	_g_object_unref0 (_tmp95_);
#line 183 "../src/headerbar.vala"
	_tmp96_ = self->priv->gear_but;
#line 183 "../src/headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp96_, (GMenuModel*) gear_menu);
#line 184 "../src/headerbar.vala"
	_tmp97_ = self->priv->gear_but;
#line 184 "../src/headerbar.vala"
	_tmp98_ = haguichi_window_accel_group;
#line 184 "../src/headerbar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) _tmp97_, "clicked", _tmp98_, GDK_KEY_F10, 0, GTK_ACCEL_VISIBLE);
#line 187 "../src/headerbar.vala"
	_tmp99_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 187 "../src/headerbar.vala"
	g_object_ref_sink (_tmp99_);
#line 187 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->box);
#line 187 "../src/headerbar.vala"
	self->priv->box = _tmp99_;
#line 188 "../src/headerbar.vala"
	_tmp100_ = self->priv->box;
#line 188 "../src/headerbar.vala"
	_tmp101_ = gtk_widget_get_style_context ((GtkWidget*) _tmp100_);
#line 188 "../src/headerbar.vala"
	gtk_style_context_add_class (_tmp101_, "linked");
#line 189 "../src/headerbar.vala"
	_tmp102_ = self->priv->box;
#line 189 "../src/headerbar.vala"
	_tmp103_ = self->priv->network_but;
#line 189 "../src/headerbar.vala"
	gtk_container_add ((GtkContainer*) _tmp102_, (GtkWidget*) _tmp103_);
#line 190 "../src/headerbar.vala"
	_tmp104_ = self->priv->box;
#line 190 "../src/headerbar.vala"
	_tmp105_ = self->priv->refresh_but;
#line 190 "../src/headerbar.vala"
	gtk_container_add ((GtkContainer*) _tmp104_, (GtkWidget*) _tmp105_);
#line 193 "../src/headerbar.vala"
	_tmp106_ = self->connect_but;
#line 193 "../src/headerbar.vala"
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp106_);
#line 194 "../src/headerbar.vala"
	_tmp107_ = self->priv->client_but;
#line 194 "../src/headerbar.vala"
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp107_);
#line 195 "../src/headerbar.vala"
	_tmp108_ = self->priv->box;
#line 195 "../src/headerbar.vala"
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp108_);
#line 196 "../src/headerbar.vala"
	_tmp109_ = self->priv->gear_but;
#line 196 "../src/headerbar.vala"
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp109_);
#line 197 "../src/headerbar.vala"
	_tmp110_ = self->search_but;
#line 197 "../src/headerbar.vala"
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp110_);
#line 199 "../src/headerbar.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 201 "../src/headerbar.vala"
	_tmp111_ = self->connect_but;
#line 201 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp111_, &_tmp112_, NULL);
#line 201 "../src/headerbar.vala"
	self->priv->connect_but_width = _tmp112_;
#line 202 "../src/headerbar.vala"
	_tmp113_ = self->priv->client_but;
#line 202 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp113_, &_tmp114_, NULL);
#line 202 "../src/headerbar.vala"
	self->priv->client_but_width = _tmp114_;
#line 203 "../src/headerbar.vala"
	_tmp115_ = self->priv->box;
#line 203 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp115_, &_tmp116_, NULL);
#line 203 "../src/headerbar.vala"
	self->priv->box_width = _tmp116_;
#line 204 "../src/headerbar.vala"
	_tmp117_ = self->search_but;
#line 204 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp117_, &_tmp118_, NULL);
#line 204 "../src/headerbar.vala"
	self->priv->search_but_width = _tmp118_;
#line 205 "../src/headerbar.vala"
	_tmp119_ = self->priv->gear_but;
#line 205 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp119_, &_tmp120_, NULL);
#line 205 "../src/headerbar.vala"
	self->priv->gear_but_width = _tmp120_;
#line 207 "../src/headerbar.vala"
	headerbar_hide_all_buttons (self);
#line 209 "../src/headerbar.vala"
	gtk_widget_get_preferred_width ((GtkWidget*) self, &_tmp121_, NULL);
#line 209 "../src/headerbar.vala"
	self->priv->minimum_width = _tmp121_;
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (quit_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (meta_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (filter_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (sort_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (config_submenu);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (open_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (backup_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (quit);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (about);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (help);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (shortcuts);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (preferences);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (show_offline);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (sort_by_status);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (sort_by_name);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (restore_config);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (save_config);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (open_config);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (gear_menu);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (client_menu);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (nick_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (info_section);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (info);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (change_nick);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (network_menu);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (create);
#line 35 "../src/headerbar.vala"
	_g_object_unref0 (join);
#line 35 "../src/headerbar.vala"
	block21_data_unref (_data21_);
#line 35 "../src/headerbar.vala"
	_data21_ = NULL;
#line 35 "../src/headerbar.vala"
	return self;
#line 1087 "headerbar.c"
}

Headerbar*
headerbar_new (void)
{
#line 35 "../src/headerbar.vala"
	return headerbar_construct (TYPE_HEADERBAR);
#line 1095 "headerbar.c"
}

void
headerbar_show_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
#line 212 "../src/headerbar.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/headerbar.vala"
	self->priv->last_allocated = 0;
#line 216 "../src/headerbar.vala"
	_tmp0_ = self->connect_but;
#line 216 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 217 "../src/headerbar.vala"
	_tmp1_ = self->priv->client_but;
#line 217 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 218 "../src/headerbar.vala"
	_tmp2_ = self->priv->box;
#line 218 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 219 "../src/headerbar.vala"
	_tmp3_ = self->search_but;
#line 219 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 220 "../src/headerbar.vala"
	_tmp4_ = self->priv->gear_but;
#line 220 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp4_);
#line 1130 "headerbar.c"
}

void
headerbar_hide_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
#line 223 "../src/headerbar.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/headerbar.vala"
	_tmp0_ = self->connect_but;
#line 225 "../src/headerbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 226 "../src/headerbar.vala"
	_tmp1_ = self->priv->client_but;
#line 226 "../src/headerbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 227 "../src/headerbar.vala"
	_tmp2_ = self->priv->box;
#line 227 "../src/headerbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 228 "../src/headerbar.vala"
	_tmp3_ = self->search_but;
#line 228 "../src/headerbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 229 "../src/headerbar.vala"
	_tmp4_ = self->priv->gear_but;
#line 229 "../src/headerbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 1163 "headerbar.c"
}

void
headerbar_show_hide_buttons (Headerbar* self,
                             gint allocated,
                             gint minimum)
{
	gint current = 0;
	GtkToggleButton* _tmp0_;
#line 232 "../src/headerbar.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/headerbar.vala"
	if (allocated == self->priv->last_allocated) {
#line 236 "../src/headerbar.vala"
		return;
#line 1179 "headerbar.c"
	}
#line 238 "../src/headerbar.vala"
	self->priv->last_allocated = allocated;
#line 240 "../src/headerbar.vala"
	headerbar_hide_all_buttons (self);
#line 242 "../src/headerbar.vala"
	current = minimum + self->priv->connect_but_width;
#line 243 "../src/headerbar.vala"
	_tmp0_ = self->connect_but;
#line 243 "../src/headerbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 245 "../src/headerbar.vala"
	current += self->priv->gear_but_width;
#line 246 "../src/headerbar.vala"
	if (allocated > current) {
#line 1195 "headerbar.c"
		GtkMenuButton* _tmp1_;
#line 248 "../src/headerbar.vala"
		_tmp1_ = self->priv->gear_but;
#line 248 "../src/headerbar.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 1201 "headerbar.c"
	}
#line 251 "../src/headerbar.vala"
	current += self->priv->client_but_width;
#line 252 "../src/headerbar.vala"
	if (allocated > current) {
#line 1207 "headerbar.c"
		GtkMenuButton* _tmp2_;
#line 254 "../src/headerbar.vala"
		_tmp2_ = self->priv->client_but;
#line 254 "../src/headerbar.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 1213 "headerbar.c"
	}
#line 257 "../src/headerbar.vala"
	current += self->priv->search_but_width;
#line 258 "../src/headerbar.vala"
	if (allocated > current) {
#line 1219 "headerbar.c"
		GtkToggleButton* _tmp3_;
#line 260 "../src/headerbar.vala"
		_tmp3_ = self->search_but;
#line 260 "../src/headerbar.vala"
		gtk_widget_show ((GtkWidget*) _tmp3_);
#line 1225 "headerbar.c"
	}
#line 263 "../src/headerbar.vala"
	current += self->priv->box_width;
#line 264 "../src/headerbar.vala"
	if (allocated > current) {
#line 1231 "headerbar.c"
		GtkBox* _tmp4_;
#line 266 "../src/headerbar.vala"
		_tmp4_ = self->priv->box;
#line 266 "../src/headerbar.vala"
		gtk_widget_show ((GtkWidget*) _tmp4_);
#line 1237 "headerbar.c"
	}
}

static void
headerbar_real_get_preferred_width (GtkWidget* base,
                                    gint* new_minimum_width,
                                    gint* new_natural_width)
{
	Headerbar * self;
	gint _vala_new_minimum_width = 0;
	gint _vala_new_natural_width = 0;
	gboolean _tmp0_ = FALSE;
#line 270 "../src/headerbar.vala"
	self = (Headerbar*) base;
#line 272 "../src/headerbar.vala"
	if (haguichi_window_use_header_bar == FALSE) {
#line 273 "../src/headerbar.vala"
		_tmp0_ = self->priv->minimum_width > 0;
#line 1256 "headerbar.c"
	} else {
#line 272 "../src/headerbar.vala"
		_tmp0_ = FALSE;
#line 1260 "headerbar.c"
	}
#line 272 "../src/headerbar.vala"
	if (_tmp0_) {
#line 1264 "headerbar.c"
	} else {
#line 277 "../src/headerbar.vala"
		if (haguichi_window_minimum_width > 0) {
#line 1268 "headerbar.c"
			const gchar* _tmp1_;
#line 279 "../src/headerbar.vala"
			self->priv->minimum_width = haguichi_window_minimum_width;
#line 281 "../src/headerbar.vala"
			_tmp1_ = gtk_check_version ((guint) 3, (guint) 18, (guint) 0);
#line 281 "../src/headerbar.vala"
			if (_tmp1_ == NULL) {
#line 283 "../src/headerbar.vala"
				self->priv->minimum_width = self->priv->minimum_width + 50;
#line 1278 "headerbar.c"
			}
		} else {
			gint base_minimum_width = 0;
			gint base_natural_width = 0;
			gint _tmp2_ = 0;
			gint _tmp3_ = 0;
#line 291 "../src/headerbar.vala"
			GTK_WIDGET_CLASS (headerbar_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_header_bar_get_type (), GtkHeaderBar), &_tmp2_, &_tmp3_);
#line 291 "../src/headerbar.vala"
			base_minimum_width = _tmp2_;
#line 291 "../src/headerbar.vala"
			base_natural_width = _tmp3_;
#line 293 "../src/headerbar.vala"
			self->priv->minimum_width = base_minimum_width;
#line 1293 "headerbar.c"
		}
	}
#line 296 "../src/headerbar.vala"
	_vala_new_minimum_width = self->priv->minimum_width;
#line 297 "../src/headerbar.vala"
	_vala_new_natural_width = self->priv->minimum_width;
#line 270 "../src/headerbar.vala"
	if (new_minimum_width) {
#line 270 "../src/headerbar.vala"
		*new_minimum_width = _vala_new_minimum_width;
#line 1304 "headerbar.c"
	}
#line 270 "../src/headerbar.vala"
	if (new_natural_width) {
#line 270 "../src/headerbar.vala"
		*new_natural_width = _vala_new_natural_width;
#line 1310 "headerbar.c"
	}
}

void
headerbar_set_mode (Headerbar* self,
                    const gchar* _mode)
{
	gchar* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GtkMenuButton* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GQuark _tmp12_ = 0U;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label0 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label1 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label2 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label3 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label4 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label5 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label6 = 0;
#line 318 "../src/headerbar.vala"
	static GQuark _tmp11_label7 = 0;
#line 300 "../src/headerbar.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/headerbar.vala"
	g_return_if_fail (_mode != NULL);
#line 302 "../src/headerbar.vala"
	_tmp0_ = g_strdup (_mode);
#line 302 "../src/headerbar.vala"
	_g_free0 (self->priv->mode);
#line 302 "../src/headerbar.vala"
	self->priv->mode = _tmp0_;
#line 304 "../src/headerbar.vala"
	_tmp1_ = global_actions_connect;
#line 304 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp1_, FALSE);
#line 305 "../src/headerbar.vala"
	_tmp2_ = global_actions_disconnect;
#line 305 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp2_, FALSE);
#line 307 "../src/headerbar.vala"
	_tmp3_ = global_actions_info;
#line 307 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp3_, FALSE);
#line 309 "../src/headerbar.vala"
	_tmp4_ = global_actions_join_network;
#line 309 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp4_, FALSE);
#line 310 "../src/headerbar.vala"
	_tmp5_ = global_actions_create_network;
#line 310 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 312 "../src/headerbar.vala"
	_tmp6_ = global_actions_refresh;
#line 312 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 314 "../src/headerbar.vala"
	_tmp7_ = global_actions_start_search;
#line 314 "../src/headerbar.vala"
	g_simple_action_set_enabled (_tmp7_, FALSE);
#line 316 "../src/headerbar.vala"
	_tmp8_ = self->priv->network_but;
#line 316 "../src/headerbar.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 318 "../src/headerbar.vala"
	_tmp9_ = self->priv->mode;
#line 318 "../src/headerbar.vala"
	_tmp10_ = _tmp9_;
#line 318 "../src/headerbar.vala"
	_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
#line 318 "../src/headerbar.vala"
	if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("Initializing")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1398 "headerbar.c"
			default:
			{
				const gchar* _tmp13_;
#line 321 "../src/headerbar.vala"
				_tmp13_ = text_initializing;
#line 321 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp13_);
#line 322 "../src/headerbar.vala"
				break;
#line 1408 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("Configuring")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1414 "headerbar.c"
			default:
			{
				const gchar* _tmp14_;
#line 325 "../src/headerbar.vala"
				_tmp14_ = text_configuring;
#line 325 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp14_);
#line 326 "../src/headerbar.vala"
				break;
#line 1424 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("Countdown")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1430 "headerbar.c"
			default:
			{
				GSimpleAction* _tmp15_;
				GSimpleAction* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 329 "../src/headerbar.vala"
				_tmp15_ = global_actions_connect;
#line 329 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp15_, TRUE);
#line 331 "../src/headerbar.vala"
				_tmp16_ = global_actions_info;
#line 331 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp16_, TRUE);
#line 333 "../src/headerbar.vala"
				_tmp17_ = text_reconnecting (controller_restore_countdown);
#line 333 "../src/headerbar.vala"
				_tmp18_ = g_strdup_printf ("%i", controller_restore_countdown);
#line 333 "../src/headerbar.vala"
				_tmp19_ = _tmp18_;
#line 333 "../src/headerbar.vala"
				_tmp20_ = utils_format (_tmp17_, _tmp19_, NULL, NULL);
#line 333 "../src/headerbar.vala"
				_tmp21_ = _tmp20_;
#line 333 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp21_);
#line 333 "../src/headerbar.vala"
				_g_free0 (_tmp21_);
#line 333 "../src/headerbar.vala"
				_g_free0 (_tmp19_);
#line 334 "../src/headerbar.vala"
				break;
#line 1466 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label3) ? _tmp11_label3 : (_tmp11_label3 = g_quark_from_static_string ("Connecting")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1472 "headerbar.c"
			default:
			{
				GtkToggleButton* _tmp22_;
				GSimpleAction* _tmp23_;
				const gchar* _tmp24_;
#line 337 "../src/headerbar.vala"
				_tmp22_ = self->connect_but;
#line 337 "../src/headerbar.vala"
				gtk_toggle_button_set_active (_tmp22_, TRUE);
#line 339 "../src/headerbar.vala"
				_tmp23_ = global_actions_info;
#line 339 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp23_, TRUE);
#line 341 "../src/headerbar.vala"
				_tmp24_ = text_connecting;
#line 341 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp24_);
#line 342 "../src/headerbar.vala"
				break;
#line 1492 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label4) ? _tmp11_label4 : (_tmp11_label4 = g_quark_from_static_string ("Connected")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1498 "headerbar.c"
			default:
			{
				GtkToggleButton* _tmp25_;
				const gchar* _tmp26_;
				GtkToggleButton* _tmp27_;
				GtkToggleButton* _tmp28_;
				GtkToggleButton* _tmp29_;
				GSimpleAction* _tmp30_;
				GSimpleAction* _tmp31_;
				GSimpleAction* _tmp32_;
				GSimpleAction* _tmp33_;
				GSimpleAction* _tmp34_;
				GSimpleAction* _tmp35_;
				GtkMenuButton* _tmp36_;
				const gchar* _tmp37_;
#line 345 "../src/headerbar.vala"
				_tmp25_ = self->connect_but;
#line 345 "../src/headerbar.vala"
				_tmp26_ = text_disconnect_tip;
#line 345 "../src/headerbar.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, _tmp26_);
#line 346 "../src/headerbar.vala"
				_tmp27_ = self->connect_but;
#line 346 "../src/headerbar.vala"
				gtk_widget_set_has_tooltip ((GtkWidget*) _tmp27_, FALSE);
#line 347 "../src/headerbar.vala"
				_tmp28_ = self->connect_but;
#line 347 "../src/headerbar.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp28_, "app.disconnect");
#line 348 "../src/headerbar.vala"
				_tmp29_ = self->connect_but;
#line 348 "../src/headerbar.vala"
				gtk_toggle_button_set_active (_tmp29_, TRUE);
#line 349 "../src/headerbar.vala"
				_tmp30_ = global_actions_disconnect;
#line 349 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp30_, TRUE);
#line 351 "../src/headerbar.vala"
				_tmp31_ = global_actions_info;
#line 351 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp31_, TRUE);
#line 353 "../src/headerbar.vala"
				_tmp32_ = global_actions_join_network;
#line 353 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp32_, TRUE);
#line 354 "../src/headerbar.vala"
				_tmp33_ = global_actions_create_network;
#line 354 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp33_, TRUE);
#line 356 "../src/headerbar.vala"
				_tmp34_ = global_actions_refresh;
#line 356 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp34_, TRUE);
#line 358 "../src/headerbar.vala"
				_tmp35_ = global_actions_start_search;
#line 358 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp35_, TRUE);
#line 360 "../src/headerbar.vala"
				_tmp36_ = self->priv->network_but;
#line 360 "../src/headerbar.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp36_, TRUE);
#line 362 "../src/headerbar.vala"
				_tmp37_ = text_connected;
#line 362 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp37_);
#line 363 "../src/headerbar.vala"
				break;
#line 1566 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label5) ? _tmp11_label5 : (_tmp11_label5 = g_quark_from_static_string ("Disconnected")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1572 "headerbar.c"
			default:
			{
				GtkToggleButton* _tmp38_;
				const gchar* _tmp39_;
				GtkToggleButton* _tmp40_;
				GtkToggleButton* _tmp41_;
				GtkToggleButton* _tmp42_;
				GSimpleAction* _tmp43_;
				GSimpleAction* _tmp44_;
				const gchar* _tmp45_;
#line 366 "../src/headerbar.vala"
				_tmp38_ = self->connect_but;
#line 366 "../src/headerbar.vala"
				_tmp39_ = text_connect_tip;
#line 366 "../src/headerbar.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp38_, _tmp39_);
#line 367 "../src/headerbar.vala"
				_tmp40_ = self->connect_but;
#line 367 "../src/headerbar.vala"
				gtk_widget_set_has_tooltip ((GtkWidget*) _tmp40_, FALSE);
#line 368 "../src/headerbar.vala"
				_tmp41_ = self->connect_but;
#line 368 "../src/headerbar.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp41_, "app.connect");
#line 369 "../src/headerbar.vala"
				_tmp42_ = self->connect_but;
#line 369 "../src/headerbar.vala"
				gtk_toggle_button_set_active (_tmp42_, FALSE);
#line 370 "../src/headerbar.vala"
				_tmp43_ = global_actions_connect;
#line 370 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp43_, TRUE);
#line 372 "../src/headerbar.vala"
				_tmp44_ = global_actions_info;
#line 372 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp44_, TRUE);
#line 374 "../src/headerbar.vala"
				global_events_stop_search ();
#line 376 "../src/headerbar.vala"
				_tmp45_ = text_disconnected;
#line 376 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp45_);
#line 377 "../src/headerbar.vala"
				break;
#line 1617 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label6) ? _tmp11_label6 : (_tmp11_label6 = g_quark_from_static_string ("Not configured")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1623 "headerbar.c"
			default:
			{
				GtkToggleButton* _tmp46_;
				GSimpleAction* _tmp47_;
				const gchar* _tmp48_;
#line 380 "../src/headerbar.vala"
				_tmp46_ = self->connect_but;
#line 380 "../src/headerbar.vala"
				gtk_toggle_button_set_active (_tmp46_, FALSE);
#line 382 "../src/headerbar.vala"
				_tmp47_ = global_actions_refresh;
#line 382 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp47_, TRUE);
#line 384 "../src/headerbar.vala"
				_tmp48_ = text_disconnected;
#line 384 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp48_);
#line 385 "../src/headerbar.vala"
				break;
#line 1643 "headerbar.c"
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label7) ? _tmp11_label7 : (_tmp11_label7 = g_quark_from_static_string ("Not installed")))) {
#line 318 "../src/headerbar.vala"
		switch (0) {
#line 1649 "headerbar.c"
			default:
			{
				GtkToggleButton* _tmp49_;
				GSimpleAction* _tmp50_;
				const gchar* _tmp51_;
#line 388 "../src/headerbar.vala"
				_tmp49_ = self->connect_but;
#line 388 "../src/headerbar.vala"
				gtk_toggle_button_set_active (_tmp49_, FALSE);
#line 390 "../src/headerbar.vala"
				_tmp50_ = global_actions_refresh;
#line 390 "../src/headerbar.vala"
				g_simple_action_set_enabled (_tmp50_, TRUE);
#line 392 "../src/headerbar.vala"
				_tmp51_ = text_disconnected;
#line 392 "../src/headerbar.vala"
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp51_);
#line 393 "../src/headerbar.vala"
				break;
#line 1669 "headerbar.c"
			}
		}
	}
}

static void
headerbar_class_init (HeaderbarClass * klass,
                      gpointer klass_data)
{
#line 13 "../src/headerbar.vala"
	headerbar_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/headerbar.vala"
	g_type_class_adjust_private_offset (klass, &Headerbar_private_offset);
#line 13 "../src/headerbar.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) headerbar_real_get_preferred_width;
#line 13 "../src/headerbar.vala"
	G_OBJECT_CLASS (klass)->finalize = headerbar_finalize;
#line 1687 "headerbar.c"
}

static void
headerbar_instance_init (Headerbar * self,
                         gpointer klass)
{
#line 13 "../src/headerbar.vala"
	self->priv = headerbar_get_instance_private (self);
#line 1696 "headerbar.c"
}

static void
headerbar_finalize (GObject * obj)
{
	Headerbar * self;
#line 13 "../src/headerbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HEADERBAR, Headerbar);
#line 15 "../src/headerbar.vala"
	_g_free0 (self->priv->mode);
#line 17 "../src/headerbar.vala"
	_g_object_unref0 (self->connect_but);
#line 18 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->network_but);
#line 19 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->client_but);
#line 20 "../src/headerbar.vala"
	_g_object_unref0 (self->search_but);
#line 21 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->refresh_but);
#line 22 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->gear_but);
#line 24 "../src/headerbar.vala"
	_g_object_unref0 (self->priv->box);
#line 13 "../src/headerbar.vala"
	G_OBJECT_CLASS (headerbar_parent_class)->finalize (obj);
#line 1723 "headerbar.c"
}

static GType
headerbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeaderbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) headerbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Headerbar), 0, (GInstanceInitFunc) headerbar_instance_init, NULL };
	GType headerbar_type_id;
	headerbar_type_id = g_type_register_static (gtk_header_bar_get_type (), "Headerbar", &g_define_type_info, 0);
	Headerbar_private_offset = g_type_add_instance_private (headerbar_type_id, sizeof (HeaderbarPrivate));
	return headerbar_type_id;
}

GType
headerbar_get_type (void)
{
	static volatile gsize headerbar_type_id__once = 0;
	if (g_once_init_enter (&headerbar_type_id__once)) {
		GType headerbar_type_id;
		headerbar_type_id = headerbar_get_type_once ();
		g_once_init_leave (&headerbar_type_id__once, headerbar_type_id);
	}
	return headerbar_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

