/* member-event.c generated by valac 0.56.7, the Vala compiler
 * generated from member-event.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MEMBER_EVENT (member_event_get_type ())
#define MEMBER_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEMBER_EVENT, MemberEvent))
#define MEMBER_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEMBER_EVENT, MemberEventClass))
#define IS_MEMBER_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEMBER_EVENT))
#define IS_MEMBER_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEMBER_EVENT))
#define MEMBER_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEMBER_EVENT, MemberEventClass))

typedef struct _MemberEvent MemberEvent;
typedef struct _MemberEventClass MemberEventClass;
typedef struct _MemberEventPrivate MemberEventPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecMemberEvent ParamSpecMemberEvent;

struct _MemberEvent {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MemberEventPrivate * priv;
	gchar* client_id;
	gchar* name;
};

struct _MemberEventClass {
	GTypeClass parent_class;
	void (*finalize) (MemberEvent *self);
};

struct _MemberEventPrivate {
	gchar** network_approval_ids;
	gint network_approval_ids_length1;
	gint _network_approval_ids_size_;
	gchar** network_names;
	gint network_names_length1;
	gint _network_names_size_;
};

struct _ParamSpecMemberEvent {
	GParamSpec parent_instance;
};

static gint MemberEvent_private_offset;
static gpointer member_event_parent_class = NULL;

VALA_EXTERN gpointer member_event_ref (gpointer instance);
VALA_EXTERN void member_event_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_member_event (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_member_event (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_member_event (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_member_event (const GValue* value);
VALA_EXTERN GType member_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MemberEvent, member_event_unref)
VALA_EXTERN MemberEvent* member_event_new (const gchar* _client_id,
                               const gchar* _name);
VALA_EXTERN MemberEvent* member_event_construct (GType object_type,
                                     const gchar* _client_id,
                                     const gchar* _name);
VALA_EXTERN void member_event_add_network (MemberEvent* self,
                               const gchar* network_name);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void member_event_add_network_approval (MemberEvent* self,
                                        const gchar* network_id);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar** member_event_get_network_approval_ids (MemberEvent* self,
                                               gint* result_length1);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
VALA_EXTERN const gchar* member_event_get_first_network_name (MemberEvent* self);
VALA_EXTERN gint member_event_get_networks_length (MemberEvent* self);
static void member_event_finalize (MemberEvent * obj);
static GType member_event_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
member_event_get_instance_private (MemberEvent* self)
{
	return G_STRUCT_MEMBER_P (self, MemberEvent_private_offset);
}

MemberEvent*
member_event_construct (GType object_type,
                        const gchar* _client_id,
                        const gchar* _name)
{
	MemberEvent* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
#line 18 "../src/member-event.vala"
	g_return_val_if_fail (_client_id != NULL, NULL);
#line 18 "../src/member-event.vala"
	g_return_val_if_fail (_name != NULL, NULL);
#line 18 "../src/member-event.vala"
	self = (MemberEvent*) g_type_create_instance (object_type);
#line 20 "../src/member-event.vala"
	_tmp0_ = g_strdup (_client_id);
#line 20 "../src/member-event.vala"
	_g_free0 (self->client_id);
#line 20 "../src/member-event.vala"
	self->client_id = _tmp0_;
#line 21 "../src/member-event.vala"
	_tmp1_ = g_strdup (_name);
#line 21 "../src/member-event.vala"
	_g_free0 (self->name);
#line 21 "../src/member-event.vala"
	self->name = _tmp1_;
#line 22 "../src/member-event.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 22 "../src/member-event.vala"
	self->priv->network_approval_ids = (_vala_array_free (self->priv->network_approval_ids, self->priv->network_approval_ids_length1, (GDestroyNotify) g_free), NULL);
#line 22 "../src/member-event.vala"
	self->priv->network_approval_ids = _tmp2_;
#line 22 "../src/member-event.vala"
	self->priv->network_approval_ids_length1 = 0;
#line 22 "../src/member-event.vala"
	self->priv->_network_approval_ids_size_ = self->priv->network_approval_ids_length1;
#line 23 "../src/member-event.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 23 "../src/member-event.vala"
	self->priv->network_names = (_vala_array_free (self->priv->network_names, self->priv->network_names_length1, (GDestroyNotify) g_free), NULL);
#line 23 "../src/member-event.vala"
	self->priv->network_names = _tmp3_;
#line 23 "../src/member-event.vala"
	self->priv->network_names_length1 = 0;
#line 23 "../src/member-event.vala"
	self->priv->_network_names_size_ = self->priv->network_names_length1;
#line 18 "../src/member-event.vala"
	return self;
#line 175 "member-event.c"
}

MemberEvent*
member_event_new (const gchar* _client_id,
                  const gchar* _name)
{
#line 18 "../src/member-event.vala"
	return member_event_construct (TYPE_MEMBER_EVENT, _client_id, _name);
#line 184 "member-event.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 28 "../src/member-event.vala"
	if ((*length) == (*size)) {
#line 28 "../src/member-event.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 28 "../src/member-event.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 199 "member-event.c"
	}
#line 28 "../src/member-event.vala"
	(*array)[(*length)++] = value;
#line 28 "../src/member-event.vala"
	(*array)[*length] = NULL;
#line 205 "member-event.c"
}

void
member_event_add_network (MemberEvent* self,
                          const gchar* network_name)
{
	gchar* _tmp0_;
#line 26 "../src/member-event.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/member-event.vala"
	g_return_if_fail (network_name != NULL);
#line 28 "../src/member-event.vala"
	_tmp0_ = g_strdup (network_name);
#line 28 "../src/member-event.vala"
	_vala_array_add5 (&self->priv->network_names, &self->priv->network_names_length1, &self->priv->_network_names_size_, _tmp0_);
#line 221 "member-event.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 33 "../src/member-event.vala"
	if ((*length) == (*size)) {
#line 33 "../src/member-event.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 33 "../src/member-event.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 236 "member-event.c"
	}
#line 33 "../src/member-event.vala"
	(*array)[(*length)++] = value;
#line 33 "../src/member-event.vala"
	(*array)[*length] = NULL;
#line 242 "member-event.c"
}

void
member_event_add_network_approval (MemberEvent* self,
                                   const gchar* network_id)
{
	gchar* _tmp0_;
#line 31 "../src/member-event.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/member-event.vala"
	g_return_if_fail (network_id != NULL);
#line 33 "../src/member-event.vala"
	_tmp0_ = g_strdup (network_id);
#line 33 "../src/member-event.vala"
	_vala_array_add6 (&self->priv->network_approval_ids, &self->priv->network_approval_ids_length1, &self->priv->_network_approval_ids_size_, _tmp0_);
#line 258 "member-event.c"
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 38 "../src/member-event.vala"
	if (length >= 0) {
#line 267 "member-event.c"
		gchar** result;
		gssize i;
#line 38 "../src/member-event.vala"
		result = g_new0 (gchar*, length + 1);
#line 38 "../src/member-event.vala"
		for (i = 0; i < length; i++) {
#line 274 "member-event.c"
			gchar* _tmp0_;
#line 38 "../src/member-event.vala"
			_tmp0_ = g_strdup (self[i]);
#line 38 "../src/member-event.vala"
			result[i] = _tmp0_;
#line 280 "member-event.c"
		}
#line 38 "../src/member-event.vala"
		return result;
#line 284 "member-event.c"
	}
#line 38 "../src/member-event.vala"
	return NULL;
#line 288 "member-event.c"
}

gchar**
member_event_get_network_approval_ids (MemberEvent* self,
                                       gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result;
#line 36 "../src/member-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/member-event.vala"
	_tmp0_ = self->priv->network_approval_ids;
#line 38 "../src/member-event.vala"
	_tmp0__length1 = self->priv->network_approval_ids_length1;
#line 38 "../src/member-event.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup4 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 38 "../src/member-event.vala"
	_tmp1__length1 = _tmp0__length1;
#line 38 "../src/member-event.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/member-event.vala"
	_tmp2__length1 = _tmp1__length1;
#line 38 "../src/member-event.vala"
	if (result_length1) {
#line 38 "../src/member-event.vala"
		*result_length1 = _tmp2__length1;
#line 320 "member-event.c"
	}
#line 38 "../src/member-event.vala"
	result = _tmp2_;
#line 38 "../src/member-event.vala"
	return result;
#line 326 "member-event.c"
}

const gchar*
member_event_get_first_network_name (MemberEvent* self)
{
	const gchar* result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
#line 43 "../src/member-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/member-event.vala"
	_tmp0_ = self->priv->network_names;
#line 45 "../src/member-event.vala"
	_tmp0__length1 = self->priv->network_names_length1;
#line 45 "../src/member-event.vala"
	_tmp1_ = _tmp0_[0];
#line 45 "../src/member-event.vala"
	result = _tmp1_;
#line 45 "../src/member-event.vala"
	return result;
#line 348 "member-event.c"
}

gint
member_event_get_networks_length (MemberEvent* self)
{
	gint result;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 51 "../src/member-event.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/member-event.vala"
	_tmp0_ = self->priv->network_names;
#line 53 "../src/member-event.vala"
	_tmp0__length1 = self->priv->network_names_length1;
#line 53 "../src/member-event.vala"
	result = _tmp0__length1;
#line 53 "../src/member-event.vala"
	return result;
#line 367 "member-event.c"
}

static void
value_member_event_init (GValue* value)
{
#line 11 "../src/member-event.vala"
	value->data[0].v_pointer = NULL;
#line 375 "member-event.c"
}

static void
value_member_event_free_value (GValue* value)
{
#line 11 "../src/member-event.vala"
	if (value->data[0].v_pointer) {
#line 11 "../src/member-event.vala"
		member_event_unref (value->data[0].v_pointer);
#line 385 "member-event.c"
	}
}

static void
value_member_event_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 11 "../src/member-event.vala"
	if (src_value->data[0].v_pointer) {
#line 11 "../src/member-event.vala"
		dest_value->data[0].v_pointer = member_event_ref (src_value->data[0].v_pointer);
#line 397 "member-event.c"
	} else {
#line 11 "../src/member-event.vala"
		dest_value->data[0].v_pointer = NULL;
#line 401 "member-event.c"
	}
}

static gpointer
value_member_event_peek_pointer (const GValue* value)
{
#line 11 "../src/member-event.vala"
	return value->data[0].v_pointer;
#line 410 "member-event.c"
}

static gchar*
value_member_event_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 11 "../src/member-event.vala"
	if (collect_values[0].v_pointer) {
#line 421 "member-event.c"
		MemberEvent * object;
		object = collect_values[0].v_pointer;
#line 11 "../src/member-event.vala"
		if (object->parent_instance.g_class == NULL) {
#line 11 "../src/member-event.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 428 "member-event.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 11 "../src/member-event.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 432 "member-event.c"
		}
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = member_event_ref (object);
#line 436 "member-event.c"
	} else {
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = NULL;
#line 440 "member-event.c"
	}
#line 11 "../src/member-event.vala"
	return NULL;
#line 444 "member-event.c"
}

static gchar*
value_member_event_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	MemberEvent ** object_p;
	object_p = collect_values[0].v_pointer;
#line 11 "../src/member-event.vala"
	if (!object_p) {
#line 11 "../src/member-event.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 459 "member-event.c"
	}
#line 11 "../src/member-event.vala"
	if (!value->data[0].v_pointer) {
#line 11 "../src/member-event.vala"
		*object_p = NULL;
#line 465 "member-event.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 11 "../src/member-event.vala"
		*object_p = value->data[0].v_pointer;
#line 469 "member-event.c"
	} else {
#line 11 "../src/member-event.vala"
		*object_p = member_event_ref (value->data[0].v_pointer);
#line 473 "member-event.c"
	}
#line 11 "../src/member-event.vala"
	return NULL;
#line 477 "member-event.c"
}

GParamSpec*
param_spec_member_event (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecMemberEvent* spec;
#line 11 "../src/member-event.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEMBER_EVENT), NULL);
#line 11 "../src/member-event.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 11 "../src/member-event.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 11 "../src/member-event.vala"
	return G_PARAM_SPEC (spec);
#line 496 "member-event.c"
}

gpointer
value_get_member_event (const GValue* value)
{
#line 11 "../src/member-event.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEMBER_EVENT), NULL);
#line 11 "../src/member-event.vala"
	return value->data[0].v_pointer;
#line 506 "member-event.c"
}

void
value_set_member_event (GValue* value,
                        gpointer v_object)
{
	MemberEvent * old;
#line 11 "../src/member-event.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEMBER_EVENT));
#line 11 "../src/member-event.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/member-event.vala"
	if (v_object) {
#line 11 "../src/member-event.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEMBER_EVENT));
#line 11 "../src/member-event.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = v_object;
#line 11 "../src/member-event.vala"
		member_event_ref (value->data[0].v_pointer);
#line 528 "member-event.c"
	} else {
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = NULL;
#line 532 "member-event.c"
	}
#line 11 "../src/member-event.vala"
	if (old) {
#line 11 "../src/member-event.vala"
		member_event_unref (old);
#line 538 "member-event.c"
	}
}

void
value_take_member_event (GValue* value,
                         gpointer v_object)
{
	MemberEvent * old;
#line 11 "../src/member-event.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEMBER_EVENT));
#line 11 "../src/member-event.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/member-event.vala"
	if (v_object) {
#line 11 "../src/member-event.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEMBER_EVENT));
#line 11 "../src/member-event.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = v_object;
#line 559 "member-event.c"
	} else {
#line 11 "../src/member-event.vala"
		value->data[0].v_pointer = NULL;
#line 563 "member-event.c"
	}
#line 11 "../src/member-event.vala"
	if (old) {
#line 11 "../src/member-event.vala"
		member_event_unref (old);
#line 569 "member-event.c"
	}
}

static void
member_event_class_init (MemberEventClass * klass,
                         gpointer klass_data)
{
#line 11 "../src/member-event.vala"
	member_event_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/member-event.vala"
	((MemberEventClass *) klass)->finalize = member_event_finalize;
#line 11 "../src/member-event.vala"
	g_type_class_adjust_private_offset (klass, &MemberEvent_private_offset);
#line 583 "member-event.c"
}

static void
member_event_instance_init (MemberEvent * self,
                            gpointer klass)
{
#line 11 "../src/member-event.vala"
	self->priv = member_event_get_instance_private (self);
#line 11 "../src/member-event.vala"
	self->ref_count = 1;
#line 594 "member-event.c"
}

static void
member_event_finalize (MemberEvent * obj)
{
	MemberEvent * self;
#line 11 "../src/member-event.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEMBER_EVENT, MemberEvent);
#line 11 "../src/member-event.vala"
	g_signal_handlers_destroy (self);
#line 13 "../src/member-event.vala"
	_g_free0 (self->client_id);
#line 14 "../src/member-event.vala"
	_g_free0 (self->name);
#line 15 "../src/member-event.vala"
	self->priv->network_approval_ids = (_vala_array_free (self->priv->network_approval_ids, self->priv->network_approval_ids_length1, (GDestroyNotify) g_free), NULL);
#line 16 "../src/member-event.vala"
	self->priv->network_names = (_vala_array_free (self->priv->network_names, self->priv->network_names_length1, (GDestroyNotify) g_free), NULL);
#line 613 "member-event.c"
}

static GType
member_event_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_member_event_init, value_member_event_free_value, value_member_event_copy_value, value_member_event_peek_pointer, "p", value_member_event_collect_value, "p", value_member_event_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MemberEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) member_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MemberEvent), 0, (GInstanceInitFunc) member_event_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType member_event_type_id;
	member_event_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MemberEvent", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MemberEvent_private_offset = g_type_add_instance_private (member_event_type_id, sizeof (MemberEventPrivate));
	return member_event_type_id;
}

GType
member_event_get_type (void)
{
	static volatile gsize member_event_type_id__once = 0;
	if (g_once_init_enter (&member_event_type_id__once)) {
		GType member_event_type_id;
		member_event_type_id = member_event_get_type_once ();
		g_once_init_leave (&member_event_type_id__once, member_event_type_id);
	}
	return member_event_type_id__once;
}

gpointer
member_event_ref (gpointer instance)
{
	MemberEvent * self;
	self = instance;
#line 11 "../src/member-event.vala"
	g_atomic_int_inc (&self->ref_count);
#line 11 "../src/member-event.vala"
	return instance;
#line 649 "member-event.c"
}

void
member_event_unref (gpointer instance)
{
	MemberEvent * self;
	self = instance;
#line 11 "../src/member-event.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 11 "../src/member-event.vala"
		MEMBER_EVENT_GET_CLASS (self)->finalize (self);
#line 11 "../src/member-event.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 663 "member-event.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

