/* status.c generated by valac 0.56.7, the Vala compiler
 * generated from status.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;
typedef struct _StatusPrivate StatusPrivate;
enum  {
	STATUS_0_PROPERTY,
	STATUS_NUM_PROPERTIES
};
static GParamSpec* status_properties[STATUS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Status {
	GObject parent_instance;
	StatusPrivate * priv;
	gint status_int;
	gchar* status_text;
	gchar* status_sortable;
	gchar* message;
	gchar* connection_type;
};

struct _StatusClass {
	GObjectClass parent_class;
};

static gpointer status_parent_class = NULL;
VALA_EXTERN gchar* text_offline;
VALA_EXTERN gchar* text_online;
VALA_EXTERN gchar* text_relayed;
VALA_EXTERN gchar* text_unreachable;
VALA_EXTERN gchar* text_unapproved;
VALA_EXTERN gchar* text_error_unknown;
VALA_EXTERN gchar* text_mismatch;
VALA_EXTERN gchar* text_conflict;
VALA_EXTERN gchar* text_direct;

VALA_EXTERN GType status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
VALA_EXTERN Status* status_new (const gchar* status);
VALA_EXTERN Status* status_construct (GType object_type,
                          const gchar* status);
VALA_EXTERN void status_set_status (Status* self,
                        const gchar* status);
VALA_EXTERN Status* status_new_complete (const gchar* status,
                             const gchar* connection,
                             const gchar* _message);
VALA_EXTERN Status* status_construct_complete (GType object_type,
                                   const gchar* status,
                                   const gchar* connection,
                                   const gchar* _message);
static void status_set_connection_type (Status* self,
                                 const gchar* connection);
VALA_EXTERN gchar* status_get_icon_name (Status* self);
static void status_finalize (GObject * obj);
static GType status_get_type_once (void);

Status*
status_construct (GType object_type,
                  const gchar* status)
{
	Status * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 19 "../src/status.vala"
	g_return_val_if_fail (status != NULL, NULL);
#line 19 "../src/status.vala"
	self = (Status*) g_object_new (object_type, NULL);
#line 21 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 21 "../src/status.vala"
	_g_free0 (self->message);
#line 21 "../src/status.vala"
	self->message = _tmp0_;
#line 22 "../src/status.vala"
	_tmp1_ = g_strdup ("");
#line 22 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 22 "../src/status.vala"
	self->connection_type = _tmp1_;
#line 23 "../src/status.vala"
	status_set_status (self, status);
#line 19 "../src/status.vala"
	return self;
#line 119 "status.c"
}

Status*
status_new (const gchar* status)
{
#line 19 "../src/status.vala"
	return status_construct (TYPE_STATUS, status);
#line 127 "status.c"
}

Status*
status_construct_complete (GType object_type,
                           const gchar* status,
                           const gchar* connection,
                           const gchar* _message)
{
	Status * self = NULL;
	gchar* _tmp0_;
#line 26 "../src/status.vala"
	g_return_val_if_fail (status != NULL, NULL);
#line 26 "../src/status.vala"
	self = (Status*) g_object_new (object_type, NULL);
#line 28 "../src/status.vala"
	_tmp0_ = g_strdup (_message);
#line 28 "../src/status.vala"
	_g_free0 (self->message);
#line 28 "../src/status.vala"
	self->message = _tmp0_;
#line 29 "../src/status.vala"
	status_set_connection_type (self, connection);
#line 30 "../src/status.vala"
	status_set_status (self, status);
#line 26 "../src/status.vala"
	return self;
#line 154 "status.c"
}

Status*
status_new_complete (const gchar* status,
                     const gchar* connection,
                     const gchar* _message)
{
#line 26 "../src/status.vala"
	return status_construct_complete (TYPE_STATUS, status, connection, _message);
#line 164 "status.c"
}

void
status_set_status (Status* self,
                   const gchar* status)
{
#line 33 "../src/status.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/status.vala"
	g_return_if_fail (status != NULL);
#line 35 "../src/status.vala"
	if (g_strcmp0 (status, " ") == 0) {
#line 177 "status.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 37 "../src/status.vala"
		self->status_int = 0;
#line 38 "../src/status.vala"
		_tmp0_ = text_offline;
#line 38 "../src/status.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 38 "../src/status.vala"
		_g_free0 (self->status_text);
#line 38 "../src/status.vala"
		self->status_text = _tmp1_;
#line 39 "../src/status.vala"
		_tmp2_ = g_strdup ("f");
#line 39 "../src/status.vala"
		_g_free0 (self->status_sortable);
#line 39 "../src/status.vala"
		self->status_sortable = _tmp2_;
#line 197 "status.c"
	} else {
#line 41 "../src/status.vala"
		if (g_strcmp0 (status, "*") == 0) {
#line 201 "status.c"
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
#line 43 "../src/status.vala"
			self->status_int = 1;
#line 44 "../src/status.vala"
			_tmp3_ = text_online;
#line 44 "../src/status.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 44 "../src/status.vala"
			_g_free0 (self->status_text);
#line 44 "../src/status.vala"
			self->status_text = _tmp4_;
#line 46 "../src/status.vala"
			_tmp5_ = self->connection_type;
#line 46 "../src/status.vala"
			_tmp6_ = text_relayed;
#line 46 "../src/status.vala"
			if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
#line 222 "status.c"
				gchar* _tmp7_;
#line 48 "../src/status.vala"
				_tmp7_ = g_strdup ("b");
#line 48 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 48 "../src/status.vala"
				self->status_sortable = _tmp7_;
#line 230 "status.c"
			} else {
				gchar* _tmp8_;
#line 52 "../src/status.vala"
				_tmp8_ = g_strdup ("a");
#line 52 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 52 "../src/status.vala"
				self->status_sortable = _tmp8_;
#line 239 "status.c"
			}
		} else {
#line 55 "../src/status.vala"
			if (g_strcmp0 (status, "x") == 0) {
#line 244 "status.c"
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
#line 57 "../src/status.vala"
				self->status_int = 2;
#line 58 "../src/status.vala"
				_tmp9_ = text_unreachable;
#line 58 "../src/status.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 58 "../src/status.vala"
				_g_free0 (self->status_text);
#line 58 "../src/status.vala"
				self->status_text = _tmp10_;
#line 59 "../src/status.vala"
				_tmp11_ = g_strdup ("d");
#line 59 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 59 "../src/status.vala"
				self->status_sortable = _tmp11_;
#line 264 "status.c"
			} else {
#line 61 "../src/status.vala"
				if (g_strcmp0 (status, "?") == 0) {
#line 268 "status.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 63 "../src/status.vala"
					self->status_int = 3;
#line 64 "../src/status.vala"
					_tmp12_ = text_unapproved;
#line 64 "../src/status.vala"
					_tmp13_ = g_strdup (_tmp12_);
#line 64 "../src/status.vala"
					_g_free0 (self->status_text);
#line 64 "../src/status.vala"
					self->status_text = _tmp13_;
#line 65 "../src/status.vala"
					_tmp14_ = g_strdup ("c");
#line 65 "../src/status.vala"
					_g_free0 (self->status_sortable);
#line 65 "../src/status.vala"
					self->status_sortable = _tmp14_;
#line 288 "status.c"
				} else {
#line 67 "../src/status.vala"
					if (g_strcmp0 (status, "!") == 0) {
#line 292 "status.c"
						const gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						const gchar* _tmp18_;
#line 69 "../src/status.vala"
						self->status_int = 4;
#line 70 "../src/status.vala"
						_tmp15_ = text_error_unknown;
#line 70 "../src/status.vala"
						_tmp16_ = g_strdup (_tmp15_);
#line 70 "../src/status.vala"
						_g_free0 (self->status_text);
#line 70 "../src/status.vala"
						self->status_text = _tmp16_;
#line 71 "../src/status.vala"
						_tmp17_ = g_strdup ("e");
#line 71 "../src/status.vala"
						_g_free0 (self->status_sortable);
#line 71 "../src/status.vala"
						self->status_sortable = _tmp17_;
#line 73 "../src/status.vala"
						_tmp18_ = self->message;
#line 73 "../src/status.vala"
						if (g_strcmp0 (_tmp18_, "IP protocol mismatch between you and peer") == 0) {
#line 317 "status.c"
							const gchar* _tmp19_;
							gchar* _tmp20_;
#line 75 "../src/status.vala"
							_tmp19_ = text_mismatch;
#line 75 "../src/status.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 75 "../src/status.vala"
							_g_free0 (self->status_text);
#line 75 "../src/status.vala"
							self->status_text = _tmp20_;
#line 328 "status.c"
						} else {
							const gchar* _tmp21_;
#line 77 "../src/status.vala"
							_tmp21_ = self->message;
#line 77 "../src/status.vala"
							if (g_strcmp0 (_tmp21_, "This address is also used by another peer") == 0) {
#line 335 "status.c"
								const gchar* _tmp22_;
								gchar* _tmp23_;
#line 79 "../src/status.vala"
								_tmp22_ = text_conflict;
#line 79 "../src/status.vala"
								_tmp23_ = g_strdup (_tmp22_);
#line 79 "../src/status.vala"
								_g_free0 (self->status_text);
#line 79 "../src/status.vala"
								self->status_text = _tmp23_;
#line 346 "status.c"
							}
						}
					}
				}
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 372 "status.c"
}

static void
status_set_connection_type (Status* self,
                            const gchar* connection)
{
	gchar* _tmp0_;
#line 84 "../src/status.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 86 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 86 "../src/status.vala"
	self->connection_type = _tmp0_;
#line 88 "../src/status.vala"
	if (connection == NULL) {
#line 90 "../src/status.vala"
		return;
#line 392 "status.c"
	} else {
#line 92 "../src/status.vala"
		if (g_strcmp0 (connection, "direct") == 0) {
#line 396 "status.c"
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 94 "../src/status.vala"
			_tmp1_ = text_direct;
#line 94 "../src/status.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 94 "../src/status.vala"
			_g_free0 (self->connection_type);
#line 94 "../src/status.vala"
			self->connection_type = _tmp2_;
#line 407 "status.c"
		} else {
#line 96 "../src/status.vala"
			if (string_contains (connection, "via ")) {
#line 411 "status.c"
				const gchar* _tmp3_;
				gchar* _tmp4_;
#line 98 "../src/status.vala"
				_tmp3_ = text_relayed;
#line 98 "../src/status.vala"
				_tmp4_ = g_strdup (_tmp3_);
#line 98 "../src/status.vala"
				_g_free0 (self->connection_type);
#line 98 "../src/status.vala"
				self->connection_type = _tmp4_;
#line 422 "status.c"
			}
		}
	}
}

gchar*
status_get_icon_name (Status* self)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 102 "../src/status.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 104 "../src/status.vala"
	icon_name = _tmp0_;
#line 106 "../src/status.vala"
	if (self->status_int == 0) {
#line 442 "status.c"
		gchar* _tmp1_;
#line 108 "../src/status.vala"
		_tmp1_ = g_strdup ("network-node-offline");
#line 108 "../src/status.vala"
		_g_free0 (icon_name);
#line 108 "../src/status.vala"
		icon_name = _tmp1_;
#line 450 "status.c"
	}
#line 110 "../src/status.vala"
	if (self->status_int == 1) {
#line 454 "status.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 112 "../src/status.vala"
		_tmp2_ = self->connection_type;
#line 112 "../src/status.vala"
		_tmp3_ = text_relayed;
#line 112 "../src/status.vala"
		if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 463 "status.c"
			gchar* _tmp4_;
#line 114 "../src/status.vala"
			_tmp4_ = g_strdup ("network-node-online-relayed");
#line 114 "../src/status.vala"
			_g_free0 (icon_name);
#line 114 "../src/status.vala"
			icon_name = _tmp4_;
#line 471 "status.c"
		} else {
			gchar* _tmp5_;
#line 118 "../src/status.vala"
			_tmp5_ = g_strdup ("network-node-online");
#line 118 "../src/status.vala"
			_g_free0 (icon_name);
#line 118 "../src/status.vala"
			icon_name = _tmp5_;
#line 480 "status.c"
		}
	} else {
#line 121 "../src/status.vala"
		if (self->status_int == 2) {
#line 485 "status.c"
			gchar* _tmp6_;
#line 123 "../src/status.vala"
			_tmp6_ = g_strdup ("network-node-unreachable");
#line 123 "../src/status.vala"
			_g_free0 (icon_name);
#line 123 "../src/status.vala"
			icon_name = _tmp6_;
#line 493 "status.c"
		} else {
#line 125 "../src/status.vala"
			if (self->status_int == 3) {
#line 497 "status.c"
				gchar* _tmp7_;
#line 127 "../src/status.vala"
				_tmp7_ = g_strdup ("network-node-unapproved");
#line 127 "../src/status.vala"
				_g_free0 (icon_name);
#line 127 "../src/status.vala"
				icon_name = _tmp7_;
#line 505 "status.c"
			} else {
#line 129 "../src/status.vala"
				if (self->status_int == 4) {
#line 509 "status.c"
					gchar* _tmp8_;
#line 131 "../src/status.vala"
					_tmp8_ = g_strdup ("network-node-error");
#line 131 "../src/status.vala"
					_g_free0 (icon_name);
#line 131 "../src/status.vala"
					icon_name = _tmp8_;
#line 517 "status.c"
				}
			}
		}
	}
#line 134 "../src/status.vala"
	result = icon_name;
#line 134 "../src/status.vala"
	return result;
#line 526 "status.c"
}

static void
status_class_init (StatusClass * klass,
                   gpointer klass_data)
{
#line 11 "../src/status.vala"
	status_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/status.vala"
	G_OBJECT_CLASS (klass)->finalize = status_finalize;
#line 537 "status.c"
}

static void
status_instance_init (Status * self,
                      gpointer klass)
{
}

static void
status_finalize (GObject * obj)
{
	Status * self;
#line 11 "../src/status.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS, Status);
#line 14 "../src/status.vala"
	_g_free0 (self->status_text);
#line 15 "../src/status.vala"
	_g_free0 (self->status_sortable);
#line 16 "../src/status.vala"
	_g_free0 (self->message);
#line 17 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 11 "../src/status.vala"
	G_OBJECT_CLASS (status_parent_class)->finalize (obj);
#line 562 "status.c"
}

static GType
status_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Status), 0, (GInstanceInitFunc) status_instance_init, NULL };
	GType status_type_id;
	status_type_id = g_type_register_static (G_TYPE_OBJECT, "Status", &g_define_type_info, 0);
	return status_type_id;
}

GType
status_get_type (void)
{
	static volatile gsize status_type_id__once = 0;
	if (g_once_init_enter (&status_type_id__once)) {
		GType status_type_id;
		status_type_id = status_get_type_once ();
		g_once_init_leave (&status_type_id__once, status_type_id);
	}
	return status_type_id__once;
}

