/* utils.c generated by valac 0.56.7, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2021 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_UTILS (utils_get_type ())
#define UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UTILS, Utils))
#define UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UTILS, UtilsClass))
#define IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UTILS))
#define IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UTILS))
#define UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UTILS, UtilsClass))

typedef struct _Utils Utils;
typedef struct _UtilsClass UtilsClass;
typedef struct _UtilsPrivate UtilsPrivate;
enum  {
	UTILS_0_PROPERTY,
	UTILS_NUM_PROPERTIES
};
static GParamSpec* utils_properties[UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Utils {
	GObject parent_instance;
	UtilsPrivate * priv;
};

struct _UtilsClass {
	GObjectClass parent_class;
};

static gpointer utils_parent_class = NULL;
VALA_EXTERN gboolean haguichi_dialog_use_header_bar;
VALA_EXTERN gboolean haguichi_running_in_flatpak;

VALA_EXTERN GType utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Utils, g_object_unref)
VALA_EXTERN gchar* utils_format (gchar* text,
                     const gchar* param1,
                     const gchar* param2,
                     const gchar* param3);
VALA_EXTERN gchar* utils_remove_mnemonics (gchar* label);
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
VALA_EXTERN gchar* utils_remove_colons (gchar* label);
VALA_EXTERN gchar* utils_as_string (gchar** commands,
                        gint commands_length1);
VALA_EXTERN gchar* utils_clean_string (gchar* _string);
VALA_EXTERN gchar* utils_protocol_to_string (gint protocol);
VALA_EXTERN gint utils_protocol_to_int (const gchar* protocol);
VALA_EXTERN gchar* utils_get_message_type_icon_name (GtkMessageType message_type);
VALA_EXTERN gchar* utils_get_available_theme_icon (gchar** icon_names,
                                       gint icon_names_length1);
VALA_EXTERN GtkLabel* utils_get_label_widget (GtkContainer* container);
VALA_EXTERN void utils_set_action_area_margins (GtkContainer* action_area);
VALA_EXTERN gboolean utils_path_exists (const gchar* type,
                            const gchar* path);
VALA_EXTERN gchar* command_return_output (const gchar* command);
VALA_EXTERN Utils* utils_new (void);
VALA_EXTERN Utils* utils_construct (GType object_type);
static GType utils_get_type_once (void);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 122 "utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 126 "utils.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 132 "utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 136 "utils.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 140 "utils.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 148 "utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 176 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 185 "utils.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 199 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 208 "utils.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 222 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 231 "utils.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 240 "utils.c"
}

gchar*
utils_format (gchar* text,
              const gchar* param1,
              const gchar* param2,
              const gchar* param3)
{
	gchar* _tmp6_;
	gchar* result;
#line 15 "../src/utils.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 17 "../src/utils.vala"
	if (param1 == NULL) {
#line 255 "utils.c"
		gchar* _tmp0_;
#line 17 "../src/utils.vala"
		_tmp0_ = string_replace (text, "{0}", "");
#line 17 "../src/utils.vala"
		_g_free0 (text);
#line 17 "../src/utils.vala"
		text = _tmp0_;
#line 263 "utils.c"
	}
#line 18 "../src/utils.vala"
	if (param2 == NULL) {
#line 267 "utils.c"
		gchar* _tmp1_;
#line 18 "../src/utils.vala"
		_tmp1_ = string_replace (text, "{1}", "");
#line 18 "../src/utils.vala"
		_g_free0 (text);
#line 18 "../src/utils.vala"
		text = _tmp1_;
#line 275 "utils.c"
	}
#line 19 "../src/utils.vala"
	if (param3 == NULL) {
#line 279 "utils.c"
		gchar* _tmp2_;
#line 19 "../src/utils.vala"
		_tmp2_ = string_replace (text, "{2}", "");
#line 19 "../src/utils.vala"
		_g_free0 (text);
#line 19 "../src/utils.vala"
		text = _tmp2_;
#line 287 "utils.c"
	}
#line 21 "../src/utils.vala"
	if (param1 != NULL) {
#line 291 "utils.c"
		gchar* _tmp3_;
#line 21 "../src/utils.vala"
		_tmp3_ = string_replace (text, "{0}", param1);
#line 21 "../src/utils.vala"
		_g_free0 (text);
#line 21 "../src/utils.vala"
		text = _tmp3_;
#line 299 "utils.c"
	}
#line 22 "../src/utils.vala"
	if (param2 != NULL) {
#line 303 "utils.c"
		gchar* _tmp4_;
#line 22 "../src/utils.vala"
		_tmp4_ = string_replace (text, "{1}", param2);
#line 22 "../src/utils.vala"
		_g_free0 (text);
#line 22 "../src/utils.vala"
		text = _tmp4_;
#line 311 "utils.c"
	}
#line 23 "../src/utils.vala"
	if (param3 != NULL) {
#line 315 "utils.c"
		gchar* _tmp5_;
#line 23 "../src/utils.vala"
		_tmp5_ = string_replace (text, "{2}", param3);
#line 23 "../src/utils.vala"
		_g_free0 (text);
#line 23 "../src/utils.vala"
		text = _tmp5_;
#line 323 "utils.c"
	}
#line 25 "../src/utils.vala"
	_tmp6_ = g_strdup (text);
#line 25 "../src/utils.vala"
	result = _tmp6_;
#line 25 "../src/utils.vala"
	_g_free0 (text);
#line 25 "../src/utils.vala"
	return result;
#line 333 "utils.c"
}

gchar*
utils_remove_mnemonics (gchar* label)
{
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 28 "../src/utils.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 344 "utils.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 32 "../src/utils.vala"
		_tmp1_ = g_regex_new ("\\(_[a-zA-Z]\\)", 0, 0, &_inner_error0_);
#line 32 "../src/utils.vala"
		_tmp0_ = _tmp1_;
#line 32 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 360 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 32 "../src/utils.vala"
			_g_free0 (label);
#line 32 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 32 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 32 "../src/utils.vala"
			return NULL;
#line 371 "utils.c"
		}
#line 32 "../src/utils.vala"
		_tmp3_ = g_regex_replace (_tmp0_, label, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 32 "../src/utils.vala"
		_tmp2_ = _tmp3_;
#line 32 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/utils.vala"
			_g_regex_unref0 (_tmp0_);
#line 32 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 383 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 32 "../src/utils.vala"
			_g_free0 (label);
#line 32 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 32 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 32 "../src/utils.vala"
			return NULL;
#line 394 "utils.c"
		}
#line 32 "../src/utils.vala"
		_tmp4_ = _tmp2_;
#line 32 "../src/utils.vala"
		_tmp2_ = NULL;
#line 32 "../src/utils.vala"
		_g_free0 (label);
#line 32 "../src/utils.vala"
		label = _tmp4_;
#line 33 "../src/utils.vala"
		_tmp5_ = string_replace (label, "_", "");
#line 33 "../src/utils.vala"
		_g_free0 (label);
#line 33 "../src/utils.vala"
		label = _tmp5_;
#line 30 "../src/utils.vala"
		_g_free0 (_tmp2_);
#line 30 "../src/utils.vala"
		_g_regex_unref0 (_tmp0_);
#line 414 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 30 "../src/utils.vala"
		e = _inner_error0_;
#line 30 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 37 "../src/utils.vala"
		_tmp6_ = e;
#line 37 "../src/utils.vala"
		_tmp7_ = _tmp6_->message;
#line 37 "../src/utils.vala"
		debug_log (DEBUG_DOMAIN_ERROR, "Utils.remove_mnemonics", _tmp7_);
#line 30 "../src/utils.vala"
		_g_error_free0 (e);
#line 434 "utils.c"
	}
	__finally0:
#line 30 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30 "../src/utils.vala"
		_g_free0 (label);
#line 30 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 30 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 30 "../src/utils.vala"
		return NULL;
#line 447 "utils.c"
	}
#line 40 "../src/utils.vala"
	_tmp8_ = g_strdup (label);
#line 40 "../src/utils.vala"
	result = _tmp8_;
#line 40 "../src/utils.vala"
	_g_free0 (label);
#line 40 "../src/utils.vala"
	return result;
#line 457 "utils.c"
}

gchar*
utils_remove_colons (gchar* label)
{
	gchar* _tmp2_;
	gchar* result;
#line 45 "../src/utils.vala"
	if (label != NULL) {
#line 467 "utils.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 47 "../src/utils.vala"
		_tmp0_ = string_replace (label, " :", "");
#line 47 "../src/utils.vala"
		_g_free0 (label);
#line 47 "../src/utils.vala"
		label = _tmp0_;
#line 48 "../src/utils.vala"
		_tmp1_ = string_replace (label, ":", "");
#line 48 "../src/utils.vala"
		_g_free0 (label);
#line 48 "../src/utils.vala"
		label = _tmp1_;
#line 482 "utils.c"
	}
#line 51 "../src/utils.vala"
	_tmp2_ = g_strdup (label);
#line 51 "../src/utils.vala"
	result = _tmp2_;
#line 51 "../src/utils.vala"
	_g_free0 (label);
#line 51 "../src/utils.vala"
	return result;
#line 492 "utils.c"
}

gchar*
utils_as_string (gchar** commands,
                 gint commands_length1)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 56 "../src/utils.vala"
	_tmp0_ = g_strdup ("");
#line 56 "../src/utils.vala"
	output = _tmp0_;
#line 506 "utils.c"
	{
		gchar** c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 58 "../src/utils.vala"
		c_collection = commands;
#line 58 "../src/utils.vala"
		c_collection_length1 = commands_length1;
#line 58 "../src/utils.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 518 "utils.c"
			gchar* _tmp1_;
			gchar* c = NULL;
#line 58 "../src/utils.vala"
			_tmp1_ = g_strdup (c_collection[c_it]);
#line 58 "../src/utils.vala"
			c = _tmp1_;
#line 525 "utils.c"
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				gchar* _tmp4_;
#line 60 "../src/utils.vala"
				_tmp2_ = output;
#line 60 "../src/utils.vala"
				_tmp3_ = c;
#line 60 "../src/utils.vala"
				_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 60 "../src/utils.vala"
				_g_free0 (output);
#line 60 "../src/utils.vala"
				output = _tmp4_;
#line 58 "../src/utils.vala"
				_g_free0 (c);
#line 542 "utils.c"
			}
		}
	}
#line 63 "../src/utils.vala"
	result = output;
#line 63 "../src/utils.vala"
	return result;
#line 550 "utils.c"
}

gchar*
utils_clean_string (gchar* _string)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 66 "../src/utils.vala"
	g_return_val_if_fail (_string != NULL, NULL);
#line 68 "../src/utils.vala"
	_tmp0_ = string_replace (_string, "\\", "\\\\");
#line 68 "../src/utils.vala"
	_g_free0 (_string);
#line 68 "../src/utils.vala"
	_string = _tmp0_;
#line 69 "../src/utils.vala"
	_tmp1_ = string_replace (_string, "\"", "\\\"");
#line 69 "../src/utils.vala"
	_g_free0 (_string);
#line 69 "../src/utils.vala"
	_string = _tmp1_;
#line 71 "../src/utils.vala"
	_tmp2_ = g_strdup (_string);
#line 71 "../src/utils.vala"
	result = _tmp2_;
#line 71 "../src/utils.vala"
	_g_free0 (_string);
#line 71 "../src/utils.vala"
	return result;
#line 582 "utils.c"
}

gchar*
utils_protocol_to_string (gint protocol)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 76 "../src/utils.vala"
	_tmp0_ = g_strdup ("");
#line 76 "../src/utils.vala"
	output = _tmp0_;
#line 78 "../src/utils.vala"
	switch (protocol) {
#line 78 "../src/utils.vala"
		case 0:
#line 599 "utils.c"
		{
			gchar* _tmp1_;
#line 81 "../src/utils.vala"
			_tmp1_ = g_strdup ("both");
#line 81 "../src/utils.vala"
			_g_free0 (output);
#line 81 "../src/utils.vala"
			output = _tmp1_;
#line 82 "../src/utils.vala"
			break;
#line 610 "utils.c"
		}
#line 78 "../src/utils.vala"
		case 1:
#line 614 "utils.c"
		{
			gchar* _tmp2_;
#line 85 "../src/utils.vala"
			_tmp2_ = g_strdup ("ipv4");
#line 85 "../src/utils.vala"
			_g_free0 (output);
#line 85 "../src/utils.vala"
			output = _tmp2_;
#line 86 "../src/utils.vala"
			break;
#line 625 "utils.c"
		}
#line 78 "../src/utils.vala"
		case 2:
#line 629 "utils.c"
		{
			gchar* _tmp3_;
#line 89 "../src/utils.vala"
			_tmp3_ = g_strdup ("ipv6");
#line 89 "../src/utils.vala"
			_g_free0 (output);
#line 89 "../src/utils.vala"
			output = _tmp3_;
#line 90 "../src/utils.vala"
			break;
#line 640 "utils.c"
		}
		default:
#line 78 "../src/utils.vala"
		break;
#line 645 "utils.c"
	}
#line 93 "../src/utils.vala"
	result = output;
#line 93 "../src/utils.vala"
	return result;
#line 651 "utils.c"
}

gint
utils_protocol_to_int (const gchar* protocol)
{
	gint output = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 100 "../src/utils.vala"
	static GQuark _tmp1_label0 = 0;
#line 100 "../src/utils.vala"
	static GQuark _tmp1_label1 = 0;
#line 100 "../src/utils.vala"
	static GQuark _tmp1_label2 = 0;
#line 666 "utils.c"
	gint result;
#line 96 "../src/utils.vala"
	g_return_val_if_fail (protocol != NULL, 0);
#line 98 "../src/utils.vala"
	output = 0;
#line 100 "../src/utils.vala"
	_tmp0_ = protocol;
#line 100 "../src/utils.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 100 "../src/utils.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("both")))) {
#line 100 "../src/utils.vala"
		switch (0) {
#line 680 "utils.c"
			default:
			{
#line 103 "../src/utils.vala"
				output = 0;
#line 104 "../src/utils.vala"
				break;
#line 687 "utils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("ipv4")))) {
#line 100 "../src/utils.vala"
		switch (0) {
#line 693 "utils.c"
			default:
			{
#line 107 "../src/utils.vala"
				output = 1;
#line 108 "../src/utils.vala"
				break;
#line 700 "utils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("ipv6")))) {
#line 100 "../src/utils.vala"
		switch (0) {
#line 706 "utils.c"
			default:
			{
#line 111 "../src/utils.vala"
				output = 2;
#line 112 "../src/utils.vala"
				break;
#line 713 "utils.c"
			}
		}
	}
#line 115 "../src/utils.vala"
	result = output;
#line 115 "../src/utils.vala"
	return result;
#line 721 "utils.c"
}

gchar*
utils_get_message_type_icon_name (GtkMessageType message_type)
{
	gchar* result;
#line 120 "../src/utils.vala"
	switch (message_type) {
#line 120 "../src/utils.vala"
		case GTK_MESSAGE_WARNING:
#line 732 "utils.c"
		{
			gchar* _tmp0_;
#line 123 "../src/utils.vala"
			_tmp0_ = g_strdup ("dialog-warning");
#line 123 "../src/utils.vala"
			result = _tmp0_;
#line 123 "../src/utils.vala"
			return result;
#line 741 "utils.c"
		}
#line 120 "../src/utils.vala"
		case GTK_MESSAGE_QUESTION:
#line 745 "utils.c"
		{
			gchar* _tmp1_;
#line 126 "../src/utils.vala"
			_tmp1_ = g_strdup ("dialog-question");
#line 126 "../src/utils.vala"
			result = _tmp1_;
#line 126 "../src/utils.vala"
			return result;
#line 754 "utils.c"
		}
#line 120 "../src/utils.vala"
		case GTK_MESSAGE_ERROR:
#line 758 "utils.c"
		{
			gchar* _tmp2_;
#line 129 "../src/utils.vala"
			_tmp2_ = g_strdup ("dialog-error");
#line 129 "../src/utils.vala"
			result = _tmp2_;
#line 129 "../src/utils.vala"
			return result;
#line 767 "utils.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 132 "../src/utils.vala"
			_tmp3_ = g_strdup ("dialog-info");
#line 132 "../src/utils.vala"
			result = _tmp3_;
#line 132 "../src/utils.vala"
			return result;
#line 778 "utils.c"
		}
	}
}

gchar*
utils_get_available_theme_icon (gchar** icon_names,
                                gint icon_names_length1)
{
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	{
		gchar** icon_name_collection = NULL;
		gint icon_name_collection_length1 = 0;
		gint _icon_name_collection_size_ = 0;
		gint icon_name_it = 0;
#line 138 "../src/utils.vala"
		icon_name_collection = icon_names;
#line 138 "../src/utils.vala"
		icon_name_collection_length1 = icon_names_length1;
#line 138 "../src/utils.vala"
		for (icon_name_it = 0; icon_name_it < icon_name_collection_length1; icon_name_it = icon_name_it + 1) {
#line 801 "utils.c"
			gchar* _tmp0_;
			gchar* icon_name = NULL;
#line 138 "../src/utils.vala"
			_tmp0_ = g_strdup (icon_name_collection[icon_name_it]);
#line 138 "../src/utils.vala"
			icon_name = _tmp0_;
#line 808 "utils.c"
			{
				GtkIconTheme* _tmp1_;
				const gchar* _tmp2_;
#line 140 "../src/utils.vala"
				_tmp1_ = gtk_icon_theme_get_default ();
#line 140 "../src/utils.vala"
				_tmp2_ = icon_name;
#line 140 "../src/utils.vala"
				if (gtk_icon_theme_has_icon (_tmp1_, _tmp2_)) {
#line 142 "../src/utils.vala"
					result = icon_name;
#line 142 "../src/utils.vala"
					return result;
#line 822 "utils.c"
				}
#line 138 "../src/utils.vala"
				_g_free0 (icon_name);
#line 826 "utils.c"
			}
		}
	}
#line 146 "../src/utils.vala"
	_tmp3_ = icon_names[0];
#line 146 "../src/utils.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 146 "../src/utils.vala"
	result = _tmp4_;
#line 146 "../src/utils.vala"
	return result;
#line 838 "utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 151 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 846 "utils.c"
}

GtkLabel*
utils_get_label_widget (GtkContainer* container)
{
	GList* _tmp0_;
	GtkLabel* result;
#line 149 "../src/utils.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 151 "../src/utils.vala"
	_tmp0_ = gtk_container_get_children (container);
#line 858 "utils.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 151 "../src/utils.vala"
		child_collection = _tmp0_;
#line 151 "../src/utils.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 866 "utils.c"
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
#line 151 "../src/utils.vala"
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 151 "../src/utils.vala"
			child = _tmp1_;
#line 873 "utils.c"
			{
				GtkLabel* label = NULL;
				GtkWidget* _tmp2_;
				GtkLabel* _tmp3_;
				GtkLabel* _tmp4_;
#line 153 "../src/utils.vala"
				_tmp2_ = child;
#line 153 "../src/utils.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp2_) : NULL);
#line 153 "../src/utils.vala"
				label = _tmp3_;
#line 155 "../src/utils.vala"
				_tmp4_ = label;
#line 155 "../src/utils.vala"
				if (_tmp4_ != NULL) {
#line 157 "../src/utils.vala"
					result = label;
#line 157 "../src/utils.vala"
					_g_object_unref0 (child);
#line 157 "../src/utils.vala"
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 157 "../src/utils.vala"
					return result;
#line 897 "utils.c"
				}
#line 151 "../src/utils.vala"
				_g_object_unref0 (label);
#line 151 "../src/utils.vala"
				_g_object_unref0 (child);
#line 903 "utils.c"
			}
		}
#line 151 "../src/utils.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 908 "utils.c"
	}
#line 161 "../src/utils.vala"
	result = NULL;
#line 161 "../src/utils.vala"
	return result;
#line 914 "utils.c"
}

void
utils_set_action_area_margins (GtkContainer* action_area)
{
#line 164 "../src/utils.vala"
	g_return_if_fail (action_area != NULL);
#line 166 "../src/utils.vala"
	if (haguichi_dialog_use_header_bar == FALSE) {
#line 168 "../src/utils.vala"
		gtk_container_set_border_width (action_area, (guint) 0);
#line 172 "../src/utils.vala"
		g_object_set ((GtkWidget*) action_area, "margin", 12, NULL);
#line 174 "../src/utils.vala"
		gtk_widget_set_margin_top ((GtkWidget*) action_area, 0);
#line 930 "utils.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 950 "utils.c"
}

gboolean
utils_path_exists (const gchar* type,
                   const gchar* path)
{
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean result;
#line 178 "../src/utils.vala"
	g_return_val_if_fail (type != NULL, FALSE);
#line 178 "../src/utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 180 "../src/utils.vala"
	if (g_file_test (path, G_FILE_TEST_EXISTS)) {
#line 968 "utils.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 182 "../src/utils.vala"
		_tmp0_ = g_strconcat ("FileUtils tested true for path ", path, NULL);
#line 182 "../src/utils.vala"
		_tmp1_ = _tmp0_;
#line 182 "../src/utils.vala"
		debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Utils.path_exists", _tmp1_);
#line 182 "../src/utils.vala"
		_g_free0 (_tmp1_);
#line 183 "../src/utils.vala"
		result = TRUE;
#line 183 "../src/utils.vala"
		return result;
#line 983 "utils.c"
	}
#line 186 "../src/utils.vala"
	if (haguichi_running_in_flatpak) {
#line 987 "utils.c"
		gchar* output = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
#line 188 "../src/utils.vala"
		_tmp2_ = g_strconcat ("bash -c \"test -", type, NULL);
#line 188 "../src/utils.vala"
		_tmp3_ = _tmp2_;
#line 188 "../src/utils.vala"
		_tmp4_ = g_strconcat (_tmp3_, " ", NULL);
#line 188 "../src/utils.vala"
		_tmp5_ = _tmp4_;
#line 188 "../src/utils.vala"
		_tmp6_ = g_strconcat (_tmp5_, path, NULL);
#line 188 "../src/utils.vala"
		_tmp7_ = _tmp6_;
#line 188 "../src/utils.vala"
		_tmp8_ = g_strconcat (_tmp7_, " &>/dev/null || echo 'path not found'\"", NULL);
#line 188 "../src/utils.vala"
		_tmp9_ = _tmp8_;
#line 188 "../src/utils.vala"
		_tmp10_ = command_return_output (_tmp9_);
#line 188 "../src/utils.vala"
		_tmp11_ = _tmp10_;
#line 188 "../src/utils.vala"
		_g_free0 (_tmp9_);
#line 188 "../src/utils.vala"
		_g_free0 (_tmp7_);
#line 188 "../src/utils.vala"
		_g_free0 (_tmp5_);
#line 188 "../src/utils.vala"
		_g_free0 (_tmp3_);
#line 188 "../src/utils.vala"
		output = _tmp11_;
#line 189 "../src/utils.vala"
		_tmp12_ = g_strconcat ("Test command output for path ", path, NULL);
#line 189 "../src/utils.vala"
		_tmp13_ = _tmp12_;
#line 189 "../src/utils.vala"
		_tmp14_ = g_strconcat (_tmp13_, ": ", NULL);
#line 189 "../src/utils.vala"
		_tmp15_ = _tmp14_;
#line 189 "../src/utils.vala"
		_tmp16_ = output;
#line 189 "../src/utils.vala"
		_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 189 "../src/utils.vala"
		_tmp18_ = _tmp17_;
#line 189 "../src/utils.vala"
		debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Utils.path_exists", _tmp18_);
#line 189 "../src/utils.vala"
		_g_free0 (_tmp18_);
#line 189 "../src/utils.vala"
		_g_free0 (_tmp15_);
#line 189 "../src/utils.vala"
		_g_free0 (_tmp13_);
#line 191 "../src/utils.vala"
		_tmp19_ = output;
#line 191 "../src/utils.vala"
		if (string_contains (_tmp19_, "path not found") == FALSE) {
#line 1063 "utils.c"
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 193 "../src/utils.vala"
			_tmp20_ = g_strconcat ("Test command tested true for path ", path, NULL);
#line 193 "../src/utils.vala"
			_tmp21_ = _tmp20_;
#line 193 "../src/utils.vala"
			debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Utils.path_exists", _tmp21_);
#line 193 "../src/utils.vala"
			_g_free0 (_tmp21_);
#line 194 "../src/utils.vala"
			result = TRUE;
#line 194 "../src/utils.vala"
			_g_free0 (output);
#line 194 "../src/utils.vala"
			return result;
#line 1080 "utils.c"
		}
#line 186 "../src/utils.vala"
		_g_free0 (output);
#line 1084 "utils.c"
	}
#line 198 "../src/utils.vala"
	_tmp22_ = g_strconcat ("Path ", path, NULL);
#line 198 "../src/utils.vala"
	_tmp23_ = _tmp22_;
#line 198 "../src/utils.vala"
	_tmp24_ = g_strconcat (_tmp23_, " was not found", NULL);
#line 198 "../src/utils.vala"
	_tmp25_ = _tmp24_;
#line 198 "../src/utils.vala"
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Utils.path_exists", _tmp25_);
#line 198 "../src/utils.vala"
	_g_free0 (_tmp25_);
#line 198 "../src/utils.vala"
	_g_free0 (_tmp23_);
#line 199 "../src/utils.vala"
	result = FALSE;
#line 199 "../src/utils.vala"
	return result;
#line 1104 "utils.c"
}

Utils*
utils_construct (GType object_type)
{
	Utils * self = NULL;
#line 13 "../src/utils.vala"
	self = (Utils*) g_object_new (object_type, NULL);
#line 13 "../src/utils.vala"
	return self;
#line 1115 "utils.c"
}

Utils*
utils_new (void)
{
#line 13 "../src/utils.vala"
	return utils_construct (TYPE_UTILS);
#line 1123 "utils.c"
}

static void
utils_class_init (UtilsClass * klass,
                  gpointer klass_data)
{
#line 13 "../src/utils.vala"
	utils_parent_class = g_type_class_peek_parent (klass);
#line 1132 "utils.c"
}

static void
utils_instance_init (Utils * self,
                     gpointer klass)
{
}

static GType
utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Utils), 0, (GInstanceInitFunc) utils_instance_init, NULL };
	GType utils_type_id;
	utils_type_id = g_type_register_static (G_TYPE_OBJECT, "Utils", &g_define_type_info, 0);
	return utils_type_id;
}

GType
utils_get_type (void)
{
	static volatile gsize utils_type_id__once = 0;
	if (g_once_init_enter (&utils_type_id__once)) {
		GType utils_type_id;
		utils_type_id = utils_get_type_once ();
		g_once_init_leave (&utils_type_id__once, utils_type_id);
	}
	return utils_type_id__once;
}

