/* commands-editor-row.c generated by valac 0.56.7, the Vala compiler
 * generated from commands-editor-row.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2023 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COMMANDS_EDITOR_ROW (commands_editor_row_get_type ())
#define COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRow))
#define COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRowClass))
#define IS_COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMANDS_EDITOR_ROW))
#define IS_COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMANDS_EDITOR_ROW))
#define COMMANDS_EDITOR_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRowClass))

typedef struct _CommandsEditorRow CommandsEditorRow;
typedef struct _CommandsEditorRowClass CommandsEditorRowClass;
typedef struct _CommandsEditorRowPrivate CommandsEditorRowPrivate;

#define TYPE_COMMANDS_EDITOR (commands_editor_get_type ())
#define COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMANDS_EDITOR, CommandsEditor))
#define COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMANDS_EDITOR, CommandsEditorClass))
#define IS_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMANDS_EDITOR))
#define IS_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMANDS_EDITOR))
#define COMMANDS_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMANDS_EDITOR, CommandsEditorClass))

typedef struct _CommandsEditor CommandsEditor;
typedef struct _CommandsEditorClass CommandsEditorClass;
enum  {
	COMMANDS_EDITOR_ROW_0_PROPERTY,
	COMMANDS_EDITOR_ROW_NUM_PROPERTIES
};
static GParamSpec* commands_editor_row_properties[COMMANDS_EDITOR_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _CommandsEditorPrivate CommandsEditorPrivate;

struct _CommandsEditorRow {
	GtkListBoxRow parent_instance;
	CommandsEditorRowPrivate * priv;
	gboolean is_active;
	gboolean is_default;
	gchar* label;
	gchar* command_ipv4;
	gchar* command_ipv6;
	gchar* priority;
};

struct _CommandsEditorRowClass {
	GtkListBoxRowClass parent_class;
};

struct _CommandsEditorRowPrivate {
	CommandsEditor* editor;
	GtkLabel* title;
	GtkLabel* preview;
	GtkImage* img;
	GtkSwitch* swh;
};

struct _CommandsEditor {
	GtkBox parent_instance;
	CommandsEditorPrivate * priv;
	gchar** default_icon_names;
	gint default_icon_names_length1;
};

struct _CommandsEditorClass {
	GtkBoxClass parent_class;
};

static gint CommandsEditorRow_private_offset;
static gpointer commands_editor_row_parent_class = NULL;

VALA_EXTERN GType commands_editor_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandsEditorRow, g_object_unref)
VALA_EXTERN GType commands_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandsEditor, g_object_unref)
VALA_EXTERN CommandsEditorRow* commands_editor_row_new (CommandsEditor* _editor,
                                            gboolean _is_active,
                                            gboolean _is_default,
                                            const gchar* _label,
                                            const gchar* _command_ipv4,
                                            const gchar* _command_ipv6,
                                            const gchar* _priority);
VALA_EXTERN CommandsEditorRow* commands_editor_row_construct (GType object_type,
                                                  CommandsEditor* _editor,
                                                  gboolean _is_active,
                                                  gboolean _is_default,
                                                  const gchar* _label,
                                                  const gchar* _command_ipv4,
                                                  const gchar* _command_ipv6,
                                                  const gchar* _priority);
static gboolean __lambda61_ (CommandsEditorRow* self,
                      gboolean state);
VALA_EXTERN void commands_editor_update_commands (CommandsEditor* self);
static gboolean ___lambda61__gtk_switch_state_set (GtkSwitch* _sender,
                                            gboolean state,
                                            gpointer self);
VALA_EXTERN void commands_editor_row_update (CommandsEditorRow* self,
                                 const gchar* _label,
                                 const gchar* _command_ipv4,
                                 const gchar* _command_ipv6,
                                 const gchar* _priority);
VALA_EXTERN void commands_editor_row_set_default (CommandsEditorRow* self,
                                      gboolean _is_default);
VALA_EXTERN gchar* utils_remove_mnemonics (gchar* label);
VALA_EXTERN gchar* command_replace_variables (gchar* command,
                                  const gchar* address,
                                  const gchar* nick,
                                  const gchar* id);
VALA_EXTERN gchar* utils_get_available_theme_icon (gchar** icon_names,
                                       gint icon_names_length1);
static void commands_editor_row_finalize (GObject * obj);
static GType commands_editor_row_get_type_once (void);

static inline gpointer
commands_editor_row_get_instance_private (CommandsEditorRow* self)
{
	return G_STRUCT_MEMBER_P (self, CommandsEditorRow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/widgets/commands-editor-row.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "commands-editor-row.c"
}

static gboolean
__lambda61_ (CommandsEditorRow* self,
             gboolean state)
{
	CommandsEditor* _tmp0_;
	gboolean result;
#line 60 "../src/widgets/commands-editor-row.vala"
	self->is_active = state;
#line 61 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 61 "../src/widgets/commands-editor-row.vala"
	commands_editor_update_commands (_tmp0_);
#line 62 "../src/widgets/commands-editor-row.vala"
	result = FALSE;
#line 62 "../src/widgets/commands-editor-row.vala"
	return result;
#line 171 "commands-editor-row.c"
}

static gboolean
___lambda61__gtk_switch_state_set (GtkSwitch* _sender,
                                   gboolean state,
                                   gpointer self)
{
	gboolean result;
	result = __lambda61_ ((CommandsEditorRow*) self, state);
#line 58 "../src/widgets/commands-editor-row.vala"
	return result;
#line 183 "commands-editor-row.c"
}

CommandsEditorRow*
commands_editor_row_construct (GType object_type,
                               CommandsEditor* _editor,
                               gboolean _is_active,
                               gboolean _is_default,
                               const gchar* _label,
                               const gchar* _command_ipv4,
                               const gchar* _command_ipv6,
                               const gchar* _priority)
{
	CommandsEditorRow * self = NULL;
	CommandsEditor* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkBox* label_box = NULL;
	GtkBox* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkImage* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkSwitch* _tmp17_;
	GtkBox* box = NULL;
	GtkBox* _tmp18_;
	GtkImage* _tmp19_;
	GtkSwitch* _tmp20_;
#line 28 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_editor != NULL, NULL);
#line 28 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_label != NULL, NULL);
#line 28 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_command_ipv4 != NULL, NULL);
#line 28 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_command_ipv6 != NULL, NULL);
#line 28 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_priority != NULL, NULL);
#line 28 "../src/widgets/commands-editor-row.vala"
	self = (CommandsEditorRow*) g_object_new (object_type, NULL);
#line 30 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = _g_object_ref0 (_editor);
#line 30 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->editor);
#line 30 "../src/widgets/commands-editor-row.vala"
	self->priv->editor = _tmp0_;
#line 31 "../src/widgets/commands-editor-row.vala"
	self->is_active = _is_active;
#line 32 "../src/widgets/commands-editor-row.vala"
	self->is_default = _is_default;
#line 34 "../src/widgets/commands-editor-row.vala"
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, TRUE);
#line 35 "../src/widgets/commands-editor-row.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, TRUE);
#line 38 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 38 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp1_);
#line 38 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->title);
#line 38 "../src/widgets/commands-editor-row.vala"
	self->priv->title = _tmp1_;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = self->priv->title;
#line 39 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_ellipsize (_tmp2_, PANGO_ELLIPSIZE_END);
#line 40 "../src/widgets/commands-editor-row.vala"
	_tmp3_ = self->priv->title;
#line 40 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_xalign (_tmp3_, 0.0f);
#line 42 "../src/widgets/commands-editor-row.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 42 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp4_);
#line 42 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->preview);
#line 42 "../src/widgets/commands-editor-row.vala"
	self->priv->preview = _tmp4_;
#line 43 "../src/widgets/commands-editor-row.vala"
	_tmp5_ = self->priv->preview;
#line 43 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_ellipsize (_tmp5_, PANGO_ELLIPSIZE_END);
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp6_ = self->priv->preview;
#line 44 "../src/widgets/commands-editor-row.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, 2);
#line 45 "../src/widgets/commands-editor-row.vala"
	_tmp7_ = self->priv->preview;
#line 45 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_xalign (_tmp7_, 0.0f);
#line 46 "../src/widgets/commands-editor-row.vala"
	_tmp8_ = self->priv->preview;
#line 46 "../src/widgets/commands-editor-row.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 46 "../src/widgets/commands-editor-row.vala"
	gtk_style_context_add_class (_tmp9_, "dim-label");
#line 48 "../src/widgets/commands-editor-row.vala"
	_tmp10_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 48 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp10_);
#line 48 "../src/widgets/commands-editor-row.vala"
	label_box = _tmp10_;
#line 49 "../src/widgets/commands-editor-row.vala"
	_tmp11_ = self->priv->title;
#line 49 "../src/widgets/commands-editor-row.vala"
	gtk_box_pack_start (label_box, (GtkWidget*) _tmp11_, FALSE, FALSE, (guint) 0);
#line 50 "../src/widgets/commands-editor-row.vala"
	_tmp12_ = self->priv->preview;
#line 50 "../src/widgets/commands-editor-row.vala"
	gtk_box_pack_end (label_box, (GtkWidget*) _tmp12_, FALSE, FALSE, (guint) 0);
#line 51 "../src/widgets/commands-editor-row.vala"
	gtk_widget_set_valign ((GtkWidget*) label_box, GTK_ALIGN_CENTER);
#line 53 "../src/widgets/commands-editor-row.vala"
	_tmp13_ = (GtkImage*) gtk_image_new ();
#line 53 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp13_);
#line 53 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->img);
#line 53 "../src/widgets/commands-editor-row.vala"
	self->priv->img = _tmp13_;
#line 55 "../src/widgets/commands-editor-row.vala"
	_tmp14_ = (GtkSwitch*) gtk_switch_new ();
#line 55 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp14_);
#line 55 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->swh);
#line 55 "../src/widgets/commands-editor-row.vala"
	self->priv->swh = _tmp14_;
#line 56 "../src/widgets/commands-editor-row.vala"
	_tmp15_ = self->priv->swh;
#line 56 "../src/widgets/commands-editor-row.vala"
	gtk_switch_set_active (_tmp15_, self->is_active);
#line 57 "../src/widgets/commands-editor-row.vala"
	_tmp16_ = self->priv->swh;
#line 57 "../src/widgets/commands-editor-row.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
#line 58 "../src/widgets/commands-editor-row.vala"
	_tmp17_ = self->priv->swh;
#line 58 "../src/widgets/commands-editor-row.vala"
	g_signal_connect_object (_tmp17_, "state-set", (GCallback) ___lambda61__gtk_switch_state_set, self, 0);
#line 65 "../src/widgets/commands-editor-row.vala"
	_tmp18_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 65 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp18_);
#line 65 "../src/widgets/commands-editor-row.vala"
	box = _tmp18_;
#line 66 "../src/widgets/commands-editor-row.vala"
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 6);
#line 67 "../src/widgets/commands-editor-row.vala"
	gtk_box_pack_start (box, (GtkWidget*) label_box, FALSE, FALSE, (guint) 4);
#line 68 "../src/widgets/commands-editor-row.vala"
	_tmp19_ = self->priv->img;
#line 68 "../src/widgets/commands-editor-row.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) 8);
#line 69 "../src/widgets/commands-editor-row.vala"
	_tmp20_ = self->priv->swh;
#line 69 "../src/widgets/commands-editor-row.vala"
	gtk_box_pack_end (box, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 6);
#line 71 "../src/widgets/commands-editor-row.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
#line 74 "../src/widgets/commands-editor-row.vala"
	commands_editor_row_update (self, _label, _command_ipv4, _command_ipv6, _priority);
#line 75 "../src/widgets/commands-editor-row.vala"
	commands_editor_row_set_default (self, self->is_default);
#line 77 "../src/widgets/commands-editor-row.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 28 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (box);
#line 28 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (label_box);
#line 28 "../src/widgets/commands-editor-row.vala"
	return self;
#line 364 "commands-editor-row.c"
}

CommandsEditorRow*
commands_editor_row_new (CommandsEditor* _editor,
                         gboolean _is_active,
                         gboolean _is_default,
                         const gchar* _label,
                         const gchar* _command_ipv4,
                         const gchar* _command_ipv6,
                         const gchar* _priority)
{
#line 28 "../src/widgets/commands-editor-row.vala"
	return commands_editor_row_construct (TYPE_COMMANDS_EDITOR_ROW, _editor, _is_active, _is_default, _label, _command_ipv4, _command_ipv6, _priority);
#line 378 "commands-editor-row.c"
}

void
commands_editor_row_update (CommandsEditorRow* self,
                            const gchar* _label,
                            const gchar* _command_ipv4,
                            const gchar* _command_ipv6,
                            const gchar* _priority)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* command = NULL;
	gchar* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	gchar* address = NULL;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_label != NULL);
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_command_ipv4 != NULL);
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_command_ipv6 != NULL);
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_priority != NULL);
#line 82 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = g_strdup (_label);
#line 82 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->label);
#line 82 "../src/widgets/commands-editor-row.vala"
	self->label = _tmp0_;
#line 83 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = g_strdup (_command_ipv4);
#line 83 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv4);
#line 83 "../src/widgets/commands-editor-row.vala"
	self->command_ipv4 = _tmp1_;
#line 84 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = g_strdup (_command_ipv6);
#line 84 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv6);
#line 84 "../src/widgets/commands-editor-row.vala"
	self->command_ipv6 = _tmp2_;
#line 85 "../src/widgets/commands-editor-row.vala"
	_tmp3_ = g_strdup (_priority);
#line 85 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->priority);
#line 85 "../src/widgets/commands-editor-row.vala"
	self->priority = _tmp3_;
#line 87 "../src/widgets/commands-editor-row.vala"
	_tmp5_ = self->priority;
#line 87 "../src/widgets/commands-editor-row.vala"
	if (g_strcmp0 (_tmp5_, "IPv6") == 0) {
#line 448 "commands-editor-row.c"
		const gchar* _tmp6_;
#line 87 "../src/widgets/commands-editor-row.vala"
		_tmp6_ = self->command_ipv6;
#line 87 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = _tmp6_;
#line 454 "commands-editor-row.c"
	} else {
		const gchar* _tmp7_;
#line 87 "../src/widgets/commands-editor-row.vala"
		_tmp7_ = self->command_ipv4;
#line 87 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = _tmp7_;
#line 461 "commands-editor-row.c"
	}
#line 87 "../src/widgets/commands-editor-row.vala"
	_tmp8_ = g_strdup (_tmp4_);
#line 87 "../src/widgets/commands-editor-row.vala"
	command = _tmp8_;
#line 88 "../src/widgets/commands-editor-row.vala"
	_tmp10_ = self->priority;
#line 88 "../src/widgets/commands-editor-row.vala"
	if (g_strcmp0 (_tmp10_, "IPv6") == 0) {
#line 88 "../src/widgets/commands-editor-row.vala"
		_tmp9_ = "2620:9b::56d:f78e";
#line 473 "commands-editor-row.c"
	} else {
#line 88 "../src/widgets/commands-editor-row.vala"
		_tmp9_ = "25.123.456.78";
#line 477 "commands-editor-row.c"
	}
#line 88 "../src/widgets/commands-editor-row.vala"
	_tmp11_ = g_strdup (_tmp9_);
#line 88 "../src/widgets/commands-editor-row.vala"
	address = _tmp11_;
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp12_ = self->priv->title;
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp13_ = self->label;
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp14_ = g_strdup (_ (_tmp13_));
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp15_ = utils_remove_mnemonics (_tmp14_);
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp16_ = _tmp15_;
#line 90 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_label (_tmp12_, _tmp16_);
#line 90 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp16_);
#line 91 "../src/widgets/commands-editor-row.vala"
	_tmp17_ = self->priv->preview;
#line 91 "../src/widgets/commands-editor-row.vala"
	_tmp18_ = command;
#line 91 "../src/widgets/commands-editor-row.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 91 "../src/widgets/commands-editor-row.vala"
	_tmp20_ = command_replace_variables (_tmp19_, address, "Nick", "090-123-456");
#line 91 "../src/widgets/commands-editor-row.vala"
	_tmp21_ = _tmp20_;
#line 91 "../src/widgets/commands-editor-row.vala"
	gtk_label_set_label (_tmp17_, _tmp21_);
#line 91 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp21_);
#line 80 "../src/widgets/commands-editor-row.vala"
	_g_free0 (address);
#line 80 "../src/widgets/commands-editor-row.vala"
	_g_free0 (command);
#line 515 "commands-editor-row.c"
}

void
commands_editor_row_set_default (CommandsEditorRow* self,
                                 gboolean _is_default)
{
#line 94 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/widgets/commands-editor-row.vala"
	self->is_default = _is_default;
#line 98 "../src/widgets/commands-editor-row.vala"
	if (self->is_default) {
#line 528 "commands-editor-row.c"
		GtkImage* _tmp0_;
		CommandsEditor* _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp0_ = self->priv->img;
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp1_ = self->priv->editor;
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp2_ = _tmp1_->default_icon_names;
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp2__length1 = _tmp1_->default_icon_names_length1;
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp3_ = utils_get_available_theme_icon (_tmp2_, (gint) _tmp2__length1);
#line 100 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = _tmp3_;
#line 100 "../src/widgets/commands-editor-row.vala"
		gtk_image_set_from_icon_name (_tmp0_, _tmp4_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 100 "../src/widgets/commands-editor-row.vala"
		_g_free0 (_tmp4_);
#line 551 "commands-editor-row.c"
	} else {
		GtkImage* _tmp5_;
#line 104 "../src/widgets/commands-editor-row.vala"
		_tmp5_ = self->priv->img;
#line 104 "../src/widgets/commands-editor-row.vala"
		gtk_image_clear (_tmp5_);
#line 558 "commands-editor-row.c"
	}
}

static void
commands_editor_row_class_init (CommandsEditorRowClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/widgets/commands-editor-row.vala"
	commands_editor_row_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/widgets/commands-editor-row.vala"
	g_type_class_adjust_private_offset (klass, &CommandsEditorRow_private_offset);
#line 13 "../src/widgets/commands-editor-row.vala"
	G_OBJECT_CLASS (klass)->finalize = commands_editor_row_finalize;
#line 572 "commands-editor-row.c"
}

static void
commands_editor_row_instance_init (CommandsEditorRow * self,
                                   gpointer klass)
{
#line 13 "../src/widgets/commands-editor-row.vala"
	self->priv = commands_editor_row_get_instance_private (self);
#line 581 "commands-editor-row.c"
}

static void
commands_editor_row_finalize (GObject * obj)
{
	CommandsEditorRow * self;
#line 13 "../src/widgets/commands-editor-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRow);
#line 17 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->label);
#line 18 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv4);
#line 19 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv6);
#line 20 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->priority);
#line 22 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->editor);
#line 23 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->title);
#line 24 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->preview);
#line 25 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->img);
#line 26 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->swh);
#line 13 "../src/widgets/commands-editor-row.vala"
	G_OBJECT_CLASS (commands_editor_row_parent_class)->finalize (obj);
#line 610 "commands-editor-row.c"
}

static GType
commands_editor_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CommandsEditorRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) commands_editor_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CommandsEditorRow), 0, (GInstanceInitFunc) commands_editor_row_instance_init, NULL };
	GType commands_editor_row_type_id;
	commands_editor_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "CommandsEditorRow", &g_define_type_info, 0);
	CommandsEditorRow_private_offset = g_type_add_instance_private (commands_editor_row_type_id, sizeof (CommandsEditorRowPrivate));
	return commands_editor_row_type_id;
}

GType
commands_editor_row_get_type (void)
{
	static volatile gsize commands_editor_row_type_id__once = 0;
	if (g_once_init_enter (&commands_editor_row_type_id__once)) {
		GType commands_editor_row_type_id;
		commands_editor_row_type_id = commands_editor_row_get_type_once ();
		g_once_init_leave (&commands_editor_row_type_id__once, commands_editor_row_type_id);
	}
	return commands_editor_row_type_id__once;
}

